/**
 * 
 */
package de.desy.acop.video.analysis.decoders;

import de.desy.acop.video.analysis.ColorDecoder;

/**
 * </code>IdentitiyColorDecoder</code> performs no transformation of 
 * </code>TYPE_INT_ARGB</code> integer color code.
 * 
 * @author Tilen Kusterle, Cosylab
 *
 */
public class IdentityColorDecoder implements ColorDecoder {

	/* (non-Javadoc)
	 * @see de.desy.acop.video.analysis.ColorDecoder#transform(int)
	 */
	@Override
	@Deprecated
	public double transform(int code) {
		return code;
	}

	/*
	 * (non-Javadoc)
	 * @see de.desy.acop.video.analysis.ColorDecoder#transform(int[])
	 */
	@Override
	public double[] transform(int[] data) {
		int length = data.length;
		double[] ret = new double[length];
		for (int i = 0; i < length; i++) {
			ret[i] = data[i];
		}
		return ret;
	}
}
