/**
 * Dec 20, 2007 - Jan 18, 2008 	ws: created from AL
 * 			http://mcalaunch.desy.de/webapps/Test/common/Service/newProject.jnlp
 *	Jul 14, 2008 - Jul 17, 2008	ws: add support for Protokoll Menu
 * 	Feb  5, 2009 - Feb  5, 2009	ws:	 getLoggingJTabbedPane().dispose();
 * 	Feb 24, 2009 - Feb 24, 2009	ws:	 in initialize throw for user schuette a test exception
 * 	Feb 26, 2009 - Feb 26, 2009	ws:	 move those Exceptions to special version in MstAppTest4
 * 	Jul 14, 2009 - Jul 14, 2009	ws:	fixed some Eclipse 3.5 warnings
 */
package de.desy.mst.common.info.mstlogviewer;

import de.desy.mst.libs.framework.mstapp.Main;
import de.desy.mst.libs.framework.mstapp.MstFrameMain;
import de.desy.mst.libs.framework.mstapp.MstApp;
import de.desy.mst.libs.framework.mstapp.Screen;
import de.desy.mst.libs.framework.mstapp.logging.gui.LoggingJTabbedPane;
import de.desy.mst.libs.framework.mstapp.mode.OpModeListe;
import de.desy.mst.libs.framework.mstapp.mode.ServerAnwahlListe;
import java.awt.Dimension;

/**
 * Hauptframe um Mst Loggings und Protokolle anzusehen
 * @author ws
 * @version 1.0.0
 */
public class MstLogViewer extends MstFrameMain {
	private static final long serialVersionUID = 1L;
	//-------------------------------------------------------------------------
	public static void main(String[] args) {
		Main.startMSTApp(MstLogViewer.class.getName(), "Mst Log Viewer");
	}
//=============================================================================
	private LoggingJTabbedPane loggingJTabbedPane = null;
//=============================================================================
    @Deprecated public MstLogViewer () {
		super();
		initialize();
	}
	public MstLogViewer(MstApp mstApp) {
		super(mstApp);
		initialize();
	}
//=============================================================================
	@Override protected void afterFrameCreated() {
		final LoggingJTabbedPane pane = getLoggingJTabbedPane();
		getJMenuBar().add(pane.getJMenuLog(), userHauptMenueIndex++);
		getJMenuBar().add(pane.getJMenuCSV(), userHauptMenueIndex++);
	}
	@Override public void dispose() {
		if (loggingJTabbedPane != null)
			getLoggingJTabbedPane().dispose();
		super.dispose();
	}
//=============================================================================
	private void initialize() {
		getMstApp().setImplOpModes(OpModeListe.B__);			//nurBetrachten
		getMstApp().setImplServerAnwahlen(ServerAnwahlListe.D_);//keinTestServe
        this.setSize(new Dimension(606, 267));
        Screen.FULL_SCREEN.setBoundsOnComponent(this);
        this.setContentPane(getLoggingJTabbedPane());
	}
	private LoggingJTabbedPane getLoggingJTabbedPane() {
		if (loggingJTabbedPane == null)
			this.loggingJTabbedPane = new LoggingJTabbedPane(getMstApp());
		return loggingJTabbedPane;
	}
}  //  @jve:decl-index=0:visual-constraint="10,10"