/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package de.desy.mst.common.util.autoclient;

/**
 *
 * @author <a href="marcus(dot)walla(at)desy(dot)de">walla</a>
 */
public class ServerData {
    private final String serverName;
    private final String hostName;
    private final String binaryName;
	private final EServerType serverType;
	private final String transportCDIAddressScript;
    // ---------
    public ServerData(String serverName,String hostName,String binaryName) {
        this.serverName = serverName;
        this.hostName = hostName;
        this.binaryName = binaryName;
		this.serverType = EServerType.CDI_1;
		this.transportCDIAddressScript = "cdiget";
    }
    public ServerData(String serverName,String hostName,EServerType serverType,String binaryName) {
        this.serverName = serverName;
        this.hostName = hostName;
        this.binaryName = binaryName;
		this.serverType = serverType;
		this.transportCDIAddressScript = getTransportCDIConfigurationScript(this.serverType);
	}
    public ServerData(String serverName,String hostName,EServerType serverType,String binaryName, final String transportCDIAddressScript) {
        this.serverName = serverName;
        this.hostName = hostName;
        this.binaryName = binaryName;
		this.serverType = serverType;
		this.transportCDIAddressScript = transportCDIAddressScript;
    }
	private String getTransportCDIConfigurationScript(final EServerType serverTpe) {
		if (serverType == EServerType.CDI_1) 
			return "cdiget";
		else if (serverType == EServerType.CDI_2)
			return "cdiget2";
		else
			return "UNKNOWN";
	}
	public String getServerName() { return this.serverName; }
	public String getHostName() { return this.hostName; }
	public String getBinaryName() { return this.binaryName; }
	public EServerType getServerType() { return this.serverType; }
	public String getTransportCDIAddressScript() { return this.transportCDIAddressScript; }
	public boolean isServerType(final EServerType serverType) { return this.serverType == serverType; }
	@Override
	public boolean equals(final Object obj) {
		if (!(obj instanceof ServerData))
			return super.equals(obj);
		else
			return ((ServerData) obj).getServerName().equalsIgnoreCase(serverName);
	
	}
	@Override
	public int hashCode() {
		return super.hashCode();
	}
}

