/*
 *
 * File: IEDataRange.java
 * Date: Jan 28, 2008; 2:20:34 PM
 */
package de.desy.mst.libs.accelerator;

/**
 * This interface allows to get from a data value its minimum and maximum range
 * value for each TINE property.
 *
 * @author <a href="mailto:marcus.walla(at)desy.de">walla</a>
 * @version $Id: IEDataRange.java 12066 2008-05-29 08:35:57Z walla $
 */
public interface IEDataRange
{
	
	/**
	 * Returns the format of the minimum range value as a normal {@code float} 
	 * value.
	 * 
	 * @return The minimum range is returned as a {@code float} value.
	 */
	public abstract float minimum();

	/**
	 * Returns the format of the maximum range value as a normal {@code float} 
	 * value.
	 * 
	 * @return The maximum range is returned as a {@code float} value.
	 */
	public abstract float maximum();
}
/* end of file */