/*
 *
 * File: IEDataReadStructureType.java
 * Date: Mar 5, 2009; 3:50:12 PM
 */
package de.desy.mst.libs.accelerator;

import de.desy.tine.structUtils.TTaggedStructure;

/**
 * Each data element can hold a list of structured data objects from TINE which
 * is delivered by the method of {@link #readStructuredData()}. The returned
 * list of instances have a super class from TINE called 
 * {@code TTaggedStructure}.
 *
 * @author <a href="mailto:marcus.walla(at)desy.de">walla</a>
 * @version $Id: IEDataReadStructureType.java 23042 2009-03-19 15:52:19Z walla $
 */
public interface IEDataReadStructureType<T extends TTaggedStructure>
{
	/**
	 * Reads the structured object types which is mostly used for representing
	 * each data element with its TINE output values.
	 * 
	 * @return Returns the structured object type array.
	 */
	public abstract T[] readStructuredData();
}
/* end of file */