/*
 *
 * File: AlreadyInListException.java
 * Date: Oct 10, 2006; 2:35:18 PM
 */
package de.desy.mst.libs.accelerator.exception;

/**
 * The element already exists in the list.
 * 
 * @author <a href="marcus.walla at desy.de">walla</a>
 * @version $Id: AlreadyInListException.java 12066 2008-05-29 08:35:57Z walla $
 */
public class AlreadyInListException extends RuntimeException
{
	/** Is the serial version UID to unify this class. */
	 final static long serialVersionUID = 3640202570703451345l;
	
	/**
	 * The constructor of this exception.
	 */
	public AlreadyInListException()
	{
	}

	/**
	 * The constructor of this exception.
	 * 
	 * @param message_ Gets a message as its description.
	 */
	public AlreadyInListException(String message_)
	{
		super(message_);
	}

	/**
	 * The constructor of this exception.
	 * 
	 * @param cause_ Is the throwable cause of this exception.
	 */
	public AlreadyInListException(Throwable cause_)
	{
		super(cause_);
	}

	/**
	 * The constructor of this exception.
	 * 
	 * @param message_ Gets a message as its description.
	 * @param cause_ Is the throwable cause of this exception.
	 */
	public AlreadyInListException(String message_, Throwable cause_)
	{
		super(message_, cause_);
	}

}
/* end of file */