/*
 * Created on 	Feb  1, 2005 - Jul 01, 2005
 * 				Oct 20, 2005 - Oct 27, 2005 new logging
 *				Dec 07, 2005 - ...			added getOpMode(), getServerAnwahl()
 *				Dec 19, 2005 - Dec 22, 2005	support Maschine
 *				Jun 07, 2006 - ...			move new MaschineMgr(Maschine.getDefaultMaschine()) to startParameter
 *				Jul 18, 2006 - ...			ws: Add Typ Support, creationSuccess
 * 				Sep 12, 2006 - Sep 20, 2006	ws: use setOpMode(..., ""); aber keine direkte hardkodierte Passworteingabe
 * 				Nov  9, 2006 - Nov  9, 2006	ws: added: Support for PrefStorage
 * 				Feb  9, 2007 - Feb 13, 2007	ws: connect Preferences to System
 * 			 	Mar 9, 2007 - Mar  9, 2007	ws: added: IDeveloperFileConnection
 * Mar 19, 2007 - Mar 27, 2007	ws: implement Menu Help
 * Apr 19, 2007 - May 21, 2007, Jul 4 2007 ws:	implement PrefIniDateien
 * Aug 29, 2007 - Aug 30, 2007 	ws: String appName -> ApplicationInfo appInfo
 * Jan 15, 2007 - Jan 15, 2007	ws: geloescht: class/feld Protokolle
 * Jan 21, 2007 - Jan 21, 2007	ws: added: setServerAnwahl
 * May 29, 2008 - Jul  2, 2008	ws: add MstImage(appName, class)
 * Aug 15, 2008 - Aug 15, 2008	ws:              appName -> alName
 * Sep  1, 2008 - Sep  1, 2008	ws:	added: createParameterFileSupport(...)
 * Sep 16, 2008 - Sep 16, 2008	ws:	pp export prefs fuer OpMode und ServerAnwahl
 * Oct  7, 2008 - Oct  7, 2008	ws:	added PrefLogging support
 * Dec 10, 2008 - Dec 10, 2008	ws:	OpModeMgr default constructor (no Ref to MstSecurityMgr anymor
 * Feb 19, 2009	- Feb 19, 2009	ws:	added: PrefOpModeKonfiguration()
 * Sep  7, 2009 - Sep  7, 2009	ws:	Hilfe Preference wird registriert
 * Jun 15, 2015 - Jun 15, 2015	ws: PrefIni for reading MstWeb mit Kommentar ob erlaubt
 * Aug 15, 2016 - Aug 15, 2016	kh,ws:	logbookText added
 * Aug 19, 2016 - Aug 19, 2016	ws:	dynLogbookText vorbereitet, fuer den nichtkonstanten Fall
 */

package de.desy.mst.libs.framework.mstapp;

import java.awt.Component;
import java.awt.Frame;
import java.io.IOException;
import java.security.AccessControlException;
//import java.util.function.Supplier;//dynLogbookText

import javax.swing.AbstractButton;
import javax.swing.JComponent;
import javax.swing.JLabel;
import javax.swing.JMenu;

import de.desy.mst.libs.framework.mstapp.hilfe.HelpMgr;
import de.desy.mst.libs.framework.mstapp.ini.DeveloperFileConnectionFactory;
import de.desy.mst.libs.framework.mstapp.ini.IDeveloperFileConnection;
import de.desy.mst.libs.framework.mstapp.ini.IIniFileObserverRegistrar;
import de.desy.mst.libs.framework.mstapp.ini.IIniFileObserver_FileDataIni;
import de.desy.mst.libs.framework.mstapp.ini.LocalHome;
import de.desy.mst.libs.framework.mstapp.ini.MasterMgrForIniFiles;
import de.desy.mst.libs.framework.mstapp.ini.ParameterFileSupport;
import de.desy.mst.libs.framework.mstapp.ini.PrefCache;
import de.desy.mst.libs.framework.mstapp.ini.SystemIni;
import de.desy.mst.libs.framework.mstapp.logging.Logger;
import de.desy.mst.libs.framework.mstapp.menu.IPopupMenuMgr;
import de.desy.mst.libs.framework.mstapp.menu.PopUpMenuMgr;
import de.desy.mst.libs.framework.mstapp.mode.IOpModeObserver;
import de.desy.mst.libs.framework.mstapp.mode.IRegisterForCaption;
import de.desy.mst.libs.framework.mstapp.mode.IServerAnwahlObserver;
import de.desy.mst.libs.framework.mstapp.mode.Maschine;
import de.desy.mst.libs.framework.mstapp.mode.MaschineMgr;
import de.desy.mst.libs.framework.mstapp.mode.OpMode;
import de.desy.mst.libs.framework.mstapp.mode.OpModeListe;
import de.desy.mst.libs.framework.mstapp.mode.OpModeMgr;
import de.desy.mst.libs.framework.mstapp.mode.PrefOpModeKonfiguration;
import de.desy.mst.libs.framework.mstapp.mode.PrefOperationMode;
import de.desy.mst.libs.framework.mstapp.mode.PrefServerChoice;
import de.desy.mst.libs.framework.mstapp.mode.ServerAnwahl;
import de.desy.mst.libs.framework.mstapp.mode.ServerAnwahlListe;
import de.desy.mst.libs.framework.mstapp.mode.ServerAnwahlMgr;
import de.desy.mst.libs.framework.mstapp.preferences.IPrefManager;
import de.desy.mst.libs.framework.mstapp.preferences.IPreferences;
import de.desy.mst.libs.framework.mstapp.preferences.helper.PrefGenericParent;
import de.desy.mst.libs.framework.mstapp.preferences.implementation.PrefManager;
import de.desy.mst.libs.framework.mstapp.util.gui.MstImage;

/**
 * @author schuette
 *
 * Description: Main routine of any standard MST Application
 * 					Shows Flash Screen
 * 					Instantiatiates itself with ini-, table-data, logging....
 * 					runs the MSTFrameMain with itself in constructor
 *
 * Usage: run Main with
 * @param "Bedeutung" siehe
 * @link ParamDecoder#main
 *
 */
public class MstApp implements IMstAppKernel{
	public enum Typ {KONSOLE, SERVER, DEVICE_MANAGER;}
	private  	  Typ typ;
	private final Main theMain;
	private final ParamDecoder startParameter;
	private final MstImage mstImage;

	private MstFrameMain frameMain;	//pseudo final, is only set once and for all per mstApp
	private final OpModeMgr 		opModeMgr;
	private final ServerAnwahlMgr  	serverAnwahlMgr;
	private final MaschineMgr 		maschineMgr;
	private final IPopupMenuMgr popUpMenuMgr;
	private final IPrefManager preferencesManager;
	private final IPreferences prefOperationMode;
	private final IPreferences prefServerChoice;
	private final HelpMgr helpMgr;

    public final Ini iniFiles;
    /**Only a data class for structured access to registration of the three ini file types*/
    public final class Ini{
        public  final IIniFileObserverRegistrar user;
        public  final IIniFileObserverRegistrar application;
        private final IIniFileObserverRegistrar system;

        private Ini(final IIniFileObserverRegistrar theSystem,
                    final IIniFileObserverRegistrar theApplication,
                    final IIniFileObserverRegistrar theUser) {
            super();
            this.system = theSystem;
            this.application = theApplication;
            this.user = theUser;
        }
        /**registers fdiObserver to system, application, user in correct order (system default for application, application default for user)*/
		private void registerToAll(final IIniFileObserver_FileDataIni fdiObserver) {
			this.system.registerIniObserver(fdiObserver);
			this.application.registerIniObserver(fdiObserver);
			this.user.registerIniObserver(fdiObserver);
		}

		/**Hier wird der Anschluss an einen entwicklerspezifischen Ini File erzeugt.
		 * <br> Der rawFileName enthaelt seinen suffix z.B. "example.txt"
		 * aber nicht den Pfad
		 * <br> Read gibt den Fileinhalt als Text wieder (UTF-8 only)
		 */
		public final IDeveloperFileConnection createIniFileConnection(final String rawFileName){
			return DeveloperFileConnectionFactory.createIniFileConnection
								(MstApp.this.startParameter.applicationInfo, rawFileName);
		}

		/**Hier wird der Anschluss an eine entwicklerspezifischen Parameter Datei erzeugt.
		 * <br>Die Datei kann gelesen und geschrieben werden.
		 * <br>Es gibt einen Dialog wo ein Applikationsbenutzer (User) Parameter aendern kann.
		 * (nur .csv Dateien bis jetzt)
		 * <br> Der rawFileName enthaelt seinen suffix z.B. "example.csv"
		 * aber nicht den Pfad
		 * <br> Ort der Datei ini Teil im Web Server dieser Applikation. Voraussetzung zum
		 * schreiben eingeloggter User is berechtigt und es ist ein windows system
		 * <br> Unterschied zu createIniFileConnection: geparst + schreibbar + dialog
		 * @throws IOException
		 */
		public final ParameterFileSupport createParameterFileSupport(final Frame frame, final String rawFileName) throws IOException{
			return new ParameterFileSupport(frame, MstApp.this, rawFileName);
		}
    }

    @Deprecated public final TineAnbindung tine;
	private String creationSuccess;	//Debugging Hilfe
	private volatile String logbookText = "";	//Thread safe
	/**obiges verallgemeinern logbookText -> dynLogbookText ersetzen*/
//	private volatile Supplier<String> dynLogbookText = (() -> "");	//simple Verallgemeinerung
    public final class TineAnbindung{
    	@Deprecated public final String getDatabaseVerzeichnis()             {return MstApp.this.startParameter.getTineDBVerz();    }
    	@Deprecated public final int  getDebugLevel()                        {return MstApp.this.startParameter.getTineDebugLevel();}
    	@Deprecated public final void setDebugLevel(final int tineDebugLevel){       MstApp.this.startParameter.setTineDebugLevel(tineDebugLevel);}
    	@Deprecated public final String getNameServerAddress()               {return getSystemIni().getTine_Name_Server_Address();}
    	@Deprecated public final String getNameServerBackupAddress()         {return getSystemIni().getTine_Name_Server_Backup_Address();}
    }

//=========================   now the non static stuff   ==================

	/**
	 * @param theMain          Hauptprogramm und Herrscher ueber die Programmchoreographie
	 * @param startParameter   Hier sind die Startparameter entschluesselt und dekodiert
	 */
	public MstApp(final Main theMain, final ParamDecoder startParameter) {
		super();
		this.theMain = theMain;
		this.startParameter = startParameter;
		final String alName = startParameter.applicationInfo.getShortFrameName();
		this.mstImage = new MstImage(alName, getClass());

		this.setTyp(Typ.KONSOLE);	//Default

		this.opModeMgr = new OpModeMgr();
		this.serverAnwahlMgr = new ServerAnwahlMgr(getOpModeMgr(), getOpModeMgr().getOpModeKonfiguration());
		this.maschineMgr = startParameter.getMaschineMgr();

        final MasterMgrForIniFiles masterMgrForIniFiles = theMain.getMasterMgrForIniFiles();

        this.iniFiles = new Ini(masterMgrForIniFiles.getSystemRegistrar()
                              , masterMgrForIniFiles.getApplicationRegistrar()
                              , masterMgrForIniFiles.getUserRegistrar()
                               );
        this.iniFiles.registerToAll(this.maschineMgr);

        this.tine = new TineAnbindung();

        this.helpMgr = new HelpMgr(startParameter.applicationInfo);
        this.popUpMenuMgr = new PopUpMenuMgr();

        this.prefOperationMode  = new PrefOperationMode(getServerAnwahlMgr(), getOpModeMgr());
        this.prefServerChoice   = new PrefServerChoice(getServerAnwahlMgr());
        this.preferencesManager = createAndInitPrefManager(masterMgrForIniFiles);
 	}

	private PrefManager createAndInitPrefManager(final MasterMgrForIniFiles masterMgrForIniFiles) {
		final PrefManager pm = new PrefManager(this, masterMgrForIniFiles.getPrefStorage());

		final String title = "Speichern/Laden von Einstellungen";
		final String kommentar =
			  "Hier knnen Intialisierungen geladen oder abgespeichert werden,"
			+ " soweit das vom Programm vorgesehen ist.";
		final String komSuffix = Main.mstwebUsageSettings.isUse_mstweb4ini() 
				               ? "" : " DER WEB ZUGRIFF IST NICHT ERLAUBT FUER INI DATEIEN.";
		final IPreferences einstellungen = new PrefGenericParent(title, kommentar + komSuffix);

//		pm.register(new PrefDebugLevel(tine));
		pm.register(getPrefServerChoice());
		pm.register(getPrefOperationMode());
		pm.register(new PrefOpModeKonfiguration(getPrefOperationMode()));
        pm.register(einstellungen);

        masterMgrForIniFiles.doPrefInit(pm, einstellungen);
        pm.register(new PrefCache(pm, einstellungen));
        pm.register(getHelpMgr().getPreference());
		return pm;
	}

//=============================================================================

	@Deprecated	/**probably not even set*/
	public final MstFrameMain getFrameMain()		{return this.frameMain;}
	/* (non-Javadoc)
	 * @see de.desy.mst.libs.framework.mstapp.IMstAppKernel#getStartParameter()
	 */
	@Override public final ParamDecoder getStartParameter() 	{return this.startParameter;}
	public synchronized final Main getTheMain()		{return this.theMain;}

	/**
	 * @return Returns the Mode Manager. //never null
	 */
	public final OpModeMgr getOpModeMgr() {return this.opModeMgr;}

	/**
	 * @return the ServerAnwahlMgr
	 */
	public final ServerAnwahlMgr  getServerAnwahlMgr() {return this.serverAnwahlMgr;}

    final SystemIni getSystemIni(){ 
        final Object systemIniAsObject = this.iniFiles.system.getContentRoot();
        if(systemIniAsObject instanceof SystemIni){
            return (SystemIni) systemIniAsObject;
        }else{
            Logger.SWFW.error("Can not get valid SystemIni", new IllegalArgumentException());
            return new SystemIni();//best effort
        }
    }

	//label Text will be kept in synch with current opmode
	public final void registerForOpModesCaption(final JLabel label){
		registerForCaption(getOpModeMgr(),label);
	}
	//Button, Menu, ... -text will be kept in synch with current OpMode
	public final void registerForOpModesCaption(final AbstractButton menuItemOrButtonOrEtc){
		registerForCaption(getOpModeMgr(),menuItemOrButtonOrEtc);
	}
	public final void deregisterForOpModesCaption(final Object object){
		deregisterForCaption(getOpModeMgr(),object);
	}

	public final void registerForOpModesEnablement(final Component component, final OpModeListe enabledFallsInListe){
		getOpModeMgr().registerForEnablement(component, enabledFallsInListe);
	}
	public final void deregisterForOpModesEnablement(final Component component){
		getOpModeMgr().deregisterForEnablement(component);
	}

	public final void registerForOpModesVisibility(final Component component, final OpModeListe visibleFallsInListe){
		getOpModeMgr().registerForVisibility(component, visibleFallsInListe);
	}
	public final void deregisterForOpModesVisibility(final Component component){
		getOpModeMgr().deregisterForVisibility(component);
	}

	//label Text will be kept in synch with current ServerAnwahl
	public final void registerForServerAnwahlCaption(final JLabel label){
		registerForCaption(getServerAnwahlMgr(),label);
	}
	//Button, Menu, ... -text will be kept in synch with current ServerAnwahl
	public final void registerForServerAnwahlCaption(final AbstractButton menuItemOrButtonOrEtc){
		registerForCaption(getServerAnwahlMgr(),menuItemOrButtonOrEtc);
	}
	public final void deregisterForServerAnwahlCaption(final Object object){
		deregisterForCaption(getServerAnwahlMgr(),object);
	}

	/**
	 * Keine automatisierten Passwoertgeschuetzten Operationen.
	 * @param  opMode 					Ziel OpMode, muss gesetzt werden duerfen
	 * 									(implementiert, erfolgreicher Passwortcheck)
	 * @throws AccessControlException 	fuer passwortgeschuetzte OpModes bei falscher Legitimation
	 * @throws IllegalArgumentException opMode muss setzbar (implementiert) sein
	 */
	public final void setOpMode(final OpMode opMode) {
		this.getOpModeMgr().setOpMode(opMode, "");
	}
	/**
	 * Nur fuer spezielle Faelle. Normale Faelle lassen sich durch registrieren erschlagen.
	 * Gefaehrlich da Konsistenz an mehreren Stellen erhalten werden muss.<br>
	 * Siehe: FrameMainBeispiel07
	 *  wird 'ewig' unterstuetzt, aber gefaehrlich zu benutzen
	 */
	@Deprecated public final OpMode getOpMode(){
		return this.getOpModeMgr().getOpMode();
	}

	/**
	 * Nur fuer spezielle Faelle. Normale Faelle lassen sich durch registrieren erschlagen.
	 * Gefaehrlich da Konsistenz an mehreren Stellen erhalten werden muss.<br>
	 * Siehe: analog zu FrameMainBeispiel07 wo es mit OpMode erklaert ist
	 * wird 'ewig' unterstuetzt, aber gefaehrlich zu benutzen
	 */
	@Deprecated public final ServerAnwahl getServerAnwahl(){
		return this.getServerAnwahlMgr().getAnwahl();
	}
	/**
	 * Nur fuer spezielle Faelle. Normale Faelle lassen sich durch registrieren erschlagen.
	 * Gefaehrlich da Konsistenz an mehreren Stellen erhalten werden muss.<br>
	 * Siehe: analog zu FrameMainBeispiel07 wo es mit OpMode erklaert ist
	 * @param  anwahl					gewuenschte ServerAnwahl (!= null, muss implementiert sein)
	 * @throws IllegalArgumentException	gewuenschte ServerAnwahl ist nicht implementiert
	 * @throws NullPointerException	gewuenschte ServerAnwahl == null
	 */
	public final void setServerAnwahl(final ServerAnwahl anwahl) {
		this.getServerAnwahlMgr().setServerAnwahl(anwahl);
	}

	/* (non-Javadoc)
	 * @see de.desy.mst.libs.framework.mstapp.IMstAppKernel#getMaschineMgr()
	 */
	@Override public final MaschineMgr getMaschineMgr() {return this.maschineMgr;}
	/**@return ein Array aller definierten Maschinen*/
	public final Maschine[] getMaschinenAlle() {return getMaschineMgr().getMaschinenAlle();}
	/**Maschine dieser Applikation, nie null*/
	public final Maschine getMaschine() {return getMaschineMgr().getMaschine();}
	/**Maschine dieser Applikation @throws NullPointerException, falls maschine == null*/
	public final void setMaschine(final Maschine maschine) {getMaschineMgr().setMaschine(maschine);}
	public final boolean isValidMaschineNr(final int maschineNr){return getMaschineMgr().isValidMaschineNr(maschineNr);}
	/**@throws IndexOutOfBoundsException, if not isValidMaschineNr(maschineNr)*/
	public final Maschine getMaschineByNr(final int maschineNr){return getMaschineMgr().getMaschineByNr(maschineNr);}

//-----------------------------------------------------------------------------


	/**
	 * package private, da nur fuer MstFrameMain selbst zu benutzen
	 *
	 * @param 	jMenuOptions 			Hier werden die Untermenues drangehaengt
	 * @param 	opModeObserver 			werden bei Aenderung vom OpMode benachrichtigt
	 * @param 	anwahlObserver 			wird bei Aenderung der Serveranwahl aufgerufen
	 * @param iniExportObserver
	 * @throws	NullPointerException	theOptionMenu darf nicht null sein
	 * @throws	IllegalStateException	darf nur genau einmal aufgerufen werden
	 */
	final void initAndRegisterOptionMenu(final JMenu                   jMenuOptions,
			                             final IOpModeObserver         opModeObserver,
			                             final IServerAnwahlObserver   anwahlObserver) {
		jMenuOptions.setText("Optionen");
		this.getOpModeMgr().initAndRegisterOptionMenu(jMenuOptions, 0, opModeObserver);
		this.getServerAnwahlMgr().initAndRegisterServerAnwahlMenu(jMenuOptions, 0, anwahlObserver);
		getTheMain().getMasterMgrForIniFiles().initAndRegisterJMenuForIniFiles(jMenuOptions);
        LocalHome.initAndRegisterJMenuForAllowLocalHome(jMenuOptions);
	}

	/**
	 * package private, da nur fuer MstFrameMain selbst zu benutzen
	 * @param menuHelp Hier werden die Untermenues drangehaengt
	 */
	final void initHelpMenu(final JMenu menuHelp) {
		getHelpMgr().initHelpMenu(menuHelp, getMaschineMgr());
	}

	/**package private, to distinguish errors*/
	final void setCreationSuccess(final String creationSuccess) {
		this.creationSuccess = creationSuccess;
	}
	/**package private, to distinguish errors*/
	final String getCreationSuccess() {return this.creationSuccess;}

//=============================================================================

	private final void registerForCaption(final IRegisterForCaption forCaption, final AbstractButton menuItemOrButtonOrEtc){
		forCaption.registerForCaption(menuItemOrButtonOrEtc);
	}
	private final void registerForCaption(final IRegisterForCaption forCaption, final JLabel label){
		forCaption.registerForCaption(label);
	}
	private final void deregisterForCaption(final IRegisterForCaption forCaption, final Object object){
		forCaption.deregisterForCaption(object);
	}

	/**
	 * @param componentAndSubComponents BackGroundColor wird entsprechen der Serveranwahl gesetzt.
	 */
	public void registerForServerAnwahlBackcolor(final JComponent componentAndSubComponents) {
		final JComponent component = componentAndSubComponents;
		this.getServerAnwahlMgr().registerForServerAnwahlColor(component);
		final Component[] components = component.getComponents();
		for (int i = 0; i < components.length; i++) {
			if(components[i] instanceof JComponent){
				this.registerForServerAnwahlBackcolor((JComponent) components[i]);
			}
		}
	}
	public void deregisterForServerAnwahlBackcolor(final JComponent componentAndSubComponents) {
		final JComponent component = componentAndSubComponents;
		this.getServerAnwahlMgr().deregisterForServerAnwahlColor(component);
		final Component[] components = component.getComponents();
		for (int i = 0; i < components.length; i++) {
			if(components[i] instanceof JComponent){
				this.deregisterForServerAnwahlBackcolor((JComponent) components[i]);
			}
		}
	}

	/**
	 * @param implAnwahlen 				ServerAnwahlListe mit implementierten ServerAnwahlen,
	 * 									!= null, ServerAnwahlListe.EMPTY_LISTE
	 * @throws NullPointerException		falls implAnwahlen == null
	 * @throws IllegalArgumentException	falls implAnwahlen == ServerAnwahlListe.EMPTY_LISTE
	 */
	public void setImplServerAnwahlen(final ServerAnwahlListe implAnwahlen) {
		this.getServerAnwahlMgr().setImplAnwahlen(implAnwahlen);
	}
	/**
	 * @param opModeListe 					OpModeListe mit implementierten OpModes,
	 * 										!= null, OpModeListe
	 * @throws NullPointerException			falls opModeListe == null
	 * @throws IllegalArgumentException		falls opModeListe == EMPTY_LISTE, oder nicht Passwortfrei erreichbar
	 */
	public void setImplOpModes(final OpModeListe opModeListe) {
		this.getServerAnwahlMgr().setImplOpModes(opModeListe);
	}

	/**@return Typ (Konsole, Server, DeviceManger, ...) dieser Applikation, never null*/
	public final Typ getTyp() {return this.typ;}
	/**@throws NullPointerException, falls typ == null*/
	public final void setTyp(final Typ typ) {
		if(typ == null)	{throw new NullPointerException("Der Typ darf nicht null sein.");}
		this.typ = typ;
	}

	/* (non-Javadoc)
	 * @see de.desy.mst.libs.framework.mstapp.IMstAppKernel#getPopUpMenuMgr()
	 */
	@Override public IPopupMenuMgr getPopUpMenuMgr()		{return this.popUpMenuMgr;}
	/* (non-Javadoc)
	 * @see de.desy.mst.libs.framework.mstapp.IMstAppKernel#getHelpMgr()
	 */
	@Override public HelpMgr 		getHelpMgr() 			{return this.helpMgr;}

	public IPrefManager getPreferencesManager() {return this.preferencesManager;}
	public final MstImage getMstImage() { return this.mstImage;}
//-----------------------------------------------------------------------------
	/**pp*/ final IPreferences getPrefOperationMode() {
		return this.prefOperationMode;
	}
	/**pp*/ final IPreferences getPrefServerChoice() {
		return this.prefServerChoice;
	}
//-----------------------------------------------------------------------------
	public final void setLogbookText(final String logbookText) {
		this.logbookText = logbookText == null ? "" : logbookText;
//		this.dynLogbookText = logbookText == null ? (() -> "") : (() -> logbookText);//simple Verallgemeinerung
	}
//	public final void setLogbookText(final Supplier<String> aDynLogbookText) {
//		this.dynLogbookText = aDynLogbookText == null ? (() -> "") : aDynLogbookText;//simple Verallgemeinerung
//	}
	/**@return not null*/
	public final String getLogbookText() {
//		final String logBookText = this.dynLogbookText.get();
//		return logBookText == null ? "" : logBookText;
		return this.logbookText;
	}
}