/**
 * 
 * Last changed: $Date$
 * By: $Author$
 * URL: $HeadURL$
 * $Revision$ 
 *
 */
package de.desy.mst.libs.framework.mstapp.appinf;

import de.desy.mst.libs.framework.mstapp.logging.Logger;

/**
 * @author labudda
 * Just to implement basic functionality
 *
 */
public abstract class AApplicationInterfaceFactory implements IApplikationInterfaceFactory {
	
	protected AApplicationInterfaceFactory(){
		Logger.SWFW.debug("created information factory: " + this.getClass().getName());
	}
	/**
	 * @return True, wenn die Factory ueber eine systemproperty definiert ist
	 */
	protected boolean isFactoryPropertyAvailable() {
		return CustomSystemProperty.ApplicationKindFactory.isAvailable();
	}
	/* (non-Javadoc)
	 * @see de.desy.mst.libs.framework.mstapp.appinf.IApplikationInterfaceFactory#isValidKind()
	 */
	@Override public boolean isValidKind() {
		if (this.getClass().getName().equals(CustomSystemProperty.ApplicationKindFactory.getValue())) {
			return true;
		} else {
			return this.areKindSpecificRequirementsFulfilled();
		}
	}
	
	/**
	 * @return True, wenn alle benoetigten voraussetzungen der entsprechenden Factory vorhanden sind
	 */
	abstract protected boolean areKindSpecificRequirementsFulfilled();
}
