/**
 * 
 * Last changed: 2010-4-22
 * By: ws added @Override's
 * URL: $HeadURL$
 * $Revision$ 
 *
 */
package de.desy.mst.libs.framework.mstapp.appinf.ide;

import de.desy.mst.libs.framework.mstapp.appinf.AApplicationInterfaceFactory;
import de.desy.mst.libs.framework.mstapp.appinf.IApp;
import de.desy.mst.libs.framework.mstapp.logging.Logger;

/**
 * @author labudda
 *
 */
public class DebugFactory extends AApplicationInterfaceFactory  {
	private final static java.util.concurrent.atomic.AtomicReference<IApp> appRef = new java.util.concurrent.atomic.AtomicReference<IApp>(null);

	/* (non-Javadoc)
	 * @see de.desy.mst.libs.IApplikationInterfaceFactory#getApplicationInformation()
	 */
	@Override public IApp getApplicationInformation() throws IllegalStateException {
		Logger.SWFW.debug("Enter: IApp DebugFactory:getApplicationInformation()");
		if (this.isValidKind()) {
			synchronized (DebugFactory.class) {
				if (DebugFactory.appRef.get() == null) {
					Logger.SWFW.debug("Going to build DebugApp object");
					DebugFactory.appRef.set(new DebugApp(DebugFactory.getProjectFolder()));
				} else {
					Logger.SWFW.debug("DebugApp object already defined");
					// already done
				}
			}
			return DebugFactory.appRef.get();
		} else {
			Logger.SWFW.warn("Using DebugFactory without beeing in IDE environment");
			throw new IllegalStateException("Applikation not under construction");
		}
	}

	/* (non-Javadoc)
	 * @see de.desy.mst.libs.framework.mstapp.appinf.AApplicationInterfaceFactory#areKindSpecificRequirementsFulfilled()
	 */
	@Override protected boolean areKindSpecificRequirementsFulfilled() {
		// Nur in der IDE befinden sich Verzeichnisse (statt jar files) im classpath
		// Diese Aussage ist spaetestens seit Java 1.8 u60 nicht laenger gueltig 
		// deshalb wird die IDE ueber die Datei project.properties im Projektverzeichnis definiert
		final java.io.File  propertyFile = new java.io.File("./project.properties");
		final java.io.File  build = new java.io.File("./build.xml");
		return propertyFile.exists() && build.exists();
	}

	/**
	 * @return first elment of classpath
	 */
	private static String getProjectFolder(){
		final String classpath = System.getProperty("java.class.path").split(";")[0];
		return classpath + java.io.File.separator + "..";
	}

}
