/**
 * ws:	Mar 29, 2007 - Mar 29, 2007 creation from scratch
 * ws:	Sep 10, 2007 - Sep 10, 2007 add: getCacheDateiPfad()
 * ws:	Feb  9, 2008 - Feb  9, 2008 add: isCachable()
 * ws:	Sep 30, 2007 - Sep 30, 2007 add: getCacheRoot()
 */
package de.desy.mst.libs.framework.mstapp.hilfe;

import de.desy.mst.libs.framework.mstapp.ApplicationInfo;

/**
 * Liefert die Hilfepfade:
 *
 * @author ws
 * version 1.0.0
 */
public interface IHilfePfade {

	/** @return Pfad zur Wurzel des jeweiligen Systems */
	public abstract String getSystemRoot();


	/** @return Pfad zum Systemverzeichnis der aktuellen Applikation*/
	public abstract String getSubsystemVerzeichnis();
	/** @return Pfad zum Systemverzeichnis */
	public abstract String getSubsystemVerzeichnis
							(final String accelerator, final String subSystem);
	/** @return Pfad zum Systemverzeichnis */
	public abstract String getSubsystemVerzeichnis
										(final ApplicationInfo applicationInfo);


	/** @return Pfad bis hin zur Datei der aktuellen Applikation*/
	public abstract String getDateiPfad();
	/** @return Pfad bis hin zur Datei */
	public abstract String getDateiPfad
	   (final String accelerator, final String subSystem, final String appName);
	/** @return Pfad bis hin zur Datei */
	public abstract String getDateiPfad(final ApplicationInfo applicationInfo);

	/**kann null oder leer sein, falls nicht isCachable*/
	public String getCacheDateiPfad();
	/**
	 * @return true falls ein Cache vorgesehen/erlaubt ist
	 */
	public boolean isCachable();

	/**@return typisch: LocalHome.getHome() oder LocalHome.getHomeProtokoll()*/
	public String getCacheRoot();
}