/*
 * May 26, 2005 - Jun 16, 2005 	Created on
 * Aug 15, 2005 ... 			derive from ABaseDataOfMstIni
 * Mar 30, 2007 ...				ws: package privat -> public, for Hilfesystem
 * May 07, 2007 - ...			ws: added default XTOR  
 * Jul 04, 2007 - ...			ws: update XTor, Name		
 * Aug 29, 2007 - Sep 10, 2007 	ws: String appName -> ApplicationInfo appInfo	
 *
 */
package de.desy.mst.libs.framework.mstapp.ini;

import de.desy.mst.libs.framework.mstapp.ApplicationInfo;

/** 
 * @author ws
 * @version 1.0.0
 */
public class BaseDataForAnApplication extends ABaseDataOfMstIni {
    public static final String FILETYP = "Applications Einstellungen";
    public static final String SHORTDESCRIPTION = FILETYP;
    public static final String NAME = "Applikation";
    
    BaseDataForAnApplication(String name, ApplicationInfo appInfo){super(name, appInfo);}
    BaseDataForAnApplication(ApplicationInfo appInfo){super(NAME, appInfo);}
//    BaseDataForAnApplication() 				{this(Main.getAppName());}
//=============================================================================
    /* (non-Javadoc)
     * @see de.desy.mst.libs.framework.mstapp.ini.ABaseData#calcFileName(java.lang.String)
     */
    @Override protected String calcFileName(String appName) {
//        return LocalHome.calcLocalPath(SRV_NAME, cleanAppname(appName), FILE_SUFFIX);
    	final PfadeIni pfadeIni = createPfadeIni();
    	return pfadeIni.getCacheDateiPfad();
    }
    /* (non-Javadoc)
     * @see de.desy.mst.libs.framework.mstapp.ini.ABaseData#calcWebAddress()
     */
    @Override protected String calcWebAddress() {
    	final PfadeIni pfadeIni = createPfadeIni();
    	return pfadeIni.getDateiPfad(); 
//        return WebHome.calcWebAddress(SRV_NAME, cleanAppname(appName), FILE_SUFFIX);
    }
    /* (non-Javadoc)
     * @see de.desy.mst.libs.framework.mstapp.ini.ABaseData#calcFileTyp()
     */
    @Override protected String calcFileTyp() {return FILETYP;}
    /* (non-Javadoc)
     * @see de.desy.mst.libs.framework.mstapp.ini.ABaseData#getShortDescription()
     */
    @Override public String getShortDescription() {return SHORTDESCRIPTION;}
//=============================================================================
	private PfadeIni createPfadeIni() {
		return new PfadeIni(getApplicationInfo());
	}
}
