/**
 * Nov 7, 2006 - Nov 7, 2006	ws:	created from BaseDataForTheUser
 * Jul 04, 2007 - ...			ws: update XTor, Name
 * Aug 29, 2007 - Sep 13, 2007	ws:	String appName -> ApplicationInfo appInfo
 * Dec 10, 2008 - Dec 10, 2008	ws:	MstSecurityMgr -> MstSecurity
 */
package de.desy.mst.libs.framework.mstapp.ini;

import de.desy.mst.libs.framework.mstapp.ApplicationInfo;
import de.desy.mst.libs.framework.mstapp.security.MstSecurity;

/**
 * User Preference Files Have no Web Address
 * @author ws
 */
public class BaseDataForTheUserPreferences extends ABaseDataOfMstIni {
    public static final String FILETYP = "Benutzer Preference Einstellungen";
    public static final String SHORTDESCRIPTION = FILETYP;
    public static final String NAME = "BenutzerPref";
    /**Prefix fuer Preference User Storage*/
    private static final String PREF = "Pref_";

    BaseDataForTheUserPreferences(ApplicationInfo appInfo) {super(NAME, appInfo);}
//=============================================================================
	/* (non-Javadoc)
	 * @see de.desy.mst.libs.framework.mstapp.ini.ABaseData#calcFileName(java.lang.String)
	 */
	@Override protected String calcFileName(String appName) {
        //return LocalHome.calcLocalUserPrefPath(SRV_NAME, cleanAppname(appName), FILE_SUFFIX);
    	final PfadeIni pfadeIni = createPfadeIni();
    	return pfadeIni.getCacheDateiPfad();
	}
	/* (non-Javadoc)
	 * @see de.desy.mst.libs.framework.mstapp.ini.ABaseData#calcWebAddress(java.lang.String)
	 */
	@Override protected String calcWebAddress()		{return "";}
	/* (non-Javadoc)
	 * @see de.desy.mst.libs.framework.mstapp.ini.ABaseData#calcFileTyp()
	 */
	@Override protected String calcFileTyp()		{return FILETYP;}
	/* (non-Javadoc)
	 * @see de.desy.mst.libs.framework.mstapp.ini.ABaseData#getShortDescription()
	 */
	@Override public String getShortDescription() {return SHORTDESCRIPTION;}
//=============================================================================
	private PfadeIni createPfadeIni() {
		final String fileName = PREF + MstSecurity.get().getUser() + FILE_SUFFIX;
		return new PfadeIni(getApplicationInfo(), fileName);
	}
}
