/**
 * ws:	Mar  9, 2007 - Mar  9, 2007 creation from scratch
 * ws:	Aug  6, 2007 - Aug  6, 2007 added rawType Warning acknoledgement
 * ws:	Aug 29, 2007 - Aug 29, 2007 String appName -> ApplicationInfo appInfo
 * ws:	Aug 27, 2008 - Aug 27, 2008	added: getFullFileNameInsideWebServer
 */
package de.desy.mst.libs.framework.mstapp.ini;

import java.io.FileNotFoundException;
import java.io.IOException;
import java.net.MalformedURLException;

import de.desy.mst.libs.framework.mstapp.ApplicationInfo;

/**
 * Erzeugt Objekte vom Typ IDeveloperFileConnection.<br>
 * Implementation mit BaseDataForTheDeveloper im Augenblick
 * @author ws
 * version 1.0.0
 */
@SuppressWarnings({"rawtypes", "unchecked"})
public class DeveloperFileConnectionFactory {
	/**Hier wird der Anschluss an einen entwicklerspezifischen Ini File erzeugt.
	 * <br> der rawFileName enthaelt seinen suffix z.B. "example.txt"
	 */
	public static IDeveloperFileConnection
		createIniFileConnection(final ApplicationInfo appInfo, final String rawFileName){

		final ABaseData<? extends IIniFileRoot> bD
				= new BaseDataForTheDeveloper(appInfo, rawFileName);

		final IDeveloperFileConnection dFileConnection = new IDeveloperFileConnection(){
			@Override public String getFileTyp() 			{return bD.getFileTyp();}
			@Override public String getFullFileName() 	{return bD.getFileName();}
			@Override public String getFullWebAddress()	{return bD.getWebAddress();}
			@Override public boolean isOkForWriting() 	{return bD.isOkForWriting();}
			@Override public String getFullFileNameInsideWebServer() {
				return WebHome.calcFullFileNameInsideWebServer(getFullWebAddress());
			}

			@Override public String read() throws FileNotFoundException
			                          , MalformedURLException, IOException {
				return bD.readAsStringWithoutIOManager();
			}
			@Override public void write(final String string) throws FileNotFoundException
			                              , IOException, IllegalStateException {
				bD.writeFileAsString(string);
			}
		};

		return dFileConnection;
	}
}
