/*
 * Created on Jun 3, 2005 - Jun 3, 2005
 *	Feb 15, 2008 - Feb 15, 2008 ws: added "@Override"es
 */
package de.desy.mst.libs.framework.mstapp.ini;

/**
 * Buffers the IIniFileObserver protocoll in a transparent
 * and accessible way.
 * Created for debugging
 * @author ws
 * @version 1.0.0
 */
class IniFileObserverBuffer implements IIniFileObserver, Cloneable {
    public Object defaultIniBaumRoot = null;
    public Object iniBaumRoot = null;
    
    public boolean getDefaultIniBaumRoot_WasCalled  = false;
    public boolean onPrepareForExport_WasCalled     = false;
    public boolean onNewIniAvailable_WasCalled      = false;

//=============================================================================
    
    /* (non-Javadoc)
     * @see de.desy.mst.mstapp.ini.IIniFileObserver#getDefaultIniBaumRoot()
     */
    @Override public Object getDefaultIniBaumRoot() {
        this.getDefaultIniBaumRoot_WasCalled = true;
        return this.defaultIniBaumRoot;
    }
    /* (non-Javadoc)
     * @see de.desy.mst.mstapp.ini.IIniFileObserver#onPrepareForExport()
     */
    @Override public Object onPrepareForExport() {
        this.onPrepareForExport_WasCalled = true;
        return this.iniBaumRoot;
    }
    /* (non-Javadoc)
     * @see de.desy.mst.mstapp.ini.IIniFileObserver#onNewIniAvailable(de.desy.mst.mstapp.ini.IIniFileObserver)
     */
    @Override public void onNewIniAvailable(final Object iniBaumRoot) {
        this.onNewIniAvailable_WasCalled = true;
        this.iniBaumRoot = iniBaumRoot;
    }
    
//-----------------------------------------------------------------------------
    
    /* (non-Javadoc)
     * @see java.lang.Object#equals(java.lang.Object)
     */
    @Override public boolean equals(final Object obj) {
        if(! (obj instanceof IniFileObserverBuffer)) return false;
        final IniFileObserverBuffer rhs = (IniFileObserverBuffer) obj;
        
        return (this.defaultIniBaumRoot == rhs.defaultIniBaumRoot)
            && (this.iniBaumRoot        == rhs.iniBaumRoot);
    }
    /* (non-Javadoc)
     * @see java.lang.Object#hashCode()
     */
    @Override public int hashCode() {
        final int h1 = (this.iniBaumRoot == null) ? 13 : this.iniBaumRoot.hashCode();
        final int h2 = (this.defaultIniBaumRoot == null) ? 129 : this.defaultIniBaumRoot.hashCode();
        return h1 + h2;
    }
    /* (non-Javadoc)
     * @see java.lang.Object#clone()
     */
    public IniFileObserverBuffer copy()   {
        try {return (IniFileObserverBuffer) super.clone();}
        catch (final CloneNotSupportedException ex) {return null;}
    }
} 
