/**
 * Sep 1, 2008 - Sep 1, 2008	ws:	Creation from scratch
 * Jan 6, 2009 - Jan 6, 2009	ws: center dialog in showDialog()
 *	Jan 15, 2008 - Jan 15, 2008	ws:	serializable
 */
package de.desy.mst.libs.framework.mstapp.ini;

import java.awt.Frame;
import java.io.File;
import java.io.IOException;
import java.io.Serializable;

import de.desy.mst.libs.framework.mstapp.Main;
import de.desy.mst.libs.framework.mstapp.MstApp;
import de.desy.mst.libs.framework.mstapp.logging.gui.ViewerDialog;

/**
 * Managed eine Parameter Datei (open, save, getTable)
 * @author ws
 * @version 1.0.0
 */
public class ParameterFileSupport implements Serializable{
	private static final long serialVersionUID = 1L;

	private final Frame frame;
	private final MstApp mstApp;
	private final File file;
	private final ITabelle logSource;	//beachte dies ist eine echte LogSource!
//=============================================================================
	public ParameterFileSupport(final Frame frame, final MstApp mstApp, String rawFileName) throws IOException {
		this.frame  = frame;
		this.mstApp = mstApp;
		this.file   = createFileObject(mstApp, rawFileName);
		this.logSource = ViewerDialog.createLogSource(getFile());
	}
//=============================================================================
	/**@return Liefert die der Datei zugrunde liegende DatenTabelle*/
	public ITabelle getTabelle() {return this.logSource;}

	/**&return 	einen Dialog, der dem Applikationsnutzer (user) erlaubt
	 * 			Parameter anzusehen, zu editieren, zu speichern */
	public final void showDialog() {
		final ViewerDialog dialog = ViewerDialog.createLogSourceDialog(getFrame(), getMstApp(), getTabelle(), getFile().getName());
		dialog.setVisible(true);
		Main.centerToMstFrameMain(dialog);
	}

	/**@return Ziel Parameter File*/
	public final File    getFile()   {return this.file;}
//=============================================================================
	private final Frame  getFrame () {return this.frame;}
	private final MstApp getMstApp() {return this.mstApp;}

	private File createFileObject(final MstApp mstApp, final String rawFileName) {
		final IDeveloperFileConnection fileCon =
			mstApp.iniFiles.createIniFileConnection(rawFileName);
		final String fullFileName = fileCon.getFullFileNameInsideWebServer();
		return new File(fullFileName);
	}
}
