/**
 * ws:	Aug 28, 2007 - Sep  4, 2007 creation from scratch
 * Aug 15, 2008 - Aug 15, 2008	ws: getAppOrALName() impl
 * Sep  3, 2008 - Sep  3, 2008	ws: ROOT public
 */
package de.desy.mst.libs.framework.mstapp.ini;

import de.desy.mst.libs.framework.mstapp.ApplicationInfo;
import de.desy.mst.libs.framework.mstapp.hilfe.AHilfePfadeAL;

/**
 * Hierarische IniDateien
 * @author ws
 * @version 1.0.0
 */
public class PfadeIni extends AHilfePfadeAL{
//http://mstweb.desy.de/Ini/libs/framework/~~testAppMitAppIniOnWeb/~~testAppMitAppIniOnWeb.xml
	public static final String ROOT = WebHome.getHttp_Base_Address()
									+ ABaseData.SRV_NAME
									+ "/";
//=============================================================================
	final private String fileName;
//=============================================================================
	public PfadeIni(final ApplicationInfo applicationInfo) {
		this(applicationInfo, applicationInfo.getAppName());
	}
	/**not Null, fileName inclusive Suffix und evtl. spezifischer ParentDirs*/
	public PfadeIni(final ApplicationInfo applicationInfo, final String fileName) {
		super(applicationInfo);
		this.fileName = decorateFileName(fileName);	//Inis innerhalp AppVerz
	}
//=============================================================================
	/* (non-Javadoc)
	 * @see de.desy.mst.libs.framework.mstapp.hilfe.AHilfePfadeAL#getDateiName(java.lang.String)
	 */
	@Override public String getDateiName(final String appName) {return this.fileName;}

	/* (non-Javadoc)
	 * @see de.desy.mst.libs.framework.mstapp.hilfe.AHilfePfadeAL#getSubSystemRoot()
	 */
	@Override public String getSubSystemRoot() {return getSystemRoot();}

	/* (non-Javadoc)
	 * @see de.desy.mst.libs.framework.mstapp.hilfe.AHilfePfade#getAppOrALName(de.desy.mst.libs.framework.mstapp.ApplicationInfo)
	 */
	@Override public String getAppOrALName(final ApplicationInfo applicationInfo) {
		return applicationInfo.getAppName();
	}

//-----------------------------------------------------------------------------
	/* (non-Javadoc)
	 * @see de.desy.mst.libs.framework.mstapp.hilfe.IHilfePfade#getSystemRoot()
	 */
	@Override public String getSystemRoot()  {return ROOT;}

//-----------------------------------------------------------------------------

	private String decorateFileName(final String fileName) {
		final String appName = getApplicationInfo().getAppName();
		final String bare = cleanName(appName) + SEP + cleanName(fileName);
		return (fileName.contains("."))
				?
				bare							//hat schon suffix
				:
				(bare + ABaseData.FILE_SUFFIX);	//braucht suffix wie ".xml"
	}
}
