/**
 *	Aug 11, 2008 - Aug 11, 2008	ws:	Creation from scratch
 *	Jul 28, 2009 - Jul 28, 2009	ws:	added: getAutoAppendServer() etc.
 */
package de.desy.mst.libs.framework.mstapp.logging.gui;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import de.desy.mst.libs.framework.mstapp.ini.TextInputStreamUtility;

/**
 * Helfer fuer Datei Basierte Zugriffe
 * @author ws
 * @version 1.0.0
 */
abstract class ALogSource_File<L, M extends AMsgModel<L>> extends ALogSource<L, M> {
	static String[] calcInputLines(File file) throws FileNotFoundException, IOException {
		final FileInputStream fis = new FileInputStream(file);
		final TextInputStreamUtility tisu = new TextInputStreamUtility(fis);
		final String contentsAsString = tisu.getContentsAsString();
		final String[] inputLines = contentsAsString.split("\n");
		return inputLines;
	}
//=============================================================================
	private final File file;
//-----------------------------------------------------------------------------
	ALogSource_File(final M logMsgModel, final File file) {
		super(logMsgModel, null);
		this.file = file;
	}
//-----------------------------------------------------------------------------
	public File getFile() {return this.file;}
	@Override public File getDefaultFile() {return getFile();}
}

