/**
 *  Created on  Aug 21, 2006
 */
package de.desy.mst.libs.framework.mstapp.logging.gui;

import java.awt.GridBagLayout;
import javax.swing.JPanel;

import de.desy.mst.libs.framework.mstapp.logging.LogLvl;
import de.desy.mst.libs.framework.mstapp.logging.LogMsg;
import de.desy.mst.libs.framework.mstapp.logging.Logger;
import javax.swing.JLabel;
import java.awt.GridBagConstraints;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;

/**
 * Ein Panel, dass eine LogMsg im Detail anzeigt
 * @author ws
 *
 */
class JPanel_LogMsg_MitLabels extends JPanel {
	private static final long serialVersionUID = 1L;
	
	private LogMsg msg;  //  @jve:decl-index=0:
	private JLabel jLabelNr = null;
	private JLabel jLabelLogLvl = null;
	private JLabel jLabelDate = null;
	private JLabel jLabelApplication = null;
	private JLabel jLabelPCName = null;
	private JLabel jLabelKategorie = null;
	private JLabel jLabelUUId = null;
	private JScrollPane jScrollPaneMessage = null;
	private JScrollPane jScrollPaneFehler = null;
	private JTextArea jTextAreaMessage = null;
	private JTextArea jTextAreaFehler = null;
	/**
	 * This is the default constructor
	 */
	public JPanel_LogMsg_MitLabels() {
		super();
		initialize();
		this.setMsg(this.createEmptyMessage());
	}
	
//=============================================================================	

	/**never null*/
	public final LogMsg getMsg()			{return (this.msg == null) ?(this.createEmptyMessage()) : (this.msg);}
	public final void   setMsg(final LogMsg msg)	{this.msg = msg; this.displayMsg();}
	
//=============================================================================	

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		final GridBagConstraints gridBagConstraints8 = new GridBagConstraints();
		gridBagConstraints8.fill = GridBagConstraints.NONE;
		gridBagConstraints8.gridy = 4;
		gridBagConstraints8.weighty = 1.0;
		gridBagConstraints8.gridx = 0;
		gridBagConstraints8.gridwidth = 4;
		final GridBagConstraints gridBagConstraints7 = new GridBagConstraints();
		gridBagConstraints7.fill = GridBagConstraints.NONE;
		gridBagConstraints7.gridy = 3;
		gridBagConstraints7.weighty = 1.0;
		gridBagConstraints7.gridx = 0;
		gridBagConstraints7.gridwidth = 4;
		final GridBagConstraints gridBagConstraints6 = new GridBagConstraints();
		gridBagConstraints6.gridx = 3;
		gridBagConstraints6.gridy = 2;
		this.jLabelUUId = new JLabel();
		this.jLabelUUId.setText("UUId");
		final GridBagConstraints gridBagConstraints5 = new GridBagConstraints();
		gridBagConstraints5.gridx = 2;
		gridBagConstraints5.gridy = 2;
		this.jLabelKategorie = new JLabel();
		this.jLabelKategorie.setText("Kategorie");
		final GridBagConstraints gridBagConstraints4 = new GridBagConstraints();
		gridBagConstraints4.gridx = 1;
		gridBagConstraints4.gridy = 2;
		this.jLabelPCName = new JLabel();
		this.jLabelPCName.setText("PCName");
		final GridBagConstraints gridBagConstraints3 = new GridBagConstraints();
		gridBagConstraints3.gridx = 0;
		gridBagConstraints3.gridy = 2;
		this.jLabelApplication = new JLabel();
		this.jLabelApplication.setText("Application");
		final GridBagConstraints gridBagConstraints2 = new GridBagConstraints();
		gridBagConstraints2.gridx = 2;
		gridBagConstraints2.gridy = 1;
		this.jLabelDate = new JLabel();
		this.jLabelDate.setText("Date");
		final GridBagConstraints gridBagConstraints1 = new GridBagConstraints();
		gridBagConstraints1.gridx = 1;
		gridBagConstraints1.gridy = 1;
		this.jLabelLogLvl = new JLabel();
		this.jLabelLogLvl.setText("LogLvl");
		final GridBagConstraints gridBagConstraints = new GridBagConstraints();
		gridBagConstraints.gridx = 0;
		gridBagConstraints.gridy = 1;
		this.jLabelNr = new JLabel();
		this.jLabelNr.setText("Nummer");
		this.setSize(300, 200);
		this.setLayout(new GridBagLayout());
		this.add(this.jLabelNr, 			gridBagConstraints);
		this.add(this.jLabelLogLvl, 		gridBagConstraints1);
		this.add(this.jLabelDate, 		gridBagConstraints2);
		this.add(this.jLabelApplication, gridBagConstraints3);
		this.add(this.jLabelPCName, 		gridBagConstraints4);
		this.add(this.jLabelKategorie, 	gridBagConstraints5);
		this.add(this.jLabelUUId, 		gridBagConstraints6);
		this.add(getJScrollPaneMessage(), 	gridBagConstraints7);
		this.add(getJScrollPaneFehler(), 	gridBagConstraints8);
	}

	private LogMsg createEmptyMessage() {
		return new LogMsg(LogLvl.info, Logger.SWFW, "Generierte Message, da keine gesetzt wurde.");
	}

	/**
	 * This method initializes jScrollPaneMessage	
	 * 	
	 * @return javax.swing.JScrollPane	
	 */
	private JScrollPane getJScrollPaneMessage() {
		if (this.jScrollPaneMessage == null) {
			this.jScrollPaneMessage = new JScrollPane();
			this.jScrollPaneMessage.setViewportView(getJTextAreaMessage());
		}
		return this.jScrollPaneMessage;
	}

	/**
	 * This method initializes jScrollPaneFehler	
	 * 	
	 * @return javax.swing.JScrollPane	
	 */
	private JScrollPane getJScrollPaneFehler() {
		if (this.jScrollPaneFehler == null) {
			this.jScrollPaneFehler = new JScrollPane();
			this.jScrollPaneFehler.setViewportView(getJTextAreaFehler());
		}
		return this.jScrollPaneFehler;
	}

	/**
	 * This method initializes jTextAreaMessage	
	 * 	
	 * @return javax.swing.JTextArea	
	 */
	private JTextArea getJTextAreaMessage() {
		if (this.jTextAreaMessage == null) {
			this.jTextAreaMessage = new JTextArea();
		}
		return this.jTextAreaMessage;
	}

	/**
	 * This method initializes jTextAreaFehler	
	 * 	
	 * @return javax.swing.JTextArea	
	 */
	private JTextArea getJTextAreaFehler() {
		if (this.jTextAreaFehler == null) {
			this.jTextAreaFehler = new JTextArea();
		}
		return this.jTextAreaFehler;
	}
	
	private void displayMsg() {
		final LogMsg msg = this.getMsg();	//never null

		this.jLabelNr			.setText("Nr. " 		+ msg.nr);
		this.jLabelLogLvl		.setText("LogLevel " 	+ msg.level);
		this.jLabelDate			.setText("von " 		+ msg.date);
		this.jLabelApplication	.setText("Anwendung "	+ msg.applikation);
		this.jLabelPCName		.setText("PC Name "		+ msg.pcName);
		this.jLabelKategorie		.setText("Kategorie "	+ msg.kategorie);
		this.jLabelUUId			.setText("Run Id " 		+ msg.runId);
		this.jTextAreaMessage	.setText("Eintrag\n "	+ msg.message);
		this.jTextAreaFehler		.setText("Fehler\n "	+ "" + msg.throwable);
	} 
}
