/**
 *	Feb 11, 2008 - Apr 17, 2008	ws:	Creation from scratch
 *	Apr 23, 2008 - Jun  4, 2008 ws: added Support for Tine ALogSource, ...
 *	Jun  6, 2008 - Jun  6, 2008	ws: added Support for events in South Pane
 *	Jun 10, 2008 - Jun 16, 2008	ws: added reloadData24, Diverses
 * 	Jun 17, 2008 - Jun 17, 2008	ws: added: hideColumnByDefault
 * 	Jun 24, 2008 - Jun 24, 2008	ws: added afterCreated selectLastCell
 * 	Jun 25, 2008 - Jul 10, 2008	ws:	added Navigation Controls mit row feedback
 * 									changed: addSelectionValue() dispenseFilter immer aus
 * 									changed: initTableColumnSizes adjust to widest column
 * 									added filterNotSelect support, improve Selection
 * 									added MultiChunkControl
 * 	Jul 17, 2008 - Jul 17, 2008	ws:	Unterstuetzung von CSV Dataeien
 * 									widest Column prefer StringColumns (Wide Header Problem)
 *	Jul 29, 2008 - Jul 30, 2008	ws: loggingDisplay renewed at structure changed
 *									small tables not too wide autoColumnSizes
 *	Jul 31, 2008 - Jul 31, 2008	ws: support search for csv files on watchdoggies
 * 	Aug 12, 2008 - Aug 14, 2008	ws:	added Schreib Unterstuetzung
 * 	Aug 18, 2008 - Aug 18, 2008	ws: Edit ToolBar save State
 * 	Aug 27, 2008 - Aug 27, 2008	ws: calcPrefWidthHeader mit Titel surrounded by 3 blanks
 * 	Aug 28, 2008 - Aug 28, 2008	ws: color coding nicht nur Message sondern auch
 * 									feldspezifisch (Kommentare Anzeige unterdruecken)
 * 	Sep  2, 2008 - Sep  3, 2008	ws: publish LoggingTable, add: isDirty, saveViaGui
 * 	Sep  4, 2008 - Sep  4, 2008	ws:	try to do internal HourGlas Cursor
 * 	Oct  2, 2008 - Oct  6, 2008	ws:	add print support
 *	Jan 15, 2009 - Jan 16, 2009 ws: serializable, Convert
 *	Feb  4, 2009 - Feb  4, 2009 ws: DFormat.guessDateFormat(..) same day only time format if today (MaWa)
 *	Feb  9, 2009 - Feb 17, 2009 ws: fix: in EditMode toggling of notFilterIcon due to column selection change
 *									fix: in EditMode apply/clear/reset dann ok FilterIcons sind disabled
 *									fix: remaining oddities use routines from "Swing Java Extreme Testing"
 *	Feb 10, 2009 - Feb 10, 2009 ws: initTableColumnSizes() beachte negativer parent.width()
 *	Feb 25, 2009 - Feb 27, 2009 ws: calcPrefWidthCells(...) try to find a non trivial value (Throwable use case)
 *									LogTableCellRenderer, ThrowableTableCellRenderer: marks multiline entries
 *	Mar  4, 2009 - Mar  4, 2009	ws:	createZeilenPanel(): editorPaneInfo.addMouseListener(.) -> .addHyperlinkListener(.)
 *									and corresponding refactorings (assume file: is on windows)
 *	Mar  5, 2009 - Mar 18, 2009	ws:	support also partial text Schnellfilter on coreInfoField, refactor a lot
 *	Apr 15, 2009 - Apr 15, 2009 ws: fix: createEditPanel_Cts_Clear()
 *	Jul  3, 2009 - Jul  3, 2009	ws:	class public -> pp
 * 	Jul 14, 2009 - Jul 17, 2009	ws:	fixed some Eclipse 3.5 warnings, protect pointFromCell(...)
 * 	Jul 27, 2009 - Jul 27, 2009	ws:	show buzy indicator on reload and setNewChunk
 *	Jul 30, 2009 - Jul 31, 2009	ws:	support for ALogSource.getAutoUpdate()
 *	Aug  3, 2009 - Aug  3, 2009	ws:	support for ALogSource.getAccessory()
 * 	Aug  6, 2009 - Aug  6, 2009	ws:	Eclipse asked for removing unnessary casts, so I did
 *	Sep 25, 2009 - Sep 25, 2009	ws:	changed: reload Button: table update in Swingthread
 * 	Nov  2, 2009 - Nov  4, 2009	ws: fight Deadlock problem in auto update and potential others
 *	Jan 21, 2010 - Jan 21, 2010 ws: "Auto Update" set initial value to always false: deadlock problem
 *	Aug 18, 2010 - Aug 18, 2010 ws: fixed in onNewChunk() sporadic RowSorter Problem
 *	Jul 13, 2016 - Jul 14, 2016	ws:	added _GUIUpdateThrottle() to autoupdate (Jan Problem with focus)
 */

package de.desy.mst.libs.framework.mstapp.logging.gui;

import java.awt.AWTException;
import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Container;
import java.awt.Cursor;
import java.awt.Desktop;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.MouseInfo;
import java.awt.Point;
import java.awt.Robot;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.InputEvent;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import java.awt.event.MouseEvent;
import java.awt.print.PrinterException;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.io.File;
import java.io.IOException;
import java.io.Serializable;
import java.net.URI;
import java.net.URISyntaxException;
import java.text.DateFormat;
import java.text.MessageFormat;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.GregorianCalendar;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

import javax.print.attribute.HashPrintRequestAttributeSet;
import javax.print.attribute.standard.JobName;
import javax.print.attribute.standard.OrientationRequested;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.DefaultCellEditor;
import javax.swing.DefaultListModel;
import javax.swing.DefaultRowSorter;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JEditorPane;
import javax.swing.JFileChooser;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.JToolBar;
import javax.swing.ListCellRenderer;
import javax.swing.ListSelectionModel;
import javax.swing.RowFilter;
import javax.swing.SwingConstants;
import javax.swing.SwingUtilities;
import javax.swing.SwingWorker;
import javax.swing.UIDefaults;
import javax.swing.UIManager;
import javax.swing.border.Border;
import javax.swing.border.EmptyBorder;
import javax.swing.event.CaretEvent;
import javax.swing.event.CaretListener;
import javax.swing.event.HyperlinkEvent;
import javax.swing.event.HyperlinkListener;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import javax.swing.event.TableModelEvent;
import javax.swing.event.TableModelListener;
import javax.swing.table.AbstractTableModel;
import javax.swing.table.DefaultTableCellRenderer;
import javax.swing.table.JTableHeader;
import javax.swing.table.TableCellEditor;
import javax.swing.table.TableCellRenderer;
import javax.swing.table.TableColumn;
import javax.swing.table.TableColumnModel;
import javax.swing.table.TableModel;
import javax.swing.table.TableRowSorter;

import de.desy.mst.libs.framework.mstapp.IMstAppKernel;
import de.desy.mst.libs.framework.mstapp.Screen;
import de.desy.mst.libs.framework.mstapp.logging.Logger;
import de.desy.mst.libs.framework.mstapp.logging.gui.LogMsgAuswertung.FieldInfo;
import de.desy.mst.libs.framework.mstapp.logging.gui.LoggingJFileChooser.MenuCSVManager;
import de.desy.mst.libs.framework.mstapp.logging.gui.__IAutoAppend.IAAClient;
import de.desy.mst.libs.framework.mstapp.logging.gui.__IAutoAppend.IAAServer;
import de.desy.mst.libs.framework.mstapp.util.Convert;
import de.desy.mst.libs.framework.mstapp.util.MstDateFormat;
import de.desy.mst.libs.framework.mstapp.util.gui.AppColor;
import de.desy.mst.libs.framework.mstapp.util.gui.GUIFactory;
import de.desy.mst.libs.framework.mstapp.util.threads.Sleep;

/**
 * Darstellung einer logSource mit Hilfe einer Tabelle und
 * Konfigurationsfeldern.
 * @author ws
 * @version 1.0.0
 */
@SuppressWarnings("rawtypes")
class LoggingTableDisplay<L, M extends AMsgModel<L>> extends JPanel {
	private static final long serialVersionUID = 1L;
	/**pp*/ static final String KEY_TABLE_CELL_SELECTION     = "KEY_TABLE_CELL_SELECTION";
	/**pp*/ static final String KEY_TABLE_CELL_SUB_SELECTION = "KEY_TABLE_CELL_SUB_SELECTION";
	/**pp*/ static final String KEY_ORIGINAL_TEXT        	 = "KEY_ORIGINAL_TEXT";
//=============================================================================
	private final LoggingTable<L, M> table;
	private final HauptFilter hauptFilter;
	private final MenuCSVManager menuCSVManager;
//=============================================================================
	public LoggingTableDisplay(final IMstAppKernel mstApp
							 , final ALogSource<L, M> logSource
							 , final MenuCSVManager menuCSVManager) {
		this.hauptFilter = new HauptFilter();
		this.table = createLoggingTable(logSource);
		this.menuCSVManager = menuCSVManager;
		this.setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));	//direkt
		SwingUtilities.invokeLater(new Runnable(){
			@Override public void run() {initialize(mstApp);}
		});
	}
//=============================================================================
	public HauptFilter 		  getHauptFilter () {return this.hauptFilter;}
	public LoggingTable<L, M> getLoggingTable()	{return this.table;}
//=============================================================================
	private LoggingTable<L, M> createLoggingTable(final ALogSource<L, M> logSource) {
		final LoggingTable<L, M> table =
				new LoggingTable<L, M>(new LoggingTableModel<L, M>(logSource)
									 , getHauptFilter()
									  );
		table.postCreationInit();	//LogSource muss erst initialisiert werden
		return table;
	}
	private void initialize(final IMstAppKernel mstApp){
		this.setLayout(new BorderLayout());

		final FilterHandler<L, M> filterHandler =new FilterHandler<L, M> (this);
		final Container north = filterHandler.getFilterPanel();
		this.add(north, BorderLayout.NORTH);

		final Container west = createColumnPanel();
		this.add(west, BorderLayout.WEST);

		final Container center = new JScrollPane(getTable());
		this.add(center, BorderLayout.CENTER);

		final Container south = createSouthPanel();
		this.add(south, BorderLayout.SOUTH);

		final SwingWorker<Void, Void> swingWorker =
			new SwingWorker<Void, Void>(){
			@Override protected Void doInBackground() throws Exception {
				Sleep.sleep(150); return null;
			}
			@Override protected void done() {
				getTable().afterCreated();
				LoggingTableDisplay.this.setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));	//direkt
				initializeTableCellSelection();
			}
		};
		swingWorker.execute();
	}
	private void initializeTableCellSelection() {
		final ListSelectionListener listener = new ListSelectionListener(){
			private FieldPair pairBySelection = null;
			@Override public void valueChanged(final ListSelectionEvent evt) {
				if(evt.getValueIsAdjusting())
					return;
				final FieldPair oldValue = this.pairBySelection;
				this.pairBySelection = getTable().getPairBySelection();
				firePropertyChange(KEY_TABLE_CELL_SELECTION, oldValue, this.pairBySelection);
			}
		};
		getTable()/*.getRow   Model()*/.getSelectionModel().addListSelectionListener(listener);
		getTable()  .getColumnModel()  .getSelectionModel().addListSelectionListener(listener);
	}
//-----------------------------------------------------------------------------
	/**
	 * Voraussetzung: Tabelle erst mal mit AMsgModel.FULL erzeugt<br>
	 * Layout Politik:
	 * <li>BoxLayout Vertikal
	 * <li>alle Komponenten linksbuendig
	 * <li>Reihenfolge wie erzeugt
	 */
	private Container createColumnPanel() {
		final JPanel panel = new JPanel();
		panel.setLayout(new BoxLayout(panel, BoxLayout.Y_AXIS));
		panel.setBorder(GUIFactory.createTitledBorder("Spalten"));

		createColumnPanel_Auswahl(panel);
		createColumnPanel_Space(panel);
		createColumnPanel_Format(panel);
		createColumnPanel_Space(panel);
		createColumnPanel_beliebigerLeerraum(panel);
		createColumnPanel_SpaltenBreitToDefault(panel);
		createColumnPanel_Space(panel);

		return panel;
	}
	private void createColumnPanel_Auswahl(final JPanel panel) {
		final JLabel label = new JLabel("Auswahl: ");
		label.setAlignmentX(Component.LEFT_ALIGNMENT);
		panel.add(label);

		final TableColumnModel columnModel = getTable().getColumnModel();
		final AMsgModel<L> msgModel = getTable().getLogMsgModel();
		final int n = msgModel.getSize();
		final JCheckBox[] cBoxes = new JCheckBox[n];
		for (int index = 0; index < n; index++) {
			final AField<?, L> field = msgModel.getField(index);
			final String name = field.getName();
			final JCheckBox cb = new JCheckBox(name, true);
			cb.setAlignmentX(Component.LEFT_ALIGNMENT);
			cb.setSelected(true);	//erst mal alle da
			cb.setEnabled(!msgModel.isCoreInfoField(field));
			final int colIndex = columnModel.getColumnIndex(msgModel.getField(index));
			final TableColumn column = columnModel.getColumn(colIndex);
			cb.addItemListener(new ItemListener(){
				@Override public void itemStateChanged(final ItemEvent e) {
					if(cb.isSelected()) {
						columnModel.addColumn(column);	//immer ans Ende
						moveColumn(column);
					}else{
						columnModel.removeColumn(column);
					}
				}
				/**vor die existierende Spalte mit kleinestem hoeheren logModelIndex, sonst hinten*/
				@SuppressWarnings("unchecked")
				private void moveColumn(final TableColumn column) {
					final TableColumn target  =
							findTargetColumn((AField<?, L>) column.getIdentifier());
					if(target == null)
						return;	//nichts zu tun Spalte ist ohnehin hinten

					final JTable table = getTable();
					table.moveColumn(
						table.convertColumnIndexToView(column.getModelIndex())
					  , table.convertColumnIndexToView(target.getModelIndex())
					  				);
				}
				/**null oder naechstes Feld rechts mit existierender Spalte*/
				private TableColumn findTargetColumn(final AField<?, L> field) {
					final LoggingTable<L, M> table = getTable();
					final AMsgModel<L> logMsgModel = table.getLogMsgModel();
					int index = field.getIndex();
					while(++index < logMsgModel.getSize()){
						final AField<?, L> targetFld = logMsgModel.getField(index);
						final TableColumn column = table.getColumn(targetFld);
						if(column != null)
							return column;

					}
					return null;
				}
			});
			panel.add(cb);
			cBoxes[index] = cb;
		}

		final LogMsgAuswertung<L,M> auswertung =
			getTable().getModel().getLogSource().getAuswertung();
		for (int index = 0; index < n; index++) {
			final FieldInfo<?, L> fieldInfo = auswertung.getFieldInfo( msgModel.getField(index) );
			cBoxes[index].setSelected	(fieldInfo.hasInfo());
			cBoxes[index].setToolTipText(fieldInfo.getToolTipText());
		}
	}
	private void createColumnPanel_Space(final JPanel panel) {
		final int height = 15;
		final Dimension pref = new Dimension(5, height);
		final Dimension max  = new Dimension(Integer.MAX_VALUE, height);
		panel.add(new Box.Filler(null, pref, max));
	}
	@SuppressWarnings("unchecked")
	private void createColumnPanel_Format(final JPanel panel) {
		final ALogSource<L, M> logSource = getTable().getModel().getLogSource();
		if(logSource.getMsgModel().getDateField() == null)
			return;

		final JLabel titel = new JLabel("Format: ");
		titel.setAlignmentX(Component.LEFT_ALIGNMENT);
		panel.add(titel);

		final JLabel label = new JLabel("   Datum/Zeit: ");
		label.setAlignmentX(Component.LEFT_ALIGNMENT);
		panel.add(label);

		final JComboBox combo = new JComboBox(DFormat.values());
		combo.setAlignmentX(Component.LEFT_ALIGNMENT);
		combo.setPreferredSize(label.getPreferredSize());
		final Dimension max  = new Dimension(Integer.MAX_VALUE
										   , label.getPreferredSize().height);
		combo.setMaximumSize(max);
		combo.addActionListener(new ActionListener(){
			@Override public void actionPerformed(final ActionEvent e) {
				final int index = combo.getSelectedIndex();
				if(index >= 0){
					final DFormat format = DFormat.values()[index];
					getTable().setDateFormat(format.createDateFormat());
					label.setToolTipText(format.getToolTip());
					combo.setToolTipText(format.getToolTip());
				}
			}
		});
		final int index = DFormat.guessDateFormat(logSource).ordinal();
		combo.setSelectedIndex(index);	//brauche event

		panel.add(combo);
	}
	private void createColumnPanel_beliebigerLeerraum(final JPanel panel) {
		panel.add(Box.createVerticalGlue());
	}
	private void createColumnPanel_SpaltenBreitToDefault(final JPanel panel){
		final ActionListener listener = new ActionListener(){
			@Override public void actionPerformed(final ActionEvent e) {
				getTable().initTableColumnSizes();
			}
		};
		final String fileName = "format/spaltenbreite24.gif";
		final JButton button = GUIFactory.createImageButton
					( fileName
					, "Alle Spalten automatisch in der Breite anpassen."
					, listener
					, this.getClass());
		panel.add(button);
	}

	//-------------------------------------------------------------------------

	private Container createSouthPanel(){
		final JPanel panel = new JPanel(new BorderLayout());
		panel.setBorder(GUIFactory.createTitledBorder("Gewhlte Zeile"));
		panel.add(createNavigationPanel(), BorderLayout.WEST);	//fixe groesse
		panel.add(createZeilenPanel(),     BorderLayout.CENTER);//nimmt den Rest
		return panel;
	}
	private Container createNavigationPanel(){
		final JPanel ctrPanel = new JPanel();
		ctrPanel.setLayout(new BoxLayout(ctrPanel, BoxLayout.X_AXIS));

		ctrPanel.add(Box.createHorizontalStrut(5));
		ctrPanel.add(createNavigationPanelButton("first11", 	"erste",	Integer.MIN_VALUE));
		ctrPanel.add(createNavigationPanelButton("previous11",	"vorige",	-1));
		ctrPanel.add(Box.createHorizontalStrut(3));
		ctrPanel.add(createNavigationPanelRecordTField());
		ctrPanel.add(Box.createHorizontalStrut(3));
		ctrPanel.add(createNavigationPanelButton("next11", 		"nchste",	+1));
		ctrPanel.add(createNavigationPanelButton("last11", 		"letzte",	Integer.MAX_VALUE));
		ctrPanel.add(Box.createHorizontalStrut(5));
		ctrPanel.add(createNavigationPanelRecordLablel());
		ctrPanel.add(new MultiChunkControl<L,M>(getTable()));
		ctrPanel.add(Box.createHorizontalStrut(5));

		final JPanel outerPanel = new JPanel(new BorderLayout());
		outerPanel.add(ctrPanel, BorderLayout.SOUTH);	//Controls liegen unten aufgereiht
		return outerPanel;
	}
	private JButton createNavigationPanelButton(final String fileName
											  , final String welche
											  , final long   delRow) {
		return GUIFactory.createImageButton("navigation/" + fileName + ".gif"
									, "Anwhlen der Zelle " + welche + " Zeile."
									, createNavigationButtonListener(delRow)
									, this.getClass()
		);
	}
	/**@param delRow == -1 ... previous, +1 ... next, -Max ... first, +Max ... last*/
	private ActionListener createNavigationButtonListener(final long delRow){
		return new ActionListener(){
			@Override public void actionPerformed(final ActionEvent evt){
				getTable().selectNavigateRow(delRow);
			}
		};
	}
	private JTextField createNavigationPanelRecordTField() {
		final JTextField recordField = new JTextField("-99999");
		recordField.setHorizontalAlignment(SwingConstants.RIGHT);
		final Dimension size = recordField.getPreferredSize();
		size.height = 16;
		final ListSelectionListener listener = new ListSelectionListener(){
			@Override public void valueChanged(final ListSelectionEvent event) {
				if (event.getValueIsAdjusting())
					return;
				final int row = getTable().getSelectedRow();
				if(row < 0 || getTable().getRowCount() <= 0){
					recordField.setText("");
					recordField.setToolTipText("Es wurde keine Zeile ausgewhlt.");
				}else{
					final int oriRow = getTable().convertRowIndexToModel(row);
					recordField.setText(" " + (row + 1));
					final String oriInfo = (row == oriRow) ? ""
							: " (ori = " + (oriRow + 1) + ")";
					final String toolTip = "Es wurde die Zeile "
						+ (row + 1)
						+ oriInfo + " ausgewhlt.";
					recordField.setToolTipText(toolTip);
					recordField.setMinimumSize(size);	//erst hier
					recordField.setPreferredSize(size);	//da sonst
					recordField.setMaximumSize(size);	//berschrieben
				}
			}
		};
		final KeyAdapter keyAdapter = new KeyAdapter(){
			@Override public void keyReleased(final KeyEvent evt) {
				handleKeyEvent(evt); super.keyPressed(evt);
			}
			@Override public void keyPressed(final KeyEvent evt) {
				handleKeyEvent(evt); super.keyPressed(evt);
			}
			@Override public void keyTyped(final KeyEvent evt) {
				handleKeyEvent(evt); super.keyPressed(evt);
			}
			public void handleKeyEvent(final KeyEvent evt){
				final int requestedRow = getRequestedRow();
				if(requestedRow < 0)
					AppColor._FEHLER.set(recordField);
				else{
					AppColor._Info.set(recordField);
					if(evt.getKeyCode() == KeyEvent.VK_ENTER)
						getTable().selectRow(requestedRow);
				}
			}
			private int getRequestedRow() {
				try {
					final String text = recordField.getText().trim();
					return Integer.valueOf(text) - 1;	//row Number 0 based
				} catch (final NumberFormatException ex) {
					return -1;
				}
			}

		};
		recordField.addKeyListener(keyAdapter);
		getTable().getSelectionModel().addListSelectionListener(listener);
		return recordField;
	}
	private JLabel createNavigationPanelRecordLablel() {
		final JLabel label = new JLabel();
		final ListenerForNavigationPanelRecordLablel listener =
							new ListenerForNavigationPanelRecordLablel(label);
		getTable().getSelectionModel().addListSelectionListener(listener);
		getTable().getModel()         .addTableModelListener   (listener);
		return label;
	}
	private final class ListenerForNavigationPanelRecordLablel
						implements ListSelectionListener, TableModelListener {
		private final JLabel label;
		private ListenerForNavigationPanelRecordLablel(final JLabel label)
			{this.label = label;}
		@Override public void valueChanged(final ListSelectionEvent event) {
			if (!event.getValueIsAdjusting())
				updateNavigationPanelRecordLablel(this.label);
		}
		@Override public void tableChanged(final TableModelEvent event) {
			updateNavigationPanelRecordLablel(this.label);
		}
		private void updateNavigationPanelRecordLablel(final JLabel label) {
			final LoggingTable<L, M> table = getTable();
			final int rowCount    = table.getRowCount();
			final int rowCountOri = table.getModel().getRowCount();
			final boolean filtert = (rowCount != rowCountOri);
			label.setText(" von " + rowCount
					+ (filtert ? " gefiltert ("+rowCountOri+")" : ""));
		}
	}

	private Container createZeilenPanel() {
		final JEditorPane editorPaneLink = new JEditorPane();
		editorPaneLink.setEditable(false);
		editorPaneLink.setVisible(false);

		final JTextArea errorOut = new JTextArea("Hier Fehler anzeigen.");
		errorOut.setOpaque(true);
		errorOut.setVisible(false);
		errorOut.setEditable(false);
		AppColor._FEHLER.set(errorOut);

		final JEditorPane editorPaneInfo = new JEditorPane("text/html", "");
		editorPaneInfo.setEditable(false);

		final AField<?, L> coreInfoField = getTable().getLogMsgModel().getCoreInfoField();
		editorPaneInfo.addCaretListener(new CaretListener(){
			private FieldPair oldPair;
			@Override public void caretUpdate(final CaretEvent evt) {
				final String selectedText = editorPaneInfo.getSelectedText();
				if(selectedText == null)
					return;
				//kluge against HTML decoration artefact, if all selected
				//NICHT: editorPaneInfo.getText() ist HTML Dekoriert
				final String allText = (String) editorPaneInfo.getClientProperty(KEY_ORIGINAL_TEXT);
				final boolean allIsSelected = (allText.length() <= selectedText.length());
				final FieldPair newPair = allIsSelected ?
						  new FieldSubStringPair(coreInfoField, allText, allIsSelected)
						: new FieldSubStringPair(coreInfoField, selectedText, allIsSelected);
				firePropertyChange(KEY_TABLE_CELL_SUB_SELECTION, this.oldPair, newPair);
				this.oldPair = newPair;
			}
		});

		editorPaneInfo.addHyperlinkListener(createHypertextListener(editorPaneInfo, editorPaneLink, errorOut));
		final ListSelectionModel selModel = getTable().getSelectionModel();
		selModel.addListSelectionListener(createListSelectionListener(editorPaneInfo, editorPaneLink, errorOut, getTable()));

		final JPanel panel = new JPanel();
		panel.setLayout(new BoxLayout(panel, BoxLayout.X_AXIS));
		panel.add(editorPaneInfo);
		panel.add(Box.createHorizontalStrut( 5));
		panel.add(editorPaneLink);
		panel.add(Box.createHorizontalStrut( 5));
		panel.add(errorOut);
		panel.add(Box.createHorizontalGlue());
		return panel;
	}
	private ListSelectionListener createListSelectionListener(final JEditorPane editorPaneInfo, final JEditorPane editorPaneLink, final JTextArea errorOut, final LoggingTable<L, M> table) {
		return new ListSelectionListener(){
			@Override public void valueChanged(final ListSelectionEvent event) {
				if(event.getValueIsAdjusting())
					return;;
				errorOut.setVisible(false);
				final String text = calcTextForCoreInfoField(table);
				updateCoreInfoGUI(text, editorPaneInfo, editorPaneLink);
			}
		};
	}
	private String calcTextForCoreInfoField(final LoggingTable<L, M> table) {
		final int oriRow = table.convertRowIndexToModel(table.getSelectedRow());
		if(oriRow < 0){
			return "";
		}else{
			final L logMsg = table.getModel().getLogSource().getMessage(oriRow);
			return table.getLogMsgModel().getCoreInfoField().asStringLongM(logMsg);
		}
	}
	private HyperlinkListener createHypertextListener(final JEditorPane editorPaneInfo, final JEditorPane editorPaneLink, final JTextArea errorOut) {
		return new HyperlinkListener(){
			@Override public void hyperlinkUpdate(final HyperlinkEvent evt) {
				final String link = extractNormalisedLink(evt);
				onNewLink(editorPaneInfo, editorPaneLink, link);//mousemove sufficent

				if(evt.getEventType() != HyperlinkEvent.EventType.ACTIVATED)
					return;

				final URI uri = extractURI(link);
				if(uri == null){
					final String msg = "Der Link '" + link + "' hat illegale Syntax.";
					updateError(errorOut, msg);
					return;
				}
				try {
					Desktop.getDesktop().browse(uri);
				} catch (final IOException e) {
					final String msg = "Kann \"" + link + "\" nicht ffnen . " + "Existiert dies (noch)?\n" + e.getMessage();
					Logger.SWFW.warn(msg);
					updateError(errorOut, msg);
				}
			}
			private String extractNormalisedLink(final HyperlinkEvent evt) {
				final String link = evt.getDescription();
				if(link.toLowerCase().startsWith("file:"))
					return link.replace("\\", "/");
				else
					return link;
			}
			private URI extractURI(final String link) {
				try {
					return new URI(link);
				} catch (final URISyntaxException ex) {
					Logger.SWFW.warn("Der Link \"" + link + "\" hat illegale Syntax. " + ex.getMessage(), ex);
				}
				return null;
			}
			private void updateError(final JTextArea out, final String msg) {
				out.setVisible(true);	out.setText(msg.replace(". ", ".\n"));
			}
		};
	}
	private void updateCoreInfoGUI(final String text
								 , final JEditorPane editorPaneInfo
								 , final JEditorPane editorPaneLink) {
		try {
			editorPaneInfo.setText(text);
		} catch (final Exception e) {
			final String errorText = "Kann nicht darstellen: <font color=\"#FF0000\"><b><span style=\"background-color: #FFFF00\">" + e.getMessage() + "</span></b></font>";
			updateCoreInfoGUI(errorText, editorPaneInfo, editorPaneLink);
			return;
		}
		editorPaneInfo.putClientProperty(KEY_ORIGINAL_TEXT, text);
		onNewLink(editorPaneInfo, editorPaneLink, extractLink(text));
	}
	private void onNewLink(final JEditorPane editorPaneInfo, final JEditorPane editorPaneLink, final String link) {
		final LoggingTable<L, M> table = getTable();
		editorPaneInfo.setToolTipText(!link.isEmpty() ? link
				: "Inhalt der Spalte "
				+ table.getLogMsgModel().getCoreInfoField().getName()
				+ " und der Zeile "
				+ (table.convertRowIndexToModel(table.getSelectedRow()) + 1));
		editorPaneLink.setText("Link: " + link);
		editorPaneLink.setVisible(!link.isEmpty());

		if(!link.isEmpty())
			SwingUtilities.invokeLater(new Runnable(){
				@Override public final void run(){getMenuCSVManager().fireNewFec(link);}
			});
	}
	/**braucht exaktes Piotr Format ohne extra blanks, wird mit hypertext listener ueberschrieben*/
	private static String extractLink(final String text) {
		final String sBegin = "<a href=\"";
		final String sEnd 	= "\">";
		final int begin = text.indexOf(sBegin,   -1) + sBegin.length();
		final int end   = text.indexOf(sEnd,  begin);
		return (end < 0 || end <= begin) ? "" : text.substring(begin, end)
													.replace("\\", "/");
	}
	//-------------------------------------------------------------------------
	/**should be used in EDT*/
	LoggingTable<L, M>	getTable() {
		__EDTBuster.outputDiagnosticsIfUnexpectedThread();
		return this.table;
	}
	/**no EDT restriction*/
	LoggingTableModel<L, M> getModel() 			{return this.table.getModel();}
	MenuCSVManager 			getMenuCSVManager()	{return this.menuCSVManager;}
}//END LoggingTable

//=============================================================================
//=============================================================================
//=============================================================================

@SuppressWarnings({"rawtypes", "unchecked"})
class MultiChunkControl<L, M extends AMsgModel<L>> extends JPanel{
	private static final long serialVersionUID = 1L;
	private final LoggingTable<L, M> table;
	private final JLabel label;
	private final DefaultListModel listModel;
	private final JList jList;
	//---------------------------------------------------------------------
	public MultiChunkControl(final LoggingTable<L, M> table) {
		super();
		this.table = table;
		this.label = new JLabel("(Abschnitt = 0"); this.add(this.label);
		this.listModel = new DefaultListModel();
		this.jList = createJList();
		this.setBorder(GUIFactory.createTitledBorder("Daten Abschnitt Kontrolle"));
		this.setToolTipText("Es sind zu viele Eintrge vorhanden, um sie im Stck zu verarbeiten: also in Abschnitten.");
		updateControls();
		final TableModelListener tableModelListener = new TableModelListener(){
			@Override public void tableChanged(final TableModelEvent evt) {
				updateControls();}//muss mehr chunks mitbekommen bei reload
		};
		getModel().addTableModelListener(tableModelListener);
		this.setVisible(esExistierenWeitereChunks());
	}
	//---------------------------------------------------------------------
	private JList createJList() {
		final JList jList = new JList(this.listModel);
		final ListSelectionListener listener = new ListSelectionListener(){
			@Override public void valueChanged(final ListSelectionEvent evt) {
				final int selIndex = MultiChunkControl.this.jList.getSelectedIndex();
				if(		evt.getValueIsAdjusting()
					|| 	selIndex < 0
					||	selIndex == getLogSource().getChunkIndexOfCurrent())
					return;

				if( getLogSource().getChunkAnzahl() !=
					MultiChunkControl.this.jList.getModel().getSize()){
					updateControls();
					return;
				}
				//TODO Check always on Top Problem
				GUIFactory.runInExtraThread_showingBusyDialog(
				    new Runnable(){@Override public void run(){handleNewChunk(selIndex);}}
				  , jList
				  , "Lade Abschnitt " + (selIndex + 1)
				  , true);
			}

			private void handleNewChunk(final int selIndex) {
				final Cursor oldCursor = GUIFactory.setCursor(
								  Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR)
								, MultiChunkControl.this);
				try {
					getLogSource().setChunk(selIndex);
					getTable().onNewChunk();
				}catch (final IOException ex) {
					Logger.SWFW.warn("LoggingTableDisplay.setChunk("
								   + selIndex
								   + ") IO Problem (Ignorier es.): "   + ex);
				}finally{
					GUIFactory.setCursor(oldCursor, MultiChunkControl.this);
				}
			}
		};
		jList.addListSelectionListener(listener);
		jList.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		jList.setLayoutOrientation(JList.HORIZONTAL_WRAP);
		jList.setVisibleRowCount(1);
		jList.setSelectedIndex(0);
		this.add(new JScrollPane(jList));
		return jList;
	}
	private LoggingTable<L, M> 		getTable() 		{return this.table;}
	private LoggingTableModel<L, M> getModel()		{return getTable().getModel();}
	private ALogSource<L, M> 		getLogSource()	{return getModel().getLogSource();}
	private void updateControls() {
		__EDTBuster.outputDiagnosticsIfUnexpectedThread();
		final int nChunk = Convert.toInt(getLogSource().getChunkAnzahl());
		final int chunkIndex = Convert.toInt(getLogSource().getChunkIndexOfCurrent());
		this.label.setText("(Abschnitt = " + (chunkIndex + 1) + ")");
		this.listModel.clear();	//koennen nach neuem Filter wieder weniger werden
		for (int iChunk = 0; iChunk < nChunk; iChunk++) {
			final String abschnitt = "" + (iChunk + 1);
			this.listModel.addElement(abschnitt);
		}
		try {this.jList.setSelectedIndex(chunkIndex);}catch (final Exception e){;}
		final int nRows =  Math.min(3, 1 + nChunk / 10);
		this.jList.setVisibleRowCount(nRows);
		this.setVisible(esExistierenWeitereChunks());
	}
	private boolean esExistierenWeitereChunks() {
		final long chunkAnzahl = getLogSource().getChunkAnzahl();
		return chunkAnzahl > 1;
	}
};//END Class MultiChunkControl

class LogRowFilter extends RowFilter<TableModel, Integer> {
	private IFilter filter;

	/* (non-Javadoc)
	 * @see javax.swing.RowFilter#include(javax.swing.RowFilter.Entry)
	 */
	@Override public boolean include(final RowFilter.Entry<? extends TableModel, ? extends Integer> entry) {
		return this.filter == null
			   ||
			   this.filter.include(entry);
	}
	public void setFilter(final IFilter filter) {this.filter = filter;}
}
//=============================================================================
/**Markiert die Zellen nach LogLvl der Zeile*/
class LogTableCellRenderer<L, M extends AMsgModel<L>>
											extends DefaultTableCellRenderer{
	private static final long serialVersionUID = 1L;
	private static final String NL = "\n";
	/**zaehlt die Zeilen, leere letzte Zeilen werden ignoriert, minimum 1*/
	static int valueToStringNumberOfLines(final Object value) {
		if(value == null)
			return 1;

		final String txt = value.toString();
		if(txt == null || txt.isEmpty() || !txt.contains(NL))
			return 1;

		if(txt.endsWith(NL)) {
			final String txtIgnoringEmptyLastLine = txt.substring(0, txt.length() - NL.length());
			return valueToStringNumberOfLines(txtIgnoringEmptyLastLine);
		}

		final int lastIndex = txt.length() - 1;
		int nLines = 1;
		int index = txt.indexOf(NL);
		while(0 <= index && index <  lastIndex){
			nLines++;
			index = txt.indexOf(NL, index + 1);
		}
		return nLines;
	}
	//---------------------------------------------------------------------
	LogTableCellRenderer() {super();}
	//---------------------------------------------------------------------
	/**Passt die foreGround und backGround Farbe z.B. dem LogLvl an*/
	@SuppressWarnings("unchecked")
	@Override public Component getTableCellRendererComponent(final JTable table, final Object value, final boolean isSelected, final boolean hasFocus, final int row, final int column) {
		final Component cmp = super.getTableCellRendererComponent(table, value, isSelected, hasFocus, row, column);
		((LoggingTable<L, M>)table).setRowColorToComponent(row, column, cmp);
		if(LogTableCellRenderer.valueToStringNumberOfLines(value) > 1)
			markAsMultiLine(cmp);
		return cmp;
	}
	void markAsMultiLine(final Component cmp) {
		if(cmp == null)
			return;

		final String MULTILINE_MARKER = " ...";
		if(cmp instanceof JLabel)
			((JLabel)cmp).setText(((JLabel)cmp).getText() + MULTILINE_MARKER);
		else
			Logger.SWFW.debug("LoggingTableDisplay LogTableCellRenderer.markAsMultiLine(cmp) Implementation fuer die Klasse fehlt:" + cmp.getClass());

		cmp.setFont(GUIFactory.createFont(getFont(), Font.ITALIC));
	}
}
//=============================================================================
class ThrowableTableCellRenderer<L, M extends AMsgModel<L>> extends LogTableCellRenderer<L, M> {
	private static final long serialVersionUID = 1L;
	@Override
	public Component getTableCellRendererComponent(final JTable table, final Object value, final boolean isSelected, final boolean hasFocus, final int row, final int column) {
		final Component cmp = super.getTableCellRendererComponent(table, value, isSelected, hasFocus,row, column);
		if(value instanceof Throwable && value != AMsgModel.NULL_THROWABLE)
			markAsMultiLine(cmp);
		return cmp;
	}
}
//=============================================================================
class NumTableCellRenderer<L, M extends AMsgModel<L>>
											extends LogTableCellRenderer<L, M> {
	private static final long serialVersionUID = 1L;
	public NumTableCellRenderer() {
		super();
		setHorizontalAlignment(SwingConstants.RIGHT);
	}
}
//=============================================================================
@SuppressWarnings({"unchecked", "rawtypes"})
class TableCheckBoxRenderer<E extends Serializable, L, M extends AMsgModel<L>> extends JCheckBox
														  implements ListCellRenderer {
	private static final long serialVersionUID = 1L;
	private static final Border NO_FOCUS_BORDER = new EmptyBorder(1, 1, 1, 1);
	//-------------------------------------------------------------------------
	private final AField<E, L>.FieldFilter	filter;
	private final LoggingTableModel<L, M>	model;
	private final AField<E, L> 				field;
	//-------------------------------------------------------------------------
	public TableCheckBoxRenderer( final AField<E, L>.FieldFilter filter
						  		, final LoggingTableModel<L, M>  model
						  		, final AField<E, L> field) {
		if(filter == null)
			throw new NullPointerException("Der Filter darf nicht null sein.");
		if(model == null)
			throw new NullPointerException("Das Tabellen Modell darf nicht null sein.");
		if(field == null)
			throw new NullPointerException("Das Feld darf nicht null sein.");
		this.filter = filter;
		this.model  = model;
		this.field  = field;
	}
	//-------------------------------------------------------------------------
	@Override public Component getListCellRendererComponent(
			  final JList list,         final Object value ,   final int index
			, final boolean isSelected, final boolean cellHasFocus) {

		final E e = (E)value;
        final int anzahl = getAuswertung().getFieldInfo( getField() )
        								  .getAnzahl(e);
		final String text = getFilter().getField().asStringLong(e)
						  + "   (" + anzahl + ")";
		setText(text);
		setSelected(getFilter().passes(e));

        setComponentOrientation(list.getComponentOrientation());
        setBackground(isSelected?list.getSelectionBackground():list.getBackground());
        setForeground(isSelected?list.getSelectionForeground():list.getForeground());
        setEnabled(list.isEnabled());
        setFont(list.getFont());
        setBorder(cellHasFocus?UIManager.getBorder("List.focusCellHighlightBorder"):NO_FOCUS_BORDER);
        return this;
	}
	//-------------------------------------------------------------------------
	private final AField<E, L>.FieldFilter 	getFilter() {return this.filter;}
	private final AField<E, L> 				getField()  {return this.field; }
	private final LoggingTableModel<L, M> 	getTModel() {return this.model; }
	private LogMsgAuswertung<L, M> getAuswertung() {
		return getTModel().getLogSource().getAuswertung();
	}
}
//=============================================================================
/**Holds the Field and an associated Value. E.g. contents of a Message, Substring, Comment, ....*/
@SuppressWarnings({"unchecked", "rawtypes"})
abstract class FieldPair{
	private static final String SEP   = ": ";
	private static final String QUOTE = "\"";
	//-------------------------------------------------------------------------
	private final AField field;
	private final Object value;
	//-------------------------------------------------------------------------
	public FieldPair(final AField field, final Object value)
	{this.field = field; this.value = value;}
	//-------------------------------------------------------------------------
	public AField getField()   {return this.field;}
	public Object getValue()   {return this.value;}
	/**@return key: "inhalt"*/
	public String format(final String key, final String inhalt){
		return key + SEP + QUOTE + inhalt + QUOTE;
	}
	/**@return new ToolTipText*/
	public String calcTTT(final boolean inverted){
		final String inFix = inverted ? " UNGLEICH" : " GLEICH";
		return format("Filtern nach Auswahl: " + getField() + inFix, "" + getValue());
	}
	public AFFE createFFE(final boolean inverted){
		return new FFEValueEquality(getField(), (Serializable)getValue(), inverted);
	}
	public boolean supportsInverted() {return getField().supportsInverted();}
}
//-----------------------------------------------------------------------------
@SuppressWarnings({"rawtypes"})
class FieldValuePair extends FieldPair{
	public FieldValuePair(final AField field, final Object value)
			{super(field, value);}
	@Override public String toString() {
		final String key = getField().toString();
		try {
			return format(key, getField().asStringLong(getValue()));
		}catch (final Exception ex) {
			return format(key + " ?!? ", "" + getValue());
		}
	}
}
//-----------------------------------------------------------------------------
/**for SubString Selection of toString from Fields*/
@SuppressWarnings({"rawtypes"})
class FieldCommentPair extends FieldPair{
	public FieldCommentPair(final AField field, final String comment){
		super(field, comment);
	}
	@Override public String toString() {
		return format("Kommentar: ", getComment());
	}
	@Override public String getValue() {return (String)super.getValue();}
	public String getComment() {return getValue();}
}
//-----------------------------------------------------------------------------
/**for SubString Selection of toString from Fields*/
@SuppressWarnings({"unchecked", "rawtypes"})
class FieldSubStringPair extends FieldPair{
	private final boolean isEntireField;
	public FieldSubStringPair(final AField field, final String subString, final boolean isEntireField){
		super(field, subString);
		this.isEntireField = isEntireField;
	}
	@Override public String toString() {
		return format(getField().toString() + " SubString",  getValue());
	}
	@Override public String getValue() {return (String)super.getValue();}
	public String getSubstring() {return getValue();}
	@Override public String calcTTT(final boolean inverted){
		final String inFix = inverted ? "NICHT" : "";
		return format("Filtern nach " + getField() + " enthlt " + inFix, getValue());
	}
	@Override public AFFE createFFE(final boolean inverted){
		return this.isEntireField ?
			  new FFEValueEquality(getField(), getSubstring(), inverted)
			: new FFEHasSubstring (getField(), getSubstring(), inverted);
	}
}
//=============================================================================
enum DFormat{
	  STD    ("Standard", "dd.MM.yy HH:mm:ss")
	, ISO    ("ISO", 	 "yyyy-MM-dd HH:mm:ss")
	, ISO_Z  ("ISO Zone", "yyyy-MM-dd HH:mm:ss Z")
	, ISO_MS ("LANG", 	 "yyyy-MM-dd HH:mm:ss.SSS Z")
	, DATUM  ("Datum", 	 "yyyy-MM-dd")
	, ZEIT   ("Zeit", 	 "HH:mm:ss")
	;

	private static final long MS_IN_A_DAY = 1000L*3600L*24L;
	private static final Calendar CALENDAR = new GregorianCalendar();
	public final String name;
	public final String pattern;
    //---------------------------------------------------------------------
	private DFormat(final String name, final String pattern) {
		this.name = name;
		this.pattern = pattern;
	}
	//---------------------------------------------------------------------
	public DateFormat createDateFormat() {
		return new SimpleDateFormat(this.pattern);
	}
    public String getToolTip() {return this.name + ": \"" + this.pattern + "\"";}
	@Override public String toString() {return this.name;}
	public static <L, M extends AMsgModel<L>> DFormat
								guessDateFormat(final ALogSource<L, M> logSource) {
		if(logSource == null)
			return DFormat.ISO;

		final int anzahl = logSource.getSize();
		if(anzahl <= 0)
			return DFormat.ISO;
		if(anzahl == 1)
			return DFormat.DATUM;

		final AField<Date, L> dateField = logSource.getMsgModel()
												   .getDateField();

		if(dateField == null)
			return DFormat.ISO; 

		final Date first = dateField.get(logSource.getMessage(         0));
		final Date last  = dateField.get(logSource.getMessage(anzahl - 1));
		if(isSameDay(first, last) && isSameDay(first, new Date()/*today*/))
			return DFormat.ZEIT;
		if(hasAtMostOneEntryADay(first, last, anzahl))
			return DFormat.DATUM;
		return DFormat.ISO;
	}
	//---------------------------------------------------------------------
	private static boolean isSameDay(final Date first, final Date last) {
		final long differenceMS = last.getTime()
								- first.getTime();
		if(Math.abs(differenceMS) > MS_IN_A_DAY)
			return false;
		final int firstDOW = calcDayOfWeek(first);
		final int lastDOW = calcDayOfWeek(last);
		if(firstDOW == lastDOW)	//reicht, da alles innerhalb 24 Stunden
			return true;
		return false;
	}
	private static int calcDayOfWeek(final Date date) {
		CALENDAR.setTime(date);
		return CALENDAR.get(Calendar.DAY_OF_WEEK);
	}
	private static boolean hasAtMostOneEntryADay(final Date first, final Date last, final int anzahl) {
		final long msDiff = Math.abs(last.getTime() - first.getTime());
		return msDiff >= ((anzahl- 1) * MS_IN_A_DAY);//bei gleicher Verteilung
	}
}

//=============================================================================

@SuppressWarnings({"unchecked", "rawtypes"})
class LoggingTable<L, M extends AMsgModel<L>> extends JTable {
	private static final long serialVersionUID = 1L;
	private static final int  MAX_COLUMN_INIT_WIDTH =
								Convert.toInt(Screen.FULL_SCREEN.width * 0.8);
	//.........................................................................
	/**liefert den JFileChooser return wert*/
	public static int saveViaGui(final Component compToCenterFileDialog
							   , final LoggingTableModel tableModel) {
		final ALogSource logSource = tableModel.getLogSource();
		final File defaultFile = logSource.getDefaultFile();
		final JFileChooser fc = new JFileChooser(defaultFile);
		if(defaultFile != null && defaultFile.exists())
			fc.setSelectedFile(defaultFile);
		final int returnVal = fc.showOpenDialog(compToCenterFileDialog);
		if (returnVal == JFileChooser.APPROVE_OPTION) {
            final File file = fc.getSelectedFile();
            final String msg = "'" + logSource.toString()
            					   + "' nach '"
            					   + file.getAbsolutePath()
            					   + "' schreiben.";
            if(   file.exists()
               && JOptionPane.OK_OPTION != JOptionPane.showConfirmDialog(null, "Die Datei existiert schon. berschreiben?")){
            	Logger.SWFW.info("Doch nicht: " + msg);
            }else{
				Logger.SWFW.info(msg);
				try{
					logSource.getWriter().write(file);
					tableModel.fireTableDataChanged();
				}catch(final IOException ex){
					final String ms = "Problem beim Schreiben von '"
									+ file.getAbsolutePath() + "'.";
					Logger.SWFW.warn(ms, ex);
					JOptionPane.showMessageDialog(null, msg);
				}
            }
		} else {
			Logger.SWFW.info("Benutzer will doch nicht schreiben.");
		}
		return returnVal;
	}
//-----------------------------------------------------------------------------

	private final Robot robot;
	private DateFormat dateFormat = MstDateFormat.ISO;
	private AField<Serializable, L> lastSelectedField;
//-----------------------------------------------------------------------------
	public LoggingTable(final LoggingTableModel<L, M> loggingTableModel
					  , final HauptFilter hauptFilter) {
		super(loggingTableModel);
		this.robot = createRobot();
		getModel().getLogSource().initFilter(hauptFilter, this);
		final ListSelectionListener listener = new ListSelectionListener(){
			@Override public void valueChanged(final ListSelectionEvent evt) {
				ensureASelectedCell();
			}
		};
		getColumnModel().getSelectionModel().addListSelectionListener(listener);
					this.getSelectionModel().addListSelectionListener(listener);
	}
	private Robot createRobot() {
		try {return new Robot();}
		catch (final AWTException ex) {
			Logger.SWFW.warn("LoggingTable can not create robot. Just ignore", ex);
		}
		return null;
	}
	public void onNewChunk() {
		try {getRowSorter().allRowsChanged();}
		catch (final Exception ex) {Logger.SWFW.warn("Ignore Rowsorter Problem.", ex);}
		getModel().fireTableDataChanged();
		selectLastRowFirstCell();
		requestFocusInWindow();
	}
	public void afterCreated() {
		initTableColumnSizes();
		selectLastRowFirstCell();
		requestFocusInWindow();
	}
	void postCreationInit() {
		final TableColumnModel columnModel = getColumnModel();
		final int n = columnModel.getColumnCount();
		for (int iCol = 0; iCol < n; iCol++) {
			final TableColumn column = columnModel.getColumn(iCol);
			final AField<?, L> field = getLogMsgModel().getField(iCol);
			column.setIdentifier(field);
		}
		setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		setCellSelectionEnabled(true);

		setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
		setFillsViewportHeight(true);

		final TableRowSorter<TableModel> sorter =
			new TableRowSorter<TableModel>(getModel());
		sorter.setRowFilter(new LogRowFilter());
		setRowSorter(sorter);
	}
	private void selectLastRowFirstCell() {selectCell(getRowLastIndex(), 0);}
	void selectCell(final int row, final int col) {
		if(row < 0 || !hasColumns() || !hasRows())
			return;
		final boolean toggle = false; final boolean extend = false;
		changeSelection(row, col, toggle, extend);
		clickTableCell(row, col);
	}
	private void clickTableCell(final int row, final int col) {
		printCellSelectionInfo("       clickTableCell");
		final Point position = pointFromCell(row, col);
		mouseLeftClickInsideComponentAt(position);
	}
	private Point pointFromCell(final int row, final int col) {
		try {
			final Point locationInTable = getCellRect( row, col, true).getLocation();
			final Point tableLocationOnScreen = getLocationOnScreen();
			return new Point( locationInTable.x + tableLocationOnScreen.x,
							  locationInTable.y + tableLocationOnScreen.y );
		} catch (final Exception ex) {
			return new Point(0,0);	//if not on screen => IllegalStateException
		}
	}
    private void mouseLeftClickInsideComponentAt(final Point position) {
    	mouseLeftClick( pointJustInsideComponentAt( position ) );
    }
    private Point pointJustInsideComponentAt( final Point position ) {
        return new Point( position.x + 5, position.y + 5 );
    }
    private void mouseLeftClick(final Point where) {
    	final Robot robot = this.robot;
    	if(robot == null)
    		return;
    	final Point oldWhere = MouseInfo.getPointerInfo().getLocation();
        robot.mouseMove( where.x, where.y );
	        robot.mousePress  ( InputEvent.BUTTON1_MASK );
	        robot.mouseRelease( InputEvent.BUTTON1_MASK );
        robot.mouseMove( oldWhere.x, oldWhere.y );
    }
	/**@param delRow == -1 ... previous, +1 ... next, -Max ... first, +Max ... last*/
	void selectNavigateRow(final long delRow) {
		final int rowCount = getRowCount();
		if(rowCount <= 0)
			return;
		final int row = calcRow(delRow);
		if(0 <= row && row < rowCount)
			selectRow(row);
	}
	void selectRow(final int row) {selectCell(row, calcToBeSelectedColumn());}
	private int calcToBeSelectedColumn() {
		if(hasSelectedColumn() || !hasColumns())
			return getSelectedColumn();
		if(this.lastSelectedField == null)
			return 0;
		return getColumnModel().getColumnIndex(this.lastSelectedField);
	}
	private int calcToBeSelectedRow() {
		if(hasSelectedRow() || !hasRows())
			return getSelectedRow();	//try to stick with the old selection
		return getRowCount() - 1;	//last row (most up to date one) is default
	}
	private int calcRow(final long delRow) {
		final int rowCandidate = Convert.toInt(getSelectedRow() + delRow);
		if(rowCandidate < 0)
			return 0;
		if(rowCandidate >= getRowCount())
			return getRowLastIndex();
		return rowCandidate;
	}
	/**level Highlightin
 * @param column g*/
	void setRowColorToComponent(final int row, final int column,  final Component component) {
		final int modelRow = convertRowIndexToModel(row);
		final int modelCol = convertColumnIndexToModel(column);
		getModel().getLogSource()
				  .getAppColor(modelRow, modelCol)
				  .set(component);
	}
	void setDateFormat(final DateFormat dateFormat) {
		this.dateFormat = dateFormat;
		final List<AField<Date, L>> dateFields = getLogMsgModel().getDateFields();
		for (final AField<Date, L> dateField : dateFields) {
			final TableColumn column = getColumn(dateField);
			if(column == null)
				continue;		//noch nicht fertig initialisiert
			initTableColumnSize(column);
			fireTableColumnUpdated(column);
		}
	}
//-----------------------------------------------------------------------------

	@Override protected void createDefaultRenderers() {
		this.defaultRenderersByColumnClass = new UIDefaults(8, 0.75f);

		this.defaultRenderersByColumnClass.put(Object.class,		new LogTableCellRenderer<L, M>()		);
		this.defaultRenderersByColumnClass.put(Number.class,		new NumTableCellRenderer<L, M>()		);
		this.defaultRenderersByColumnClass.put(Throwable.class,	new ThrowableTableCellRenderer<L, M>()	);
		this.defaultRenderersByColumnClass.put(  Date.class, createDateRenderer());
//		setDefaultRenderer(Object.class, new LogTableCellRenderer<L, M>());
//		setDefaultRenderer(Number.class, new NumTableCellRenderer<L, M>());
//		setDefaultRenderer(  Date.class, createDateRenderer());
	}

	@Override public TableCellEditor getCellEditor(final int row, final int column) {
		if(getModel().canWriteSource())
			return super.getCellEditor(row, column);

		final Object value = getValueAt(row, column);
		if(value instanceof Throwable)
			return new DefaultCellEditor(new JComboBox(((Throwable)value).getStackTrace()));

		return new DefaultCellEditor(new JComboBox(value.toString().split("\n")));
	}
	//Implement table cell tool tips.
	@Override public String getToolTipText(final MouseEvent e) {
		final FieldPair pair = getPairByMouseEvent(e);
		return (pair == null) ? "" : pair.toString();
	}
	@Override protected JTableHeader createDefaultTableHeader() {
		return new JTableHeader(this.columnModel) {
			private static final long serialVersionUID = 1L;
	        @Override public String getToolTipText(final MouseEvent e) {
	            final int xPos = e.getPoint().x;
				final int index = this.columnModel.getColumnIndexAtX(xPos);
	            if(index < 0)
	            	return "###Huch### " + index;
	            final String name = this.columnModel.getColumn(index)
	            							   .getHeaderValue()
	            							   .toString();
	            final AField<?, L> field = getLogMsgModel().getField(name);
				final String tip = field.getDescription();
	            return tip;
	        }
	    };
	}
	@Override public LoggingTableModel<L,M> getModel() {
		return (LoggingTableModel<L, M>) super.getModel();
	}
	/**save for negative viewRow Indices*/
	@Override public int convertRowIndexToModel(final int viewRowIndex) {
		if(viewRowIndex < 0 || this.getModel().getLogSource().getSize() == 0)
			return -1;
		else
			try {
				return super.convertRowIndexToModel(viewRowIndex);
			} catch (final ArrayIndexOutOfBoundsException ex) {
//				final String msg = "Kann den viewRowIndex " + viewRowIndex
//								 + " nicht in den modelIndex umrechnen. Ignore";
//				Logger.SWFW.warn(msg, ex);
				return -1;
			}
	}
	public boolean isDirty(){return getModel().getLogSource().isDirty();}
//-----------------------------------------------------------------------------
	public M getLogMsgModel() {return getModel().getLogMsgModel();}
	/**@return the Column or if not existent null*/
	public TableColumn getColumn(final AField<?, L> field) {
		try {
			return (field != null) ? getColumn((Object) field) : null;
		} catch (final IllegalArgumentException e) {
			return null;	//Column existiert (im Moment) nicht
		}

	}
	/**pp, either FieldValuePair or FieldCommentPair*/
	FieldPair getPairBySelection() {
		final int column = this.getSelectedColumn();
		if(column < 0)
			return null;	//nothing selected

		final int rowInLogSource = convertRowIndexToModel(this.getSelectedRow());
		if(rowInLogSource < 0)
			return null;

		return getFieldPair(column, rowInLogSource);
	}
	private FieldPair getFieldPair(final int column, final int rowInLogSource) {
		final L message = getModel().getLogSource().getMessage(rowInLogSource);
		final AField<Serializable, L> field = getField(column);
		final M logMsgModel = getLogMsgModel();
		return logMsgModel.isComment(message) ?
				  new FieldCommentPair(field, logMsgModel.getComment(message))
				: new FieldValuePair  (field, field.get(message));
	}
	private AField<Serializable, L> getField(final int column) {
		return (AField<Serializable, L>) this.getColumnModel()
											 .getColumn(column)
											 .getIdentifier();
	}

//-----------------------------------------------------------------------------
	private DateFormat getDateFormat() {return this.dateFormat;}

	private TableCellRenderer createDateRenderer() {
		return new LogTableCellRenderer<L, M>(){
			private static final long serialVersionUID = 1L;
			@Override public void setValue(final Object value) {
				if(value instanceof Date)	//immer ausser wenn null
					setText(getDateFormat().format( (Date)value ));
				else
					setText("");
			}
		};
	}
	private FieldPair getPairByMouseEvent(final MouseEvent e) {
	    final java.awt.Point p = e.getPoint();
	    final int row = rowAtPoint(p);		if(row < 0)		return null;
	    final int col = columnAtPoint(p);	if(col < 0)		return null;
	    final int modCol = convertColumnIndexToModel(col);
	    									if(modCol < 0)	return null;
		return getFieldPair(col, row);
	}

	void initTableColumnSizes() {
        final int nCol = getColumnCount();
        if(nCol <= 0)
        	return;

        TableColumn widestColumn = getColumnModel().getColumn(0);
        int sumColWidth = 0;
        for(int iCol = 0; iCol < nCol; iCol++){
            final TableColumn column = getColumnModel().getColumn(iCol);
			initTableColumnSize(column);
			final int colWidth = column.getPreferredWidth();
			sumColWidth += colWidth;
			if(colWidth > widestColumn.getPreferredWidth())
				if(isStringColumn(column))
					widestColumn = column;
        }

        final Container parent = getParent();
        if(parent == null || parent.getWidth() <= 0)
        	return;

        final int   calcWidth = widestColumn.getPreferredWidth()
        					  + (parent.getWidth() - sumColWidth);
        final int  finalWidth = Math.max(parent.getWidth()/nCol, calcWidth);

        final int maxWidth = Math.max(100, widestColumn.getPreferredWidth() * 3);
		widestColumn.setPreferredWidth(Math.min(finalWidth, maxWidth));
    }
	private boolean isStringColumn(final TableColumn column) {
		return String.class.equals(((AField)column.getIdentifier()).getClazz());
	}
    /**Preferred Spaltenbreite Max Header und ersten Zeileneintrag*/
	private void initTableColumnSize(final TableColumn column) {
		final String title = column.getHeaderValue().toString();

		final int headerWidth = calcPrefWidthHeader("   " + title + "   ");
		final int   cellWidth = calcPrefWidthCells (column);

		column.setPreferredWidth(Math.min(MAX_COLUMN_INIT_WIDTH
										, Math.max(headerWidth, cellWidth))
								);
	}
	private int calcPrefWidthCells(final TableColumn column){
		final int iColModel = column.getModelIndex();
		final int iCol = convertColumnIndexToView(iColModel);
		final int rowCount = getRowCount();
		if( (iCol < 0) || (rowCount <= 0))
			return 5;	//no Entry

		final AField<Serializable, L> field = (AField<Serializable, L>) column.getIdentifier();
		final Class<Object> columnClass = (Class<Object> )getColumnClass(iCol);
		final int firstRow = 0;
		final int lastRow = calcLastRowAndTryToBeNonTrivial(rowCount, iColModel);
		final int cellWidth = Math.max(
				  calcPrefWidthCell(firstRow, iCol, field, columnClass)
				, calcPrefWidthCell( lastRow, iCol, field, columnClass)
				                      );
		return cellWidth + 5;
	}
	private int calcLastRowAndTryToBeNonTrivial(final int rowCount, final int iColModel) {
		final int lastRow = rowCount - 1;
		if(isNotTrivial(iColModel, lastRow))
			return lastRow;

		//need to search
		final int NROWS_TO_SCAN = 100;
		final int minRow = Math.max(0, lastRow - NROWS_TO_SCAN);
		for(int iCandidate = lastRow - 1; iCandidate >= minRow; iCandidate--)
			if(isNotTrivial(iColModel, iCandidate))
				return iCandidate;
		return lastRow;
	}
	private boolean isNotTrivial(final int iColModel, final int candidate) {
		final Object value = getModel().getValueAt(candidate, iColModel);
		return (value != null)
			&& (!value.toString().isEmpty());
	}
	private int calcPrefWidthCell(final int row
								, final int col
								, final AField<Serializable, L> field
								, final Class<Object> columnClass) {
		final Object entry = getValueAt(row, col);
		final Object value = field.getValueForPrefSize((Serializable)entry);
		final Component comp = getDefaultRenderer(columnClass)
									.getTableCellRendererComponent(
												   this
							 					 , value
							 					 , false
							 					 , false
							 					 , 0
							 					 , 0);
		final int cellWidth = comp.getPreferredSize().width;
		return cellWidth;
	}
	private int calcPrefWidthHeader(final String title) {
		return getTableHeader().getDefaultRenderer()
						 	   .getTableCellRendererComponent(this
						 			   						, title	//refValues
						 			   						, false	//isSelected
						 			   						, false	//hasFocus
						 			   						, 0		//row
						 			   						, 0)	//col
						 	   .getPreferredSize()
						 	   .width;
	}

	/**column may be null*/
	private void fireTableColumnUpdated(final TableColumn column) {
		if(column == null)
			return;		//nichts zu tun, da diese Spalte (im Moment) nicht exi.
		final LoggingTableModel<L, M> model = getModel();
		final TableModelEvent event =
			new TableModelEvent(model					//source
							  , 0						//first row
							  , Integer.MAX_VALUE		//last  row
							  , column.getModelIndex()
							  , TableModelEvent.UPDATE	//type
							   );
		model.fireTableChanged(event);
	}
	void ensureASelectedCell() {
		printCellSelectionInfo("  ensureASelectedCell");
		if(hasSelectedColumn()){
			this.lastSelectedField = getField(calcToBeSelectedColumn());
			if(hasSelectedRow())
				return;
		}
		selectCell(calcToBeSelectedRow(), calcToBeSelectedColumn());
	}
	/**debug helper*/
	void printCellSelectionInfo(final String routine) {
		if(System.currentTimeMillis() > Long.MIN_VALUE/*true*/)	//turn debug info off
			return;
		System.out.println(routine + "()\t"
						 + " selectedRow = "    + getSelectedRow()
						 + " selectedColumn = " + calcToBeSelectedColumn()
						 + " rowLastIndex = "   + getRowLastIndex()
						 + " lastSelectedField = "   + this.lastSelectedField
						 + " pair = " + getPairBySelection()
				 );
	}
	private boolean hasRows() 			{return getRowCount() > 0;}
	private boolean hasSelectedRow()	{return getSelectedRow() >= 0;}
	private int getRowLastIndex()		{return getRowCount() - 1;}

	private boolean hasSelectedColumn()	{return getSelectedColumn() >= 0;}
	private boolean hasColumns() 		{return getColumnCount() > 0;}
	void doSelectionPreservingTotalDataRefresh() {
		final int row = getSelectedRow();
		final int col = getSelectedColumn();
		getRowSorter().allRowsChanged();
		getModel().fireTableDataChanged();
		selectCell(row, col);
	}
}	//END LogginTable

//=============================================================================
/**L Typ der LogMsg, M Typ von AMsgModel*/
@SuppressWarnings({"unchecked"})
class LoggingTableModel<L, M extends AMsgModel<L>> extends AbstractTableModel {
	private static final long serialVersionUID = 1L;
	private final ALogSource<L, M> logSource;
//-----------------------------------------------------------------------------
	public LoggingTableModel(final ALogSource<L, M> logSource) {
		this.logSource = logSource;
	}
	//-----------------------------------------------------------------------------
	@Override public String getColumnName(final int columnIndex) {
		return getField(columnIndex).getName();
	}
	@Override public Class<?> getColumnClass(final int columnIndex) {
		return getField(columnIndex).getClazz();
	}
//-----------------------------------------------------------------------------
	/* (non-Javadoc)
	 * @see javax.swing.table.TableModel#getColumnCount()
	 */
	@Override public int getColumnCount() 		{return getLogMsgModel().getSize();}
	/* (non-Javadoc)
	 * @see javax.swing.table.TableModel#getRowCount()
	 */
	@Override public int getRowCount() {return getLogSource().getSize();}

	/* (non-Javadoc)
	 * @see javax.swing.table.TableModel#getValueAt(int, int)
	 */
	@Override public Serializable getValueAt(final int rowIndex, final int columnIndex) {
		if(rowIndex >= getRowCount())
			return null;
		final L logMsg  = getLogSource().getMessage(rowIndex);
		final Object element = getField(columnIndex).get(logMsg);
		return (Serializable) element;
	}
	/* (non-Javadoc)
	 * @see javax.swing.table.AbstractTableModel#isCellEditable(int, int)
	 */
	@Override public boolean isCellEditable(final int rowIndex, final int columnIndex) {
		if(canWriteSource())
			return true;

		final AField<Serializable, L> field = getField(columnIndex);
		return field.mightBeMultiline()
			&& field.mightBeMultiline(getValueAt(rowIndex, columnIndex));
	}

	/* (non-Javadoc)
	 * @see javax.swing.table.AbstractTableModel#setValueAt(java.lang.Object, int, int)
	 */
	@Override public void setValueAt(final Object value, final int row, final int col) {
		if(!canWriteSource()){
			Logger.SWFW.debug("LoggingTableDisplay LoggingTableModel.setValueAt versuche Feld zu schreiben ohne schreibbare LogSource.");
			return;	//Editior for Display only
		}

		final AField<Serializable, L> field = getField(col);
		getLogSource().getWriter().setValueAt((Serializable)value, row, field);
		fireTableCellUpdated(row, col);
	}
	//-----------------------------------------------------------------------------
	final ALogSource<L, M> getLogSource() {return this.logSource;}
	boolean canWriteSource() {return getLogSource().canWrite();}
	AField<Serializable, L> getField(final int columnIndex) {
		final AField<?, L> field = getLogMsgModel().getField(columnIndex);
		return (AField<Serializable, L>)field;
	}
	M getLogMsgModel(){return getLogSource().getMsgModel();}
}	//END LoggingTableModel

//=============================================================================

/**
 * Idea: FilterHandler Stuff hier kapseln (Die Klasse ist einfach riesig
 */
final class FilterHandler<L, M extends AMsgModel<L>>{
	private final LoggingTableDisplay<L, M> loggingTableDisplay;
	private final FilterPanel filterPanel;
//-----------------------------------------------------------------------------
	public FilterHandler(final LoggingTableDisplay<L, M> loggingTableDisplay) {
		super();
		this.loggingTableDisplay = loggingTableDisplay;
		getRowFilter(getTable()).setFilter(getHauptFilter());
		this.filterPanel = new FilterPanel();
	}
//-----------------------------------------------------------------------------
	/**not null*/
	public FilterPanel getFilterPanel() {return this.filterPanel;}
//-----------------------------------------------------------------------------

	private LogRowFilter getRowFilter(final JTable table) {
		final DefaultRowSorter<?, ?> sorter = getSorter(table);
		return (LogRowFilter)(sorter).getRowFilter();
	}
	@SuppressWarnings("unchecked")
	private TableRowSorter<TableModel> getSorter(final JTable table) {
		return (TableRowSorter<TableModel>)table.getRowSorter();
	}
	private void setRowFilter(final JTable table, final LogRowFilter rowFilter) {
		final TableRowSorter<? extends TableModel> sorter =
				(TableRowSorter<? extends TableModel>) table.getRowSorter();
		sorter.setRowFilter(rowFilter);
	}
	private final LoggingTableDisplay<L, M> getLoggingTableDisplay() {return this.loggingTableDisplay;}
	private final LoggingTable<L, M> getTable() 	{
		return getLoggingTableDisplay().getTable();
	}
	private LoggingTableModel<L, M> getModel() {
		return getLoggingTableDisplay().getModel();
	}
	private final HauptFilter  getHauptFilter()	{return getLoggingTableDisplay().getHauptFilter();}
	private FieldPair getPairBySelection() {return getTable().getPairBySelection();}

	/**loescht den gesamten Filter*/
	private void clearFilter(){
		getHauptFilter().clear();
		onFilterChange();
	}
	/**turns the filter off/on ohne ihn zu loeschen*/
	private final void dispenseFilter(final boolean dispense){
		getHauptFilter().setDispenseFilter(dispense);
		getFilterPanel().dispenseFilterUI(dispense);
	}
	private void onFilterChange() {
		applyFilterToTable();
		getFilterPanel().onFilterChangeUIUpdate();
	}
	void applyFilterToTable() {
		final LoggingTable<L, M> table = getTable();
		table.getModel()
			 .getLogSource()
			 .onFilterChanged(getHauptFilter(), table);
		setRowFilter(table, getRowFilter(table));
		getTable().getModel().fireTableDataChanged();
	}

	//Internal Classes to internal Class FilterHandler=====================
	@SuppressWarnings({"rawtypes", "unchecked"})
	class FilterPanel extends JPanel{
		private static final String FFE = "FFE";
		private static final long serialVersionUID = 1L;
		private static final String TOOLBAR_TITEL = "Tabellen Steuerung";
		//---------------------------------------------------------------------
		private final JToolBar toolBar;
		private final JButton jbFilterEdit;
		private final JButton jbFilterSelect;
		private final JButton jbFilterNotSelect;
		private final JButton jbFilterClear;
		private final JCheckBox	cbFilterEin;
		private final JLabel 	jlFilterBeschreibung;
		private final Set<Component> disabledCmpInEditMode = new HashSet<Component>();
		private EditorPanel 	editorPanel;
		//---------------------------------------------------------------------
		public FilterPanel(){
			super();
			this.cbFilterEin	= createCBFilterEin();
			updateCbFilterEin();

			final boolean INVERTED = true;
			this.jbFilterEdit		= GUIFactory.createImageButton("filter/editFilter24.gif", 	"Filter editieren",		createListenerFilterEdit(),			  this.getClass());
			this.jbFilterSelect		= GUIFactory.createImageButton("filter/selFilter24.gif",  	"Auswahl herausfiltern",createListenerFilterSelect(!INVERTED),this.getClass());
			this.jbFilterNotSelect	= GUIFactory.createImageButton("filter/selNotFilter24.gif",	"Auswahl wegfiltern",	createListenerFilterSelect( INVERTED),this.getClass());
			initJBFilterSelect();
			this.jbFilterClear	= GUIFactory.createImageButton("filter/unFilter24.gif",   "Filter lschen",		createListenerFilterClear(), this.getClass());
			this.jlFilterBeschreibung = new JLabel("Kein konfigurierter Filter");
			updateJLFilterBeschreibung();

			this.toolBar = createToolBar(createJBSave()
									   , createJBPrint()
									   , new JToolBar.Separator()
									   , GUIFactory.createImageButton("filter/reloadData24.gif", "Daten neu laden", createListenerReloadData(), this.getClass())
									   , createCBAutoUpdate()
									   , new JToolBar.Separator()
									   , getJbFilterEdit()
									   , getJbFilterSelect()
									   , getJbFilterNotSelect()
									   , getJbFilterClear()
									   , getCbFilterEin()
									   , new JToolBar.Separator()
									   , getJlFilterBeschreibung()
									    );

			this.setLayout(new BorderLayout());
			this.setBorder(GUIFactory.createTitledBorder(TOOLBAR_TITEL));

			this.add(getToolBar(), 	BorderLayout.NORTH);

			if(hasLogSourceAccessory())
				this.add(createToolBar(getLogSourceAccessory()), BorderLayout.SOUTH);

			addToDisabledComponentsInEditMode(getJbFilterEdit()
											, getJbFilterClear()
											, getCbFilterEin()
											, getJlFilterBeschreibung()
											);
		}
		private Component getLogSourceAccessory() {
			return getTable().getModel().getLogSource().getAccessory();
		}
		private boolean hasLogSourceAccessory() {
			return getLogSourceAccessory() != null;
		}
		private JCheckBox createCBAutoUpdate() {
			final JCheckBox cb = new JCheckBox("Auto Update");
			final IAAServer<L> aaSrv = getLogSource().getAutoAppendServer();
			final boolean supportsAutoAppend = aaSrv.supportsAutoAppend();
			if(supportsAutoAppend)
				cb.addItemListener(new ItemListener() {
					final IAAClient<L> client = new IAAClient<L>() {
						final Runnable update = () ->
						{
							getTable().doSelectionPreservingTotalDataRefresh();
//							final String msg = this.getClass().getName() + "appendNNew update() executed";
//							Logger.SWFW.debug(msg);
						};
						final _GUIUpdateThrottle throttle = new _GUIUpdateThrottle(this.update);
						@Override public void onNewEntries(final List<L> entries) {
							appendNNew(entries.size());
						}
						@Override public void onNewEntry(final L entry) {
							appendNNew(1);
						}
						private void appendNNew(final int nNew) {
							this.throttle.update();
//							SwingUtilities.invokeLater(new Runnable(){
//								@Override public void run() {
//									getTable().doSelectionPreservingTotalDataRefresh();								}
//							});
						}
					};
					@Override public void itemStateChanged(final ItemEvent evt) {
						final int stateChange = evt.getStateChange();
						if(stateChange == ItemEvent.SELECTED)
							aaSrv.register(this.client);
						else if( stateChange == ItemEvent.DESELECTED)
							aaSrv.deregister(this.client);
					}
				});
			cb.setEnabled (supportsAutoAppend);
			cb.setSelected(false);
			return cb;
		}
		private void addToDisabledComponentsInEditMode(final Component ... cmps) {
			final Set<Component> set = getDisabledComponentsInEditMode();
			for (final Component cmp : cmps)
				set.add(cmp);
		} 
		private JButton createJBSave() {
			if(!getLogSource().canWrite()) {
				final String tttCantWrite = createJBSaveTTT("die Daten knnen nicht editiert werden");
				final JButton jbCantWrite = GUIFactory.createImageButton("save_cant24.png", tttCantWrite, null, this.getClass());
				jbCantWrite.setEnabled(false);
				return jbCantWrite;
			}


			final LoggingTableModel<L, M> tableModel = getTable().getModel();
			final ActionListener listener = new ActionListener(){
				@Override public void actionPerformed(final ActionEvent evt){
					LoggingTable.saveViaGui(FilterPanel.this, tableModel);
				}
			};
			final String tttDatenOri = createJBSaveTTT("sind noch unverndert");
			final String tttDatenNeu = createJBSaveTTT("sind verndert");
			final JButton jb = GUIFactory.createImageButton("save24.png", tttDatenOri, listener, this.getClass());
			final ILogSourceWriter<L> writer = getLogSource().getWriter();
			jb.setEnabled(writer.isDirty());
			tableModel.addTableModelListener(new TableModelListener(){
				@Override public void tableChanged(final TableModelEvent evt) {
					jb.setEnabled(writer.isDirty());
					jb.setToolTipText(writer.isDirty()? tttDatenNeu : tttDatenOri);
				}
			});
			return jb;
		}
		private JButton createJBPrint() {
			final String toolTip = "Die ganze Tabelle ausdrucken (sichtbarer und so vorhanden unsichtbarer Teil).";
			final ActionListener listener = new ActionListener(){
				@Override public void actionPerformed(final ActionEvent evt){
					final String documentName = getLogSource().getBezeichnung();
					final MessageFormat headerFormat = null;
					final MessageFormat footerFormat = new MessageFormat("Quelle: \"" + documentName + "\"\t - {0} -");
					final HashPrintRequestAttributeSet attr = new HashPrintRequestAttributeSet();
					attr.add(OrientationRequested.LANDSCAPE);
					attr.add(new JobName("Tabelle: " + documentName, null));
					try {
						final boolean notCanceled = getTable().print(JTable.PrintMode.FIT_WIDTH, headerFormat, footerFormat, true, attr, true);
						Logger.SWFW.info("LoggingTableDisplay Ausdruck von: " + documentName + (notCanceled ? "" : " CANCELED"));
					} catch (final PrinterException ex) {
						final String msg = "LoggingTableDisplay: Kann " + documentName + " nicht drucken: " + ex;
						Logger.SWFW.error(msg);
						JOptionPane.showMessageDialog(getFilterPanel(), msg);
					}
				}
			};
			return GUIFactory.createImageButton("print24.gif", toolTip, listener, this.getClass());
		}
		private ALogSource<L, M> getLogSource() {
			return getModel().getLogSource();
		}
		private String createJBSaveTTT(final String spezifikation) {
			return "Daten speichern (" + spezifikation + ").";
		}
		//---------------------------------------------------------------------
		public void onFilterChangeUIUpdate() {
			updateCbFilterEin();
			updateJLFilterBeschreibung();
		}
		/**must NOT be in EditMode*/
		private void transitToEditmode() {
			if(isInEditMode())
				Logger.SWFW.warn(new IllegalStateException("Already in EditMode."));
			recreateEditorPanel(getHauptFilter());//ensure isInEditMode() == true
			updateComponentEnablement();
		}
		/**must BE in EditMode*/
		private void transitFromEditMode() {
			if(!isInEditMode())
				Logger.SWFW.warn(new IllegalStateException("Not in EditMode."));
			setEditorPanel(null);	//ensure isInEditMode() == false

			updateComponentEnablement();
			onFilterChangeUIUpdate();
			getTable().getSelectionModel().setSelectionInterval(0, 0);
		}
		private void updateComponentEnablement() {
			final boolean b = !isInEditMode();
			final Set<Component> cmpts = getDisabledComponentsInEditMode();
			for (final Component component : cmpts) {
				component.setEnabled(b);
			}
			onNewSelectedPair(getPairBySelection());
		}
		/**All Components with: cmp.isEnabled() == !isInEditMode()*/
		private Set<Component> getDisabledComponentsInEditMode() {return this.disabledCmpInEditMode;}
		private void recreateEditorPanel(final AndOfFieldsFilter andOfFieldsFilter) {
			setEditorPanel(new EditorPanel(new AndOfFieldsFilter(andOfFieldsFilter)));
		}
		private void updateCbFilterEin() {
			__EDTBuster.outputDiagnosticsIfUnexpectedThread();
			final JCheckBox cb = getCbFilterEin();
			cb.setEnabled(getHauptFilter().koennteFiltern() && !isInEditMode());
			if(!getHauptFilter().filtert())
				cb.setSelected(false);
		}
		private void updateJLFilterBeschreibung() {
			final JLabel label = getJlFilterBeschreibung();
			final boolean istKonfiguriert = getHauptFilter().koennteFiltern();
			final String beschreibung = istKonfiguriert ?
								"Filter: " + getHauptFilter().getBeschreibung()
							  : "Der Filter ist nicht konfiguriert.";
			label.setEnabled(getCbFilterEin().isEnabled());
			label.setText(beschreibung);
			label.setToolTipText(beschreibung);
		}
		private void dispenseFilterUI(final boolean dispense) {
			getCbFilterEin().setSelected(!dispense);
		}
		//---------------------------------------------------------------------
		private final EditorPanel getEditorPanel() {return this.editorPanel;}
		private final boolean isInEditMode() {return getEditorPanel() != null;}
		private void setEditorPanel(final EditorPanel editorPanel) {
			final EditorPanel oldPanel = getEditorPanel();
			if(oldPanel == editorPanel)
				return;
			if(oldPanel != null)
				this.remove(oldPanel);
			this.editorPanel = editorPanel;
			if(editorPanel != null){
				this.add(editorPanel, BorderLayout.CENTER);
			}
		}
		private final JToolBar 	getToolBar() 		{return this.toolBar;}
		private final JButton	getJbFilterClear()	{return this.jbFilterClear;}
		private final JButton	getJbFilterSelect()	{return this.jbFilterSelect;}
		private final JButton	getJbFilterNotSelect(){return this.jbFilterNotSelect;}
		private final JButton	getJbFilterEdit()	{return this.jbFilterEdit;}
		private final JCheckBox	getCbFilterEin()	{return this.cbFilterEin;}
		private final JLabel getJlFilterBeschreibung() {
			return this.jlFilterBeschreibung;
		}

		private JToolBar createToolBar(final Component ...components) {
			final JToolBar toolBar = new JToolBar(TOOLBAR_TITEL);
			toolBar.setRollover(true);
			toolBar.setAlignmentX(Component.LEFT_ALIGNMENT);
			for (final Component component : components)
				if(component != null)
					toolBar.add(component);
			return toolBar;
		}
		private JCheckBox createCBFilterEin() {
			final JCheckBox cbFilterEin;
			cbFilterEin = new JCheckBox("Filter ein");
			cbFilterEin.addItemListener(new ItemListener(){
				@Override public void itemStateChanged(final ItemEvent e) {
					final boolean dispense = (e.getStateChange() == ItemEvent.DESELECTED);
					if(dispense == getHauptFilter().isDispenseFilter())
						return;
					dispenseFilter(dispense);
					onFilterChange();
				}
			});
			return cbFilterEin;
		}

		private ActionListener createListenerReloadData(){
			return new ActionListener(){
				@Override public void actionPerformed(final ActionEvent evt){
					final Runnable runnable = new Runnable(){@Override public void run() {doReload();}};
					GUIFactory.runInExtraThread_showingBusyDialog(runnable, FilterPanel.this, "Neu Laden: " + getLogSource().getBezeichnung(), true);
				}
				private void doReload() {
					try {
						getLogSource().reloadAllData();
						SwingUtilities.invokeLater(new Runnable() {
							@Override public void run() {getTable().getModel().fireTableDataChanged();}
						});
					} catch (final IOException ex) {
						final String msg = "Kann " + getLogSource()
										 + " nicht neu laden: " + ex;
						Logger.SWFW.error(msg);
						JOptionPane.showMessageDialog(getFilterPanel(), msg);
					}
				}
			};
		}

		private ActionListener createListenerFilterEdit(){
			return new ActionListener(){
				@Override public void actionPerformed(final ActionEvent e){transitToEditmode();}
			};
		}
		private ActionListener createListenerFilterClear(){
			return new ActionListener(){
				@Override public void actionPerformed(final ActionEvent e) {
					clearFilter();
					applyFilterToTable();
				}
			};
		}
		private ActionListener createListenerFilterSelect(final boolean inverted) {
			return new ActionListener(){
				@Override public void actionPerformed(final ActionEvent evt) {
					addSelectionValue(((JButton) evt.getSource()).getClientProperty(FFE));
				}
			};
		}
		private void addSelectionValue(final Object ffeCandidate) {
			if(!(ffeCandidate instanceof AFFE))
				return;

			final AFFE ffe = (AFFE)ffeCandidate;
			final AField field = ffe.getField();
			final HauptFilter hauptFilter = getHauptFilter();
			if(!hauptFilter.contains(field))
				hauptFilter.add(field.createFieldFilter(getTable()));
			hauptFilter.get_(field).add(ffe);
			dispenseFilter(false);
			onFilterChange();
		}
		private void initJBFilterSelect() {
			final PropertyChangeListener lCSel = new PropertyChangeListener(){
				@Override public void propertyChange(final PropertyChangeEvent evt) {
					onNewSelectedPair(   (FieldPair) evt.getNewValue()   );
				}
			};
			getLoggingTableDisplay().addPropertyChangeListener(LoggingTableDisplay.KEY_TABLE_CELL_SELECTION, lCSel);

			final PropertyChangeListener lSubString = new PropertyChangeListener(){
				@Override public void propertyChange(final PropertyChangeEvent evt) {
					onNewSelectedPair(   (FieldPair) evt.getNewValue()   );
				}
			};
			getLoggingTableDisplay().addPropertyChangeListener(LoggingTableDisplay.KEY_TABLE_CELL_SUB_SELECTION, lSubString);
		}
		private void onNewSelectedPair(final FieldPair pair) {
			getTable().printCellSelectionInfo("    onNewSelectedPair " + pair);

			final boolean inEditMode = isInEditMode();
			final JButton[] buttons  = {getJbFilterSelect(), getJbFilterNotSelect()};
			final boolean[] inverted = {false, true};
			final boolean[] enabled  = {(pair != null), (pair != null) && pair.supportsInverted()};
			for (int i = 0; i < buttons.length; i++) {
				final JButton but = buttons[i];
				but.setEnabled       (!inEditMode && enabled[i]);
				but.setToolTipText   (      calcSafeTTT  (inEditMode, pair, inverted[i]) );
				but.putClientProperty( FFE, createSafeFFE(inEditMode, pair, inverted[i]) );
			}

			if((pair != null) && !pair.supportsInverted()) {
				final String notSupported =
					"" + pair.getField() + " untersttzt keine invertierte Auswahl.";
				getJbFilterNotSelect().setToolTipText(notSupported);
			}
		}
		private String calcSafeTTT(final boolean inEditMode, final FieldPair pair, final boolean inverted) {
			if(inEditMode)
				return "Im Editier Modus keine Schnellfilter.";
			if(pair == null)
				return "";
			return pair.calcTTT(inverted);
		}
		private AFFE createSafeFFE(final boolean inEditMode, final FieldPair pair, final boolean inverted) {
			if(inEditMode || (pair == null))
				return null;
			return pair.createFFE(inverted);
		}

		//=====================================================================
		class EditorPanel extends JPanel{
			private static final long serialVersionUID = 1L;
			private final AndOfFieldsFilter editFilter;
			private final JLabel jlEditFilterBeschreibung;
			private final JTextArea taEditFilterWarning;
			//-----------------------------------------------------------------
			public EditorPanel(final AndOfFieldsFilter editFilter) {
				this.editFilter = editFilter;
				this.jlEditFilterBeschreibung = new JLabel("Editierter Filter:");
				this.jlEditFilterBeschreibung.setForeground(Color.GRAY);
				this.taEditFilterWarning = createTAEditFilterWarning();

				this.setLayout(new BorderLayout());
				this.setBorder(GUIFactory.createTitledBorder("Filter Editierer"));

				this.add(createEditPanel_Dokus(),		BorderLayout.NORTH);
				this.add(createEditPanel_Fields(), 		BorderLayout.CENTER);
				this.add(createEditPanel_Controls(),	BorderLayout.SOUTH);

				onEditFilterChange();
			}
			//-----------------------------------------------------------------
			public final AndOfFieldsFilter getEditFilter() {
				return this.editFilter;
			}
			private final JLabel getJlEditFilterBeschreibung() {
				return this.jlEditFilterBeschreibung;
			}
			public final JTextArea getTaEditFilterWarning() {
				return this.taEditFilterWarning;
			}
			public void onEditFilterChange() {
				updateJLEditFilterBeschreibung();
				updateTAEditFilterWarning(getEditFilter().getProblems());
			}
			public LoggingTable<?, ?> getTable_() {
				final Object object = getTable();
				return (LoggingTable<?, ?>) object;
			}
			public void updateTAEditFilterWarning(final String problems) {
				final JTextArea taEditFilterWarning = this.taEditFilterWarning;
				taEditFilterWarning.setVisible(!problems.isEmpty());
				taEditFilterWarning.setText(problems);
				taEditFilterWarning.setRows(countRows(problems));
			}

			//-----------------------------------------------------------------
			private int countRows(final String text) {
				int n = 0;
				int fromIndex = -1;
				do {
					n++;
					fromIndex = text.indexOf("\n", fromIndex + 1);
				} while (fromIndex >= 0);
				return n;
			}
			private void updateJLEditFilterBeschreibung() {
				final JLabel label = getJlEditFilterBeschreibung();
				final String beschreibung = getEditFilter().getBeschreibung();
				label.setText(beschreibung);
				label.setToolTipText(beschreibung);
			}

			private JTextArea createTAEditFilterWarning() {
				final JTextArea ta = new JTextArea("Alles OK.");
				AppColor._FEHLER.set(ta);
				//MONOSPACED damit multiline RegEx Hilfe "well aligned" ist
				final int size = ta.getFont().getSize();
				ta.setFont(new Font(Font.MONOSPACED, Font.PLAIN, size));
				return ta;
			}
			private Component createEditPanel_Dokus() {
				final JPanel panel = new JPanel(new BorderLayout());
				panel.add(getJlEditFilterBeschreibung(), 	BorderLayout.NORTH);
				panel.add(getTaEditFilterWarning(),    		BorderLayout.SOUTH);
				return panel;
			}
			private Container createEditPanel_Fields() {
				final JPanel panel = new JPanel(new BorderLayout());
				final boolean doWide = true;
				panel.add(createEditPanel_Fields(!doWide, BoxLayout.X_AXIS), BorderLayout.CENTER);
				panel.add(createEditPanel_Fields( doWide, BoxLayout.Y_AXIS), BorderLayout.SOUTH );
				return panel;
			}
			private Container createEditPanel_Fields(final boolean doWide, final int axis) {
				final JPanel panel = new JPanel();
				panel.setLayout(new BoxLayout(panel, axis));

				final TableColumnModel columnModel = getTable().getColumnModel();
				JPanel oldCmpt = null;
				addStrut(axis, panel);
				for (int col = 0; col < columnModel.getColumnCount(); col++) {
					final TableColumn column = columnModel.getColumn(col);
					final AField<Serializable, L> field = (AField<Serializable, L>)column.getIdentifier();
					final AFieldFilterGUIFactory<Serializable, L, AMsgModel<L>> fieldFilterFactory = field.getFieldFilterGUIFactory();
					if(fieldFilterFactory.isWideEditor() == doWide){
						final JPanel cmpt = fieldFilterFactory.create(field, this);
						if(oldCmpt != null)
							addStrut(axis, panel);
						if(cmpt != null){
							cmpt.setAlignmentX(Component.LEFT_ALIGNMENT);
							panel.add(cmpt);
						}
						oldCmpt = cmpt;
					}
				}
				return panel;
			}
			private void addStrut(final int axis, final JPanel panel) {
				final Component cmp = (axis == BoxLayout.X_AXIS)
											? Box.createHorizontalStrut(5)
											: Box.createVerticalStrut(5);
				panel.add(cmp);
			}
			public <E> E getValue(final JList list, final int index) {
				return (E) list.getModel().getElementAt(index);
			}

			private Component createEditPanel_Controls() {
				final JPanel panel = new JPanel();
				panel.setLayout(new BoxLayout(panel, BoxLayout.X_AXIS));
				panel.setAlignmentX(Component.RIGHT_ALIGNMENT);
				panel.add(Box.createHorizontalGlue());
				panel.add(createEditPanel_Cts_Cancel() );
				panel.add(createEditPanel_Cts_Reset () );
				panel.add(createEditPanel_Cts_Clear () );

				panel.add(Box.createHorizontalStrut(20));

				panel.add(createEditPanel_Cts_Apply () );
				panel.add(createEditPanel_Cts_OK    () );
				return panel;
			}
			private JButton createEditPanel_Cts_Cancel() {
				final JButton button = new JButton("abbrechen");
				button.setMnemonic('b');
				button.addActionListener(new ActionListener(){
					@Override public void actionPerformed(final ActionEvent e) {transitFromEditMode();}
				});
				return button;
			}
			private JButton createEditPanel_Cts_Reset() {
				final JButton button = new JButton("zurcksetzen");
				button.setMnemonic('z');
				button.addActionListener(new ActionListener(){
					@Override public void actionPerformed(final ActionEvent e) {
						recreateEditorPanel(getHauptFilter());
					}
				});
				return button;
			}
			private JButton createEditPanel_Cts_Clear() {
				final JButton button = new JButton("lschen");
				button.setMnemonic('l');
				button.addActionListener(new ActionListener(){
					@Override public void actionPerformed(final ActionEvent e) {
						recreateEditorPanel(new AndOfFieldsFilter());
					}
				});
				return button;
			}
			private JButton createEditPanel_Cts_Apply() {
				final JButton button = new JButton("anwenden");
				button.setMnemonic('a');
				button.addActionListener(new ActionListener(){
					@Override public void actionPerformed(final ActionEvent e) {
						doApplyEditierterFilter();
						recreateEditorPanel(getHauptFilter());
					}
				});
				return button;
			}
			private JButton createEditPanel_Cts_OK() {
				final JButton button = new JButton("OK");
				button.setMnemonic('K');
				button.addActionListener(new ActionListener(){
					@Override public void actionPerformed(final ActionEvent e) {
						doApplyEditierterFilter();
						transitFromEditMode();
					}
				});
				return button;
			}
			private void doApplyEditierterFilter() {
				__EDTBuster.outputDiagnosticsIfUnexpectedThread();
				final Cursor oldCursor = GUIFactory.setCursor(
								  Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR)
								, this);
				final AndOfFieldsFilter editFilter = getEditFilter();
				getHauptFilter().setFilter(editFilter);
				dispenseFilter(!editFilter.filtert());
				onFilterChange();
				GUIFactory.setCursor(oldCursor, this);
			}
		}// END EditorPanel
	}// END FilterPanel
}//END FilterHandler

//=============================================================================

/**
* Idee: LogginTableDisplay graphics sollte jenseits des XTors nur im EDT
* 		Thread angesprochen werden. Diese Klasse nur fuer diese JLoggingTable
* 		Datei liefert konfigurierbares Feedback im Problemfall.
*/
final class __EDTBuster{
	static final    long maxOutput = 10;	//maximum number of times an output is printed
	static volatile long iOutput   =  0;	//actual  number of times an output is printed
	static volatile boolean inConstruction = false;	//XTor can be in any thread
	static final void outputDiagnosticsIfUnexpectedThread(){
		if(	  inConstruction
		   || !( iOutput < maxOutput)
		   || SwingUtilities.isEventDispatchThread())
			return;	//nothing to do everything is as expected

		iOutput++;
		final String msg = "Expected EDT but is: '" + Thread.currentThread().getName() + "'.";
		final IllegalStateException throwable = new IllegalStateException(msg);
		System.err.println("\n\n===START======================================");
		throwable.printStackTrace();	//falls LoggingSystem hngt
		//Logger.SWFW.warn(throwable);
		System.err.println("===END========================================\n\n");
	}
}
