/**
 * 	Jun  2, 2009 - Jul  6, 2009	ws:	Creation from scratch
 */
package de.desy.mst.libs.framework.mstapp.logging.map_tinelogsrv;

import de.desy.mst.libs.framework.mstapp.Main;
import de.desy.mst.libs.framework.mstapp.logging.appender.IWriter;
import de.desy.tine.server.equipment.TEquipmentModuleFactory;
import de.desy.tine.server.logger.ClsLog;

/**
 * Schreibt nach Tine, einzige Klasse im Paket mit explizitem Tine Zugriff
 * (-> tine.jar Abhngigkeit, -> Initialisierungsoverhead von Tine in Tests)
 * @author ws
 * @version 1.0.0
 */
class __ClsLogInfoAppender_Tine  implements IWriter<ClsLogInfo> {
	private static final String FALLBACK_CONTEXT = "Service";
	private static final String DEFAULT_CONTEXT  = calcDefaultContext();
//-----------------------------------------------------------------------------
	private static String calcDefaultContext() {
		final String tineDefault = TEquipmentModuleFactory.getInstance()
														  .getFecContext();
		return tineDefault == null ? FALLBACK_CONTEXT : tineDefault;
	}
//=============================================================================
	public final String getDefaultContext() {return DEFAULT_CONTEXT;}
	/* (non-Javadoc)
	 * @see de.desy.mst.libs.framework.mstapp.logging.appender.IWriter#doWrite(java.lang.Object)
	 */
	@Override public void doWrite(final ClsLogInfo info) {
		//(1) Do not wait for Tine
		//(2) unbuffered d.h. implizite Voraussetzung niedrige Logging Aktivitt
		//    zum Tine Server
		Main.getExecutorService().submit(new Runnable(){
			@Override public void run() {
				ClsLog.log(info.text
						 , info.context == null ? getDefaultContext() : info.context
						 , info.tag
						 , info.callerLogger
						 , info.priority
						 , info.status);
			}
		});
	}
}
