/**
 * ?????????  - ??????????  Wst: creation from scratch
 * 2007-02-13 - 2007-02-16	ws: Anschluss an das System
 */

package de.desy.mst.libs.framework.mstapp.mode;

import de.desy.mst.libs.framework.mstapp.preferences.IPrefContainer;
import de.desy.mst.libs.framework.mstapp.preferences.helper.APrefClientPanelEinfach;
import de.desy.mst.libs.framework.mstapp.preferences.helper.APreferences;

/**
 * Preferences fuer Opmodes nichtgrafischer Teil
 * @author wst, ws
 * version 1.0.0
 */
public class PrefOperationMode extends APreferences{
	private static final String   TITLE    = "Operations Modus";
	private static final String[] KEYWORDS = new String[]
                    {"Modus", "Operating", "Betrieb", "Expert", "Betrachten"};
	private final OpModeMgr       opModeMgr;
	private final ServerAnwahlMgr serverAnwahlMgr;
//=============================================================================	
	/**
	 * @param  serverAnwahlMgr not null
	 * @param  opModeMgr not null
	 * @throws NullPointerException, falls opModeMgr || serverAnwahlMgr == null
	 */
	public PrefOperationMode(final ServerAnwahlMgr serverAnwahlMgr
						   , final OpModeMgr       opModeMgr) {
		super(TITLE, null, KEYWORDS);
		if(serverAnwahlMgr == null) {throw new NullPointerException("ServerAnwahlMgr");}
		if(opModeMgr       == null) {throw new NullPointerException("OpModeMgr");}
		this.serverAnwahlMgr = serverAnwahlMgr;
		this.opModeMgr 		 = opModeMgr;
	}
//=============================================================================	
	@Override public APrefClientPanelEinfach createPrefClientPanel(final IPrefContainer prefContainer) {
		return new PrefOperationModePanel(prefContainer, this.opModeMgr, this.serverAnwahlMgr);
	}
} 
