/*
 * ws:	May 14, 2007 - May 15, 2007	changed:createPrefClientPanel() better Signature
 * 											onNewPrefString not final
 * ws:	Sep 29, 2008 - Sep 29, 2008	replaced reference by PrefManager
 * 									inherits from APrefClientPanelEinfach statt JPanel
 * ws: 	Oct 14, 2008 - Oct 14, 2008	no Logger.SWFW.debug output anymore
 */
package de.desy.mst.libs.framework.mstapp.preferences.implementation;

import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Set;

import javax.swing.BoxLayout;
import javax.swing.DefaultComboBoxModel;

import de.desy.mst.libs.framework.mstapp.preferences.IPrefContainer;
import de.desy.mst.libs.framework.mstapp.preferences.IPreferences;
import de.desy.mst.libs.framework.mstapp.preferences.helper.APrefClientPanelEinfach;

import javax.swing.JComboBox;

@SuppressWarnings({"rawtypes", "unchecked"})
public class PrefGeneralPnl extends APrefClientPanelEinfach{

	private static final long serialVersionUID = 1L;
	private final HashMap<String,IPreferences> keyWords
			=new HashMap<String,IPreferences>();  //  @jve:decl-index=0:
	private Set<?> keySet=null;
	private JComboBox jComboBox = null;
	private final List<IPreferences> iPref;
	private final PrefManager prefMgr;
//=============================================================================

	public PrefGeneralPnl(final PrefManager prefMgr, final IPrefContainer prefContainer){
		super(prefContainer);
		this.iPref = new ArrayList<IPreferences>();
		this.prefMgr = prefMgr;
		initialize();
	}

	private void initialize() {
		this.setSize(300, 200);
		this.setLayout(new BoxLayout(this,BoxLayout.Y_AXIS));
		this.add(getJComboBox(), null);
	}

	@Override public void onReset() {		}
	@Override public void onSet() throws Exception {	}
	@Override public void onDispose() {}

	private JComboBox getJComboBox() {
		if (this.jComboBox == null) {
			for (final IPreferences iP:this.prefMgr.getIPreferences()){
				final String[] keys=iP.getKeyWords();
				if ((keys!=null) && (keys.length>0)){
					for(String key:keys){
						while (this.keyWords.containsKey(key)){
							key=key+"_";
						}
						this.keyWords.put(key,iP);
					}
				}
			}
			this.keySet=this.keyWords.keySet();
			final DefaultComboBoxModel model=new DefaultComboBoxModel();
			if (!this.keySet.isEmpty()){
				final Object[] ak=this.keySet.toArray();
				java.util.Arrays.sort(ak);
				for(final Object k:ak){
					String s=(String)k;
//					Logger.SWFW.debug("PrefGeneral, key: "+s);
					while(s.endsWith("_")){
						s=s.replace("_", "");
//						Logger.SWFW.debug("PrefGeneral, key: "+s);
					}
					s=s+"\t "+ this.keyWords.get(k).getTitle();
					model.addElement(s);
					this.iPref.add(this.keyWords.get(k));
				}
			} 
			final ComboBoxCellRenderer renderer=new ComboBoxCellRenderer();
			this.jComboBox = new JComboBox(model);
			this.jComboBox.setPreferredSize(new Dimension(340,22));
			this.jComboBox.setMinimumSize(new Dimension(340,22));
			this.jComboBox.setMaximumSize(new Dimension(340,22));
			this.jComboBox.setRenderer(renderer);
			this.jComboBox.addActionListener(new ActionListener() {
				@Override public void actionPerformed(final ActionEvent e) {
					final int index = PrefGeneralPnl.this.jComboBox.getSelectedIndex();
					PrefGeneralPnl.this.prefMgr.showPreferencesFrame(PrefGeneralPnl.this.iPref.get(index));
//					Logger.SWFW.debug("PrefGeneralPnl, actionPerformed(): "+iPref.get(index).getTitle());
				}
			});
		}
		return this.jComboBox;
	}
}
