package de.desy.mst.libs.framework.mstapp.preferences.implementation.optionPanels;

import java.awt.Component;
import java.util.StringTokenizer;

import javax.swing.JPanel;

import de.desy.mst.libs.framework.mstapp.MstServerFrameMain;
import de.desy.mst.libs.framework.mstapp.logging.Logger;
import de.desy.mst.libs.framework.mstapp.preferences.IPrefClient;
import de.desy.mst.libs.framework.mstapp.preferences.IPrefContainer;
import de.desy.mst.libs.framework.mstapp.preferences.IPreferences;

public class PrefPositionServer implements IPreferences{
	private JPanel jPanelPreferences=null;
	private IPreferences parent=null;
//	private String title="<html>Position des Programs <br>" 
//			+ "       auf dem Bildschirm";
	private final String title="Programmm-Position und Gre"; 
	private MstServerFrameMain serverMainFrame=null;
	private int screenIndex=0;
	
	public PrefPositionServer(final MstServerFrameMain mainFrame){
		super();
		this.serverMainFrame=mainFrame;
	}
	
	@Override public String[] getKeyWords() {
		return new String[]{"Position", "Server"};
	}

	@Override public IPreferences getParent() {
		return this.parent;
	}

	@Override public IPrefClient getPrefClient() {
		Logger.SWFW.info("DebugLevel getPreferenceClient ");		
		return (IPrefClient)this.jPanelPreferences;
	}

	@Override public Component getPrefComponent(final IPrefContainer prefContainer) {
		if (this.jPanelPreferences==null){
				this.jPanelPreferences=new PrefPositionServerPnl(this.serverMainFrame
						,prefContainer,this.screenIndex);						
		}
		return this.jPanelPreferences;
	}

	@Override public String getTitle() {
		return this.title;
	}
 
	@Override public void onDispose() {
		Logger.SWFW.info("PrefPosition onDispose ");		
		if (this.jPanelPreferences!=null) {
			this.jPanelPreferences.setVisible(false);
			this.jPanelPreferences = null;	//meine einzige Referenz
		}
	}

	@Override public void setParent(final IPreferences iU) {
		this.parent = iU;
	}

	@Override public void onNewSaveString(final String str) {
		Logger.SWFW.info("PrefPosition setSaveString() "+str);		
		final StringTokenizer tokenizer=new StringTokenizer(str,"=");
		if (tokenizer.hasMoreTokens()){
			if (tokenizer.nextToken().equals("PrefPosition")){
				if (tokenizer.hasMoreTokens()){
					try {
						final int index=Integer.parseInt(tokenizer.nextToken());
						Logger.SWFW.info("PrefPosition setSaveString() "
																		+index);		
						this.screenIndex=index;
						if (getPrefClient()!=null){
							((PrefPositionConsolePnl)getPrefClient())
															  .setLabels(index);
						}
						this.serverMainFrame.setServerPosition(index+1);											
					} catch (final NumberFormatException e) {
						e.printStackTrace();
					}
				}
			}	
		}	
	}
		
}
