/**
 * ws:	May 14, 2007 - May 15, 2007	changed:createPrefClientPanel() better Signature
 * 											onNewPrefString not final
 *	Feb 15, 2008 - Feb 15, 2008 ws: added "@Override"es
 */
package de.desy.mst.libs.framework.mstapp.preferences.implementation.optionPanels;

import java.awt.Color;
import java.awt.Component;

import javax.swing.JPanel;

import java.awt.Dimension;

import javax.swing.JLabel;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.BorderFactory;
import javax.swing.border.BevelBorder;
import javax.swing.border.TitledBorder;

import de.desy.mst.libs.framework.mstapp.MstServerFrameMain;
import de.desy.mst.libs.framework.mstapp.logging.Logger;
import de.desy.mst.libs.framework.mstapp.preferences.IPrefClient;
import de.desy.mst.libs.framework.mstapp.preferences.IPrefContainer;
import de.desy.mst.libs.framework.mstapp.preferences.PrefSpeicherMode;

import javax.swing.JCheckBox;
import javax.swing.SwingConstants;

public class PrefPositionServerPnl extends JPanel implements IPrefClient {

	private static final long serialVersionUID = 1L;
	private static final Color selectedColor=new Color(0,200,200);
	private JPanel jPnlPosition = null;
	private JPanel jPanel1 = null;
	private JPanel jPanel2 = null;
	private JPanel jPanel3 = null;
	private JPanel jPanel4 = null;
	private JLabel jLabel = null;
	private final JLabel[] jLabels=new JLabel[14];  
	private int screenIndex=0;
	private int oldIndex=0;
	private boolean isChanged=false;
	private IPrefContainer prefContainer=null;
	private JCheckBox jCheckBox = null;
	private MstServerFrameMain serverMainFrame=null;

	public PrefPositionServerPnl(final MstServerFrameMain serverMainFrame, final IPrefContainer prefContainer,final int screenIndex) {
		super();
		this.serverMainFrame=serverMainFrame;
		this.prefContainer=prefContainer;
		this.screenIndex=screenIndex;
		initialize();
	}

	private void initialize() {
		this.setSize(300, 400);
		this.oldIndex=this.screenIndex;
		Logger.SWFW.info("PrefPositionPnl, initialize() screenIndex="
				+this.screenIndex+",  oldIndex="+this.oldIndex);		
		paintLabels(this.screenIndex);
		this.add(getJPnlPosition());
	}

	private JPanel getJPanel1() {
		if (this.jPanel1 == null) {
			this.jLabel = new JLabel();
			final String s="Klicken Sie auf die gewnschte Bildschirmposition:";
			this.jLabel.setText(s);
			this.jPanel1 = new JPanel();
			this.jPanel1.setLayout(new BoxLayout(getJPanel1(), BoxLayout.X_AXIS));
			this.jPanel1.add(this.jLabel, null);
		}
		return this.jPanel1;
	}
	private JLabel getJLabels(final int ii){
		if (this.jLabels[ii]==null){
			this.jLabels[ii]=new JLabel();
			this.jLabels[ii].setOpaque(true);
			this.jLabels[ii].setBorder(BorderFactory
					   .createBevelBorder(BevelBorder.RAISED));
			this.jLabels[ii].setText("      ");
			this.jLabels[ii].addMouseListener(new java.awt.event.MouseAdapter() {
				/* (non-Javadoc)
				 * @see java.awt.event.MouseAdapter#mouseClicked(java.awt.event.MouseEvent)
				 */
				@Override public void mouseClicked(final java.awt.event.MouseEvent e) {
					final JLabel lbl=(JLabel)e.getSource();
					final JLabel[] jLbls=PrefPositionServerPnl.this.jLabels;
					for (int i=0;i<jLbls.length;i++){
						jLbls[i].setBackground(Color.cyan);
					}	
					lbl.setBackground(selectedColor);
					for  (int i=0;i<jLbls.length;i++){
						if (jLbls[i].equals(lbl)){
							PrefPositionServerPnl.this.screenIndex=i;
							break;
						}
					}
					if(PrefPositionServerPnl.this.screenIndex != PrefPositionServerPnl.this.oldIndex){
						PrefPositionServerPnl.this.isChanged=true;
						paintLabels(PrefPositionServerPnl.this.screenIndex);
					}else{
						PrefPositionServerPnl.this.isChanged=false;
					}
					PrefPositionServerPnl.this.prefContainer.setChanged(PrefPositionServerPnl.this.isChanged);
				}
			});
		}
		return this.jLabels[ii];
	} 
	
	public void paintLabels(final int screenIndex){
		Logger.SWFW.info("PrefPositionPnl, paintLabels() screenIndex="
				+screenIndex+",  oldIndex="+this.oldIndex);		
		for(int i=0;i<14;i++){
			if (i==screenIndex){
				getJLabels(i).setBackground(selectedColor);
			}else{	
				getJLabels(i).setBackground(Color.cyan);
			}	
			getJLabels(i).repaint();
		}
	}

	private JPanel getJPanel2() {
		if (this.jPanel2 == null) {
			this.jPanel2 = new JPanel();
			this.jPanel2.setLayout(new BoxLayout(getJPanel2(), BoxLayout.X_AXIS));
			for (int i=0;i<7;i++){
				this.jPanel2.add(getJLabels(i), null);
			}	
		}
		return this.jPanel2;
	}

	private JPanel getJPanel3() {
		if (this.jPanel3 == null) {
			this.jPanel3 = new JPanel();
			this.jPanel3.setLayout(new BoxLayout(getJPanel3(), BoxLayout.X_AXIS));
			for (int i=7;i<14;i++){
				this.jPanel3.add(getJLabels(i), null);
			}	
		}
		return this.jPanel3;
	}
	
	private JPanel getJPanel4() {
		if (this.jPanel4 == null) {
			this.jPanel4 = new JPanel();
			this.jPanel4.setLayout(new BoxLayout(getJPanel4(), BoxLayout.X_AXIS));
				this.jPanel4.add(getJCheckBox(), null);
		}
		return this.jPanel4;
	}
	
	private JPanel getJPnlPosition() {
		if (this.jPnlPosition == null) {
			this.jPnlPosition = new JPanel();
			this.jPnlPosition.setLayout(new BoxLayout(this.jPnlPosition
														, BoxLayout.Y_AXIS));
			this.jPnlPosition.setBorder(BorderFactory
					.createTitledBorder(BorderFactory
							.createLineBorder(Color.gray, 1)
								, "Programm Position"
								, TitledBorder.DEFAULT_JUSTIFICATION
								, TitledBorder.DEFAULT_POSITION, null, null));
			this.jPnlPosition.setAlignmentX(0.0F);
			this.jPnlPosition.setPreferredSize(new Dimension(300,200));
			final Component vertStrut1=Box.createVerticalStrut(15);
			final Component vertStrut2=Box.createVerticalStrut(15);
//			Component vertStrut3=Box.createVerticalStrut(15);
			final Component vertStrut4=Box.createVerticalStrut(15);
			final Component vertGlue=Box.createGlue(); 
			vertStrut4.setPreferredSize(new Dimension(0, 80));
			this.jPnlPosition.add(vertStrut1,null);
			this.jPnlPosition.add(getJPanel1(), null);
			this.jPnlPosition.add(vertStrut2,null);
			this.jPnlPosition.add(getJPanel2(), null);
//			this.add(vertStrut3,null);
			this.jPnlPosition.add(getJPanel3(), null);
			this.jPnlPosition.add(vertGlue,null);
			this.jPnlPosition.add(getJPanel4(), null);
		}
		return this.jPnlPosition;
	}
	
	@Override public String getSaveString(){
		return "PrefPosition="+this.screenIndex;
	}

	@Override public void onReset() {
		Logger.SWFW.info("PrefPositionPnl reSet() ");		
		Logger.SWFW.info("PrefPositionPnl, reSet() screenIndex="
				+this.screenIndex+",  oldIndex="+this.oldIndex);		
		this.screenIndex=this.oldIndex;
		paintLabels(this.screenIndex);
		
	}

	@Override public void onSet() throws Exception {
		Logger.SWFW.info("PrefPositionPnl set(); index= "+this.screenIndex);		
		paintLabels(this.screenIndex);
		this.serverMainFrame.setServerPosition(this.screenIndex+1);											
	}

	@Override public PrefSpeicherMode getSpeicherMode() {
		return (this.jCheckBox.getModel().isSelected()) ? PrefSpeicherMode.APPLOCAL
												   : PrefSpeicherMode.MEMORYONLY;
	}
	
//	void setPositionOnScreen(int actIndex){
//		Logger.SWFW.info("PrefPositionPnl setPositionOnScreen("
//				+actIndex+") ");		
//		if (actIndex>13)actIndex=0;
//		Dimension d=Toolkit.getDefaultToolkit().getScreenSize();
//		if (actIndex<7){
//			mainFrame.setLocation(actIndex*d.width/7,0);
//		}else{
//			mainFrame.setLocation((actIndex-7)*d.width/7,133);
//		}
//	}

	/**
	 * Diese checkBox macht nur Sinn, wenn	
	 * 				prefSpeicherMode!=PrefSpeicherMode.PREF_SPEICHER_MANAGEMENT
	 * 	
	 * @return javax.swing.JCheckBox	
	 */
	private JCheckBox getJCheckBox() {
		if (this.jCheckBox == null) {
			this.jCheckBox = new JCheckBox();
			this.jCheckBox.setHorizontalAlignment(SwingConstants.LEFT);
			this.jCheckBox.setPreferredSize(new Dimension(200, 21));
			this.jCheckBox.setText("abspeichern?");
			this.jCheckBox.setMaximumSize(new Dimension(200, 24));
			this.jCheckBox.setMinimumSize(new Dimension(200, 24));
			this.jCheckBox.setVerticalAlignment(SwingConstants.BOTTOM);
		}
		return this.jCheckBox;
	}
}
