/**
 *  Created on Sep 2, 2005 - Sep 14, 2005
 */
package de.desy.mst.libs.framework.mstapp.tabellendaten.devices;

import de.desy.mst.libs.framework.mstapp.tabellendaten.entry.AEntry;
import de.desy.mst.libs.framework.mstapp.tabellendaten.entry.DeviceGruppe;
import de.desy.mst.libs.framework.mstapp.tabellendaten.entry.IDeviceGenauEinerGruppe;
import de.desy.mst.libs.framework.mstapp.tabellendaten.entry.SedacDevice;

/**
 * Sedac Device Klasse fuer kh
 * @author ws
 * @version 1.0.0
 */
public class PeKlimaAnlage 	extends 	SedacDevice
							implements 	IDeviceGenauEinerGruppe {
	
	//Alle Devices sollten diese Gruppe haben
	public static final int DEV_GR_NR_SOLL = DeviceGruppe.PeKlimaAnlage.getDevGrNr();

	public final int sedCr_SO;
	public final int sedCr_SW;
	public final int sedCr_NO;
	public final int sedCr_NW;

//=============================================================================
	
	public PeKlimaAnlage(final int devGrNr,  final int devNo,    final String devName
			           , final int sedLn,    final int sedCr,    final int sedSu
			           , final int sedCr_SO, final int sedCr_SW, final int sedCr_NO, final int sedCr_NW) {
		super(devGrNr, devNo, devName, sedLn, sedCr, sedSu);
		this.sedCr_SO = sedCr_SO;
		this.sedCr_SW = sedCr_SW;
		this.sedCr_NO = sedCr_NO;
		this.sedCr_NW = sedCr_NW;
	}
	public PeKlimaAnlage(final int devGrNr,  final int devNo,    final String devName
			           , final int sedLn,    final int sedCr,    final int sedSu
			           , final int sedCr_SO, final int sedCr_SW, final int sedCr_NO, final int sedCr_NW 
			           , final Object ... unsupportedExtraParams) {
		this(devGrNr, devNo, devName, sedLn, sedCr, sedSu, sedCr_SO, sedCr_SW, sedCr_NO, sedCr_NW);
		handleUnsupportedExtraParams(this, unsupportedExtraParams); 
	}
	
//=============================================================================
	
	public int getSedCr_NO() {return this.sedCr_NO;}
	public int getSedCr_NW() {return this.sedCr_NW;}
	public int getSedCr_SO() {return this.sedCr_SO;}
	public int getSedCr_SW() {return this.sedCr_SW;}

	@Override public boolean inSeinenWertenGleich(final AEntry<Integer> otherEntry) {
		if(!(otherEntry instanceof PeKlimaAnlage)) {return false;}
		final PeKlimaAnlage other = (PeKlimaAnlage) otherEntry;
		return super.inSeinenWertenGleich(otherEntry)
			&& this.sedCr_NO == other.sedCr_NO 
			&& this.sedCr_NW == other.sedCr_NW 
			&& this.sedCr_SO == other.sedCr_SO 
			&& this.sedCr_SW == other.sedCr_SW 
			;
	}
	
//=============================================================================
	
	/* (non-Javadoc)
	 * @see de.desy.mst.mstapp.tabellendaten.entry.IDeviceGenauEinerGruppe#getDevGrNoSoll()
	 */
	@Override public int getDevGrNoSoll() {
		return DEV_GR_NR_SOLL;
	}
} 
