/**
 *  Created on Sep 7, 2005 - Sep 14, 2005
 */
package de.desy.mst.libs.framework.mstapp.tabellendaten.devices;

import de.desy.mst.libs.framework.mstapp.tabellendaten.entry.AEntry;
import de.desy.mst.libs.framework.mstapp.tabellendaten.entry.DeviceGruppe;
import de.desy.mst.libs.framework.mstapp.tabellendaten.entry.IDeviceGenauEinerGruppe;
import de.desy.mst.libs.framework.mstapp.tabellendaten.entry.SedacDevice;

/**
 * @author ws
 * @version 1.0.0
 */
public class PeKlimaFuehler extends 	SedacDevice 
							implements 	IDeviceGenauEinerGruppe {
	
	//Alle Devices sollten diese Gruppe haben
	public static final int DEV_GR_NR_SOLL = DeviceGruppe.PeKlimaFuehler.getDevGrNr();

	public final int sub_Tem;
	public final int sub_Feu;

//=============================================================================
	
	public PeKlimaFuehler(final int devGrNr,  final int devNo,    final String devName
			            , final int sedLn,    final int sedCr,    final int sedSu
			            , final int sub_Tem,  final int sub_Feu) {
		super(devGrNr, devNo, devName, sedLn, sedCr, sedSu);
		this.sub_Tem = sub_Tem;
		this.sub_Feu = sub_Feu;
	}
	public PeKlimaFuehler(final int devGrNr,  final int devNo,    final String devName
			            , final int sedLn,    final int sedCr,    final int sedSu
			            , final int sub_Tem,  final int sub_Feu  
			           , final Object ... unsupportedExtraParams) {
		this(devGrNr, devNo, devName, sedLn, sedCr, sedSu, sub_Tem, sub_Feu);
		handleUnsupportedExtraParams(this, unsupportedExtraParams);
	}
	
//=============================================================================
	
	public int getsub_Tem() {return this.sub_Tem;}
	public int getsub_Feu() {return this.sub_Feu;}

	@Override public boolean inSeinenWertenGleich(final AEntry<Integer> otherEntry) {
		if(!(otherEntry instanceof PeKlimaFuehler)) {return false;}
		final PeKlimaFuehler other = (PeKlimaFuehler) otherEntry;
		return super.inSeinenWertenGleich(otherEntry)
			&& this.sub_Tem == other.sub_Tem 
			&& this.sub_Feu == other.sub_Feu 
			;
	}
	
//=============================================================================
	
	/* (non-Javadoc)
	 * @see de.desy.mst.mstapp.tabellendaten.entry.IDeviceGenauEinerGruppe#getDevGrNoSoll()
	 */
	@Override public int getDevGrNoSoll() {
		return DEV_GR_NR_SOLL;
	}
}
 