/**
 * 	Jun 22, 2015 - Jul 16, 2015	ws:	created from scratch
 */
package de.desy.mst.libs.framework.mstapp.tabellendaten.entry;

import de.desy.mst.libs.framework.mstapp.ini.OPModeACLEntryFactory_FileSystem;
import de.desy.mst.libs.framework.mstapp.logging.Logger;

/**
 * Cashes to the local file system the wrapped OPModeACLEntryFactory
 * @author ws
 */
class _OPModeACLEntryFactory_cached extends OPModeACLEntryFactory {
	private final OPModeACLEntryFactory sourceFactory;
	//---------------------------------------------------------------------------------------------
	public _OPModeACLEntryFactory_cached(final OPModeACLEntryFactory sourceFactory) {
		this.sourceFactory = sourceFactory;
	}
	//---------------------------------------------------------------------------------------------
	@Override public OPModeACLEntry getOPModeACLEntry(final String pcUser, final String pcName, final String appName) {
		try {
			final OPModeACLEntry entry = this.sourceFactory.getOPModeACLEntry(pcUser, pcName, appName);
			if(entry != null) 
				return new OPModeACLEntryFactory_FileSystem().set(entry);
			return new OPModeACLEntryFactory_FileSystem().getOPModeACLEntry(pcUser, pcName, appName);
			
		} catch(final Exception ex) {
			final String msg = this.getClass().getSimpleName() 
					         + ".getOPModeACLEntry(pcUser = "  + pcUser 
					                          + ", pcName = "  + pcName 
					                          + ", appName = " + appName
					                          + ") ignore problem: " + ex;
			Logger.SWFW.warn(msg, ex);
		}
		
		return null;
	}
	@SuppressWarnings("deprecation") @Override public boolean usesOldSQLWay() {
		return this.sourceFactory.usesOldSQLWay();//ignore the caching part
	}

}
