/**
 * Oct  5, 2006 - Oct  30, 2006	ws:	created from scratch
 */
package de.desy.mst.libs.framework.mstapp.tabellendaten.generics;

import de.desy.mst.libs.framework.mstapp.tabellendaten.entry.AEntry;

/**
 * Entry fuer Information ueber die Spalten Datenbank Tabelle.
 * @author ws
 */
public class ColumnInfo extends AEntry<Integer> {
	public static final String COL_ID = "colId";//name des entspr. public fields
	public static final String NAME   = "name"; //name des entspr. public fields
	public static final String X_TYPE = "xType";//name des entspr. public fields
	
	public final int    colId;	//Spalten Index 1 Basiert (ist ne DB) // SCHLUESSEL ENTRY PRO TABELLE
	public final String name;	//Spalten Name
	public final int 	xType;	//Typ der Variablen im internen SQL Server Format

//=============================================================================

	public ColumnInfo(final int colId, final String name, final int xType) {
		super();
		this.colId	= colId;
		this.name	= name;
		this.xType	= xType;
	}
	public ColumnInfo(final int colId, final String name, final int xType
					, final Object ... unsupportedExtraParams) {
		this(colId, name, xType);
		handleUnsupportedExtraParams(this, unsupportedExtraParams); 
	}

//	=============================================================================

	public final int 	getColId()	{return this.colId;}
	public final String getName()	{return this.name;}
	public final int 	getXType()	{return this.xType;}

//=============================================================================
		
	/* (non-Javadoc)
	 * @see de.desy.mst.libs.framework.mstapp.tabellendaten.entry.AEntry#getKey()
	 */
	@Override public Integer getKey() {return Integer.valueOf(getColId());}
	
	/* (non-Javadoc)
	 * @see de.desy.mst.libs.framework.mstapp.tabellendaten.entry.AEntry#inSeinenWertenGleich(de.desy.mst.libs.framework.mstapp.tabellendaten.entry.AEntry)
	 */
	@Override @SuppressWarnings("rawtypes") public boolean inSeinenWertenGleich(final AEntry otherEntry) {
		if( this.equals(otherEntry)) {return true;}
		 
		if(!(otherEntry instanceof ColumnInfo)){return false;}
		final ColumnInfo entry = (ColumnInfo) otherEntry;
		return	this.getColId() == entry.getColId()
			&&	this.getName().equalsIgnoreCase(entry.getName())
			&&	this.getXType() == entry.getXType()
		;
	}
}