/**
 *  Created on Aug 07, 2006 - Aug 07, 2006
 */
package de.desy.mst.libs.framework.mstapp.util;

/**
 * immutable class
 * @author ws
 * @version 1.0.0
 */
public class StringPadding implements IFormatAsString<String> {
	/**zu lange Strings enden hiermit*/
	public final static String TRUNCATION_INDICATOR = "*";	
	/**Alle Strings werden hierzu gepadded, laengere Strings werden truncated und mit TRUNCATION_INDICATOR gekennzeichnet*/
	public final int STRING_SIZE;
	
//=============================================================================	
	
	/**throws new IllegalArgumentException, falls stringSize <= 0 ist*/
	public StringPadding(final int stringSize) {
		if(stringSize <= 0) {
			throw new IllegalArgumentException("Die String Size muss > 0 sein ist aber: " + stringSize);
		}
		this.STRING_SIZE = stringSize;
	}
	
//	=============================================================================	
		
	@Override public String format(final String string) {
		if(string == null) 					{return this.format("");}
		final int length = string.length();
		if(length == this.STRING_SIZE)	{return string;}
		if(length >  this.STRING_SIZE)	{return string.substring(0, length - 1).concat(TRUNCATION_INDICATOR);}
		final StringBuffer sb = new StringBuffer(string);
		for (int i = length + 1; i <= this.STRING_SIZE; i++) {
			sb.append(' ');
		}
		return sb.toString();
	}

} 
