/**
 * 	Aug  6, 2009 - Aug  6, 2009	ws:	Eclipse asked for removing unnessary casts, so I did
 */
package de.desy.mst.libs.framework.mstapp.util.applicationresizemanager.listeners;

import java.awt.*;
import java.beans.*;

import javax.swing.*;

import de.desy.mst.libs.framework.mstapp.util.applicationresizemanager.managers.ApplicationResizeManager;
import de.desy.mst.libs.framework.mstapp.util.applicationresizemanager.resizers.*;


/**
* Looks for icon changes of JLabels.
* 
* @author R.Bacher
* @version 3.0.0
* 
*/	
public class IconChangeListener implements PropertyChangeListener {
	
	private ApplicationResizeManager myApplicationResizeManager = null;
	
	private Icon myOldIcon = null;
	private Icon myNewIcon = null;
	private IconResizer myComponentImageIcon = null;
	private boolean myImageIconSet = false;
	private Component myIconSwingComponent = null;
	private Component myIconReferenceComponent = null;
	
	/**
	 * 
	 * Constructor
	 * 
	 * @param referenceComponent reference component to be resized
	 * @param component component to which the icon is attached
	 */
	public IconChangeListener (final ApplicationResizeManager applicationResizeManager, final Component referenceComponent, final Component component) {
		super();
		this.myApplicationResizeManager = applicationResizeManager;
		this.myIconReferenceComponent = referenceComponent;
		this.myIconSwingComponent = component;
	}
	
	/**
	 * 
	 * Catches icon in case of icon change
	 * 
	 * @param propertyChangeEvent property change event
	 * 
	 */
	@Override public void propertyChange(final PropertyChangeEvent propertyChangeEvent) {
		if (this.myImageIconSet == false) {
				try {
					this.myNewIcon = ((JLabel)this.myIconSwingComponent).getIcon();
				}
				catch (final Exception exception) {
					this.myNewIcon = null;
					this.myImageIconSet = false;
				}
				if (this.myNewIcon != null) {
					this.myComponentImageIcon = new IconResizer(this.myApplicationResizeManager, this.myIconReferenceComponent);
					this.myImageIconSet = true;
					this.myComponentImageIcon.setImage(((ImageIcon)((JLabel)this.myIconSwingComponent).getIcon()).getImage());
					this.myNewIcon = this.myComponentImageIcon;
					this.myOldIcon = this.myNewIcon;
					if (this.myIconSwingComponent.getClass().getName() == "de.desy.acop.displayers.AcopSpider") {}
					else {
						((JLabel)this.myIconSwingComponent).setIcon(this.myComponentImageIcon);
					}
				}
		}
		else {
			this.myNewIcon = ((JLabel)this.myIconSwingComponent).getIcon();
			if (this.myOldIcon != this.myNewIcon) {
				this.myComponentImageIcon.setImage(((ImageIcon)((JLabel)this.myIconSwingComponent).getIcon()).getImage());									
				this.myNewIcon = this.myComponentImageIcon;
				this.myOldIcon = this.myNewIcon;
				if (this.myIconSwingComponent.getClass().getName() == "de.desy.acop.displayers.AcopSpider") {}
				else {
					((JLabel)this.myIconSwingComponent).setIcon(this.myComponentImageIcon);
				}
			}
		}
	} 
}
