/**
 * 	Aug  6, 2009 - Aug  6, 2009	ws:	Eclipse asked for removing unnessary casts, so I did
 */
package de.desy.mst.libs.framework.mstapp.util.applicationresizemanager.resizers;

import java.awt.*;
import java.beans.PropertyChangeEvent;

import javax.swing.*;
import javax.swing.table.*;
import javax.swing.border.*;

import de.desy.mst.libs.framework.mstapp.MstFrameMain;
import de.desy.mst.libs.framework.mstapp.menu.IPopupMenuMgr;
import de.desy.mst.libs.framework.mstapp.util.Convert;
import de.desy.mst.libs.framework.mstapp.util.applicationresizemanager.listeners.IconChangeListener;
import de.desy.mst.libs.framework.mstapp.util.applicationresizemanager.managers.ApplicationResizeManager;

/**
 * Resizes a Swing component (including Acop beans).
 *
 * @author R.Bacher
 * @version 3.0.0
 *
 */
public class ComponentResizer {

	private Component myReferenceComponent = null;
	private double myReferenceComponentWidth = 0;
	private double myReferenceComponentHeight = 0;

	private Component myComponent = null;

	private Object myComponentLayout = null;
	private int myComponentLayoutHGap = 0;
	private int myComponentLayoutVGap = 0;
	private int myComponentLayoutIpadx = 0;
	private int myComponentLayoutIpady = 0;
	private int myComponentLayoutGridx = 0;
	private int myComponentLayoutGridy = 0;
	private int myComponentLayoutGridwidth = 0;
	private int myComponentLayoutGridheight = 0;
	private int myComponentLayoutAnchor= 0;
	private int myComponentLayoutFill = 0;
	private double myComponentLayoutWeightx = 0.0;
	private double myComponentLayoutWeighty = 0.0;
	private int myComponentLayoutInsetBottom = 0;
	private int myComponentLayoutInsetLeft = 0;
	private int myComponentLayoutInsetRight = 0;
	private int myComponentLayoutInsetTop = 0;

	private double myComponentWidth = 0;
	private double myComponentHeight = 0;
	private double myComponentPrefferedWidth = 0;
	private double myComponentPrefferedHeight = 0;
	private double myComponentMaximumWidth = 0;
	private double myComponentMinimumWidth = 0;
	private double myComponentMaximumHeight = 0;
	private double myComponentMinimumHeight = 0;

	private double myComponentXLocation = 0;
	private double myComponentYLocation = 0;

	private String myComponentFontName = "";
	private int myComponentFontStyle = 0;
	private int myComponentFontSize = 0;

	private Font myAcopChartFrameFont = null;
	private String myAcopChartFrameFontName = "";
	private int myAcopChartFrameFontStyle = 0;
	private int myAcopChartFrameFontSize = 0;
	private int myAcopChartFrameWidth = 0;
	private int myAcopChartFrameBottomOffset = 0;
	private int myAcopChartFrameTopOffset = 0;
	private int myAcopChartFrameLeftOffset = 0;
	private int myAcopChartFrameRightOffset = 0;
	private Font myAcopGaugerValueLabelFont = null;
	private String myAcopGaugerValueLabelFontName = "";
	private int myAcopGaugerValueLabelFontStyle = 0;
	private int myAcopGaugerValueLabelFontSize = 0;
	private Font myAcopGaugerTickTextFont = null;
	private String myAcopGaugerTickTextFontName = "";
	private int myAcopGaugerTickTextFontStyle = 0;
	private int myAcopGaugerTickTextFontSize = 0;

	private String myComponentBorderFontName = "";
	private int myComponentBorderFontStyle = 0;
	private int myComponentBorderFontSize = 0;

	private double myComponentBoundsX = 0;
	private double myComponentBoundsY = 0;
	private double myComponentBoundsWidth = 0;
	private double myComponentBoundsHeight = 0;

	private int myComponentIconTextGap = 0;

	//private com.cosylab.gui.components.ObjectTable myTable = null;

	private int[] myTableRowHeight = null;
	private int myTableRowMargin;
	private JTable myTable = null;
	private JTableHeader myTableHeader = null;
	private TableColumn[] myTableColumn = null;
	private TableColumn[] myTableHeaderColumn = null;
    private Component[][] myTableDataCellRendererComponent = null;
    private Component[] myTableHeaderCellRendererComponent = null;
	private double[] myTableHeaderCellPrefferedWidth = null;
	private double[] myTableHeaderCellWidth = null;
	private Font myTableHeaderFont = null;
	private double[] myTableDataCellPrefferedWidth = null;
	private double[] myTableDataCellWidth = null;
	private Font[] myTableHeaderCellFont = null;
	private Font[][] myTableDataCellFont = null;
	private int[][] myTableDataCellIconTextGap = null;
	private JPopupMenu myPopupMenu = null;
	private ApplicationResizeManager myApplicationResizeManager = null;
	private IconChangeListener[][] myTableDataCellIconChangeListener = null;
	private PropertyChangeEvent[][] myTableDataCellIconPropertyChangeEvent = null;

	/**
	 *
	 * Constructor
	 *
	 * @param referenceComponent Frame object of the resized visual application
	 * @param component Swing component to be resized
	 *
	 */
	public ComponentResizer(final Component referenceComponent, final Component component, final ApplicationResizeManager applicationResizeManager) {

		this.myComponent = component;
		this.myReferenceComponent = referenceComponent;
		this.myApplicationResizeManager  = applicationResizeManager;
		initialize();
		try {
			if (this.myComponent instanceof IPopupMenuMgr) {
				this.myPopupMenu  = (JPopupMenu)((MstFrameMain)(this.myReferenceComponent)).getPopUpMenuMgr();
				this.myPopupMenu.addPropertyChangeListener("visible", new java.beans.PropertyChangeListener() {
					@Override public void propertyChange(final java.beans.PropertyChangeEvent e) {
						resizePopupMenu();
					}
				});
			}
		} catch (final Exception e) {}

	}

	/**
	 * Determines the graphical start-up parameters of the Swing Component.
	 *
	 */
	@SuppressWarnings({ "boxing", "cast" }) private final void initialize() {

		int i = 0;
		int j = 0;
 
		this.myReferenceComponentWidth = (double)this.myReferenceComponent.getWidth();
	    this.myReferenceComponentHeight = (double)this.myReferenceComponent.getHeight();

	    this.myComponentWidth = this.myComponent.getSize().getWidth();
	    this.myComponentHeight = this.myComponent.getSize().getHeight();
		this.myComponentPrefferedWidth = this.myComponent.getPreferredSize().getWidth();
	    this.myComponentPrefferedHeight = this.myComponent.getPreferredSize().getHeight();
	    this.myComponentMaximumWidth = this.myComponent.getMaximumSize().getWidth();
	    this.myComponentMaximumHeight = this.myComponent.getMaximumSize().getHeight();
	    this.myComponentMinimumWidth = this.myComponent.getMinimumSize().getWidth();
	    this.myComponentMinimumHeight = this.myComponent.getMinimumSize().getHeight();

	    this.myComponentXLocation =  this.myComponent.getLocation().getX();
		this.myComponentYLocation =  this.myComponent.getLocation().getY();

		this.myComponentFontName =  this.myComponent.getFont().getName();
		this.myComponentFontStyle = this.myComponent.getFont().getStyle();
		this.myComponentFontSize = this.myComponent.getFont().getSize();

		this.myComponentBoundsX = this.myComponent.getBounds().getX();
		this.myComponentBoundsY = this.myComponent.getBounds().getY();
		this.myComponentBoundsWidth = this.myComponent.getBounds().getWidth();
		this.myComponentBoundsHeight = this.myComponent.getBounds().getHeight();

		try {
			this.myComponentLayout = ((Object)((Container)this.myComponent).getLayout());
			if (this.myComponentLayout instanceof BoxLayout) {}
			else if (this.myComponentLayout instanceof BorderLayout) {
				this.myComponentLayoutHGap = ((BorderLayout)this.myComponentLayout).getHgap();
				this.myComponentLayoutVGap = ((BorderLayout)this.myComponentLayout).getVgap();
			}
			else if (this.myComponentLayout instanceof CardLayout) {
				this.myComponentLayoutHGap = ((CardLayout)this.myComponentLayout).getHgap();
				this.myComponentLayoutVGap = ((CardLayout)this.myComponentLayout).getVgap();
			}
			else if (this.myComponentLayout instanceof FlowLayout) {
				this.myComponentLayoutHGap = ((FlowLayout)this.myComponentLayout).getHgap();
				this.myComponentLayoutVGap = ((FlowLayout)this.myComponentLayout).getVgap();
			}
			else if (this.myComponentLayout instanceof GridLayout) {
				this.myComponentLayoutHGap = ((GridLayout)this.myComponentLayout).getHgap();
				this.myComponentLayoutVGap = ((GridLayout)this.myComponentLayout).getVgap();
			}
			else if (this.myComponentLayout instanceof GridBagLayout) {
				this.myComponentLayoutIpadx = ((GridBagLayout)this.myComponentLayout).getConstraints(this.myComponent).ipadx;
				this.myComponentLayoutIpady = ((GridBagLayout)this.myComponentLayout).getConstraints(this.myComponent).ipady;
				this.myComponentLayoutWeightx = ((GridBagLayout)this.myComponentLayout).getConstraints(this.myComponent).weightx;
				this.myComponentLayoutWeighty = ((GridBagLayout)this.myComponentLayout).getConstraints(this.myComponent).weighty;
				this.myComponentLayoutGridx = ((GridBagLayout)this.myComponentLayout).getConstraints(this.myComponent).gridx;
				this.myComponentLayoutGridy = ((GridBagLayout)this.myComponentLayout).getConstraints(this.myComponent).gridy;
				this.myComponentLayoutGridwidth = ((GridBagLayout)this.myComponentLayout).getConstraints(this.myComponent).gridwidth;
				this.myComponentLayoutGridheight = ((GridBagLayout)this.myComponentLayout).getConstraints(this.myComponent).gridheight;
				this.myComponentLayoutAnchor = ((GridBagLayout)this.myComponentLayout).getConstraints(this.myComponent).anchor;
				this.myComponentLayoutFill= ((GridBagLayout)this.myComponentLayout).getConstraints(this.myComponent).fill;
				this.myComponentLayoutInsetBottom = ((GridBagLayout)this.myComponentLayout).getConstraints(this.myComponent).insets.bottom;
				this.myComponentLayoutInsetTop = ((GridBagLayout)this.myComponentLayout).getConstraints(this.myComponent).insets.top;
				this.myComponentLayoutInsetLeft = ((GridBagLayout)this.myComponentLayout).getConstraints(this.myComponent).insets.left;
				this.myComponentLayoutInsetRight = ((GridBagLayout)this.myComponentLayout).getConstraints(this.myComponent).insets.right;
			}
			else {

			}
		} catch (final Exception e) {}

		if (this.myComponent instanceof JLabel) {
			this.myComponentIconTextGap = ((JLabel)this.myComponent).getIconTextGap();
		}

		try {
			this.myComponentBorderFontName = ((TitledBorder)((JComponent)this.myComponent).getBorder()).getTitleFont().getName();
			this.myComponentBorderFontStyle = ((TitledBorder)((JComponent)this.myComponent).getBorder()).getTitleFont().getStyle();
			this.myComponentBorderFontSize = ((TitledBorder)((JComponent)this.myComponent).getBorder()).getTitleFont().getSize();
		}
		catch (final Exception e){}

		try {
			this.myAcopChartFrameFont = (Font)(this.myComponent.getClass().getMethod("getFrameFont", (Class[]) null).invoke(this.myComponent, (Object[]) null));
			this.myAcopChartFrameFontName = this.myAcopChartFrameFont.getClass().getMethod("getName", (Class[]) null).invoke(this.myAcopChartFrameFont, (Object[]) null).toString();
			this.myAcopChartFrameFontStyle = (Integer)(this.myAcopChartFrameFont.getClass().getMethod("getStyle", (Class[]) null).invoke(this.myAcopChartFrameFont, (Object[]) null));
			this.myAcopChartFrameFontSize = (Integer)(this.myAcopChartFrameFont.getClass().getMethod("getSize", (Class[]) null).invoke(this.myAcopChartFrameFont, (Object[]) null));
			this.myAcopChartFrameWidth = (Integer)(this.myComponent.getClass().getMethod("getFrameWidth", (Class[]) null).invoke(this.myComponent, (Object[]) null));
			this.myAcopChartFrameBottomOffset = (Integer)(this.myComponent.getClass().getMethod("getFrameBottomOffset", (Class<?>[]) null).invoke(this.myComponent, (Object[])null));
			this.myAcopChartFrameTopOffset = (Integer)(this.myComponent.getClass().getMethod("getFrameTopOffset", (Class<?>[]) null).invoke(this.myComponent,(Object[])null));
			this.myAcopChartFrameLeftOffset = (Integer)(this.myComponent.getClass().getMethod("getFrameLeftOffset", (Class<?>[]) null).invoke(this.myComponent,  (Object[])null));
			this.myAcopChartFrameRightOffset = (Integer)(this.myComponent.getClass().getMethod("getFrameRightOffset", (Class<?>[]) null).invoke(this.myComponent,  (Object[])null));
		}
		catch(final Exception e){}

		try {
			this.myAcopGaugerValueLabelFont = (Font)(this.myComponent.getClass().getMethod("getValueLabelFont", (Class[]) null).invoke(this.myComponent, (Object[]) null));
			this.myAcopGaugerValueLabelFontName = this.myAcopGaugerValueLabelFont.getClass().getMethod("getName", (Class[]) null).invoke(this.myAcopGaugerValueLabelFont, (Object[]) null).toString();
			this.myAcopGaugerValueLabelFontStyle = (Integer)(this.myAcopGaugerValueLabelFont.getClass().getMethod("getStyle", (Class[]) null).invoke(this.myAcopGaugerValueLabelFont, (Object[]) null));
			this.myAcopGaugerValueLabelFontSize = (Integer)(this.myAcopGaugerValueLabelFont.getClass().getMethod("getSize", (Class[]) null).invoke(this.myAcopGaugerValueLabelFont, (Object[]) null));
			this.myAcopGaugerTickTextFont = (Font)(this.myComponent.getClass().getMethod("getTickTextFont", (Class[]) null).invoke(this.myComponent, (Object[]) null));
			this.myAcopGaugerTickTextFontName = this.myAcopGaugerTickTextFont.getClass().getMethod("getName", (Class[]) null).invoke(this.myAcopGaugerTickTextFont, (Object[]) null).toString();
			this.myAcopGaugerTickTextFontStyle = (Integer)(this.myAcopGaugerTickTextFont.getClass().getMethod("getStyle", (Class[]) null).invoke(this.myAcopGaugerTickTextFont, (Object[]) null));
			this.myAcopGaugerTickTextFontSize = (Integer)(this.myAcopGaugerTickTextFont.getClass().getMethod("getSize", (Class[]) null).invoke(this.myAcopGaugerTickTextFont, (Object[]) null));
		}
		catch(final Exception e){}

		if ((this.myComponent instanceof JTable) && (this.myComponent.getClass().getName() != "de.desy.acop.displayers.AcopTable")) {
			this.myTable = ((JTable)this.myComponent);
			//myTable = ((ObjectTable)myComponent);
			this.myTableHeader = this.myTable.getTableHeader();

			System.out.println(this.myTable.getModel().getColumnCount());
			System.out.println(this.myTable.getModel().getRowCount());

			this.myTableHeaderFont = this.myTableHeader.getFont();
			this.myTableHeaderColumn = new TableColumn[this.myTable.getModel().getColumnCount()];
			this.myTableHeaderCellRendererComponent = new Component[this.myTable.getModel().getColumnCount()];
			this.myTableHeaderCellWidth = new double[this.myTable.getModel().getColumnCount()];
			this.myTableHeaderCellPrefferedWidth = new double[this.myTable.getModel().getColumnCount()];
			this.myTableHeaderCellFont = new Font[this.myTable.getModel().getColumnCount()];
		    for (i = 0; i < this.myTable.getModel().getColumnCount(); i++) {
		    	this.myTableHeaderColumn[i] = this.myTableHeader.getColumnModel().getColumn(i);
	            this.myTableHeaderCellWidth[i] = this.myTableHeaderColumn[i].getWidth();
	            this.myTableHeaderCellPrefferedWidth[i] = this.myTableHeaderColumn[i].getPreferredWidth();
				if (this.myTableHeaderColumn[i].getHeaderRenderer() == null) {
					this.myTableHeaderCellRendererComponent[i] = this.myTableHeader.getDefaultRenderer().getTableCellRendererComponent(this.myTable, this.myTable.getModel().getColumnName(i), false, false, 0, i);
				}
				else {
					this.myTableHeaderCellRendererComponent[i] = this.myTableHeaderColumn[i].getHeaderRenderer().getTableCellRendererComponent(this.myTable, this.myTable.getModel().getColumnName(i), false, false, 0, i);
				}
				this.myTableHeaderCellFont[i] = this.myTableHeaderCellRendererComponent[i].getFont();
		    }

			//myTableRowHeight = myTable.getRowHeight();
			this.myTableRowMargin = this.myTable.getRowMargin();
	        this.myTableColumn = new TableColumn[this.myTable.getModel().getColumnCount()];
	        this.myTableDataCellRendererComponent = new Component[this.myTable.getModel().getRowCount()][this.myTable.getModel().getColumnCount()];
	        this.myTableRowHeight = new int[this.myTable.getModel().getRowCount()];
	        this.myTableDataCellWidth = new double[this.myTable.getModel().getColumnCount()];
	        this.myTableDataCellPrefferedWidth = new double[this.myTable.getModel().getColumnCount()];
	        this.myTableDataCellFont = new Font[this.myTable.getModel().getRowCount()][this.myTable.getModel().getColumnCount()];
	        this.myTableDataCellIconTextGap = new int[this.myTable.getModel().getRowCount()][this.myTable.getModel().getColumnCount()];
	        this.myTableDataCellIconChangeListener = new IconChangeListener[this.myTable.getModel().getRowCount()][this.myTable.getModel().getColumnCount()];
	        this.myTableDataCellIconPropertyChangeEvent = new PropertyChangeEvent[this.myTable.getModel().getRowCount()][this.myTable.getModel().getColumnCount()];
		    for (i = 0; i < this.myTable.getModel().getColumnCount(); i++) {
		        this.myTableColumn[i] = this.myTable.getColumnModel().getColumn(i);
		        this.myTableDataCellPrefferedWidth[i] = this.myTableColumn[i].getPreferredWidth();
		        this.myTableDataCellWidth[i] = this.myTableColumn[i].getWidth();
			    for (j = 0; j < this.myTable.getModel().getRowCount(); j++) {
			        this.myTableRowHeight[j] = this.myTable.getRowHeight(j);
			    	if (this.myTableColumn[i].getCellRenderer() == null) {
			    		this.myTableDataCellRendererComponent[j][i] = this.myTable.getDefaultRenderer(this.myTable.getColumnClass(i)).getTableCellRendererComponent(this.myTable, this.myTable.getModel().getValueAt(j,i), false, false, j, i);
			    	}
			    	else {
			    		this.myTableDataCellRendererComponent[j][i] = this.myTable.getCellRenderer(j,i).getTableCellRendererComponent(this.myTable, this.myTable.getModel().getValueAt(j,i), false, false, j, i);
			    	}
				    this.myTableDataCellFont[j][i] = this.myTableDataCellRendererComponent[j][i].getFont();
				    try {this.myTableDataCellIconTextGap[j][i] = ((JLabel)this.myTableDataCellRendererComponent[j][i]).getIconTextGap();} catch(final Exception e) {}
					this.myTableDataCellIconChangeListener[j][i] = new IconChangeListener(this.myApplicationResizeManager, this.myReferenceComponent, (this.myTableDataCellRendererComponent[j][i]));
					this.myTableDataCellRendererComponent[j][i].addPropertyChangeListener("icon", this.myTableDataCellIconChangeListener[j][i]);
					this.myTableDataCellIconChangeListener[j][i].propertyChange(this.myTableDataCellIconPropertyChangeEvent[j][i]);
			    }
		    }
		}
	}

	/**
	 * Resizes the Swing component.
	 *
	 */
	@SuppressWarnings("boxing") public final void resizeComponent() {

		int i = 0;
		int j = 0;
		double swingComponentFontSize = 0;
		double swingComponentBorderFontSize = 0;
		double acopChartFrameFontSize = 0;
		double acopGaugerValueLabelFontSize = 0;
		double acopGaugerTickTextFontSize = 0;
		double headerFontSize = 0;
		double headerCellFontSize = 0;
		double dataCellFontSize = 0;
		final double powerFactor = 10.0;
		final double scalingFactor = 1.0;
		double xScale = 1.0;
		double yScale = 1.0;
		double wheelSwitchResizeFactorX = 1.0;
		double wheelSwitchResizeFactorY = 1.0;

     	xScale = this.myApplicationResizeManager.getScaleX();
    	yScale = this.myApplicationResizeManager.getScaleY();

		if (this.myComponentLayout instanceof BorderLayout) {
			try {
			    ((BorderLayout)this.myComponentLayout).setHgap(Convert.toInt(Math.round(this.myComponentLayoutHGap * xScale)));
				((BorderLayout)this.myComponentLayout).setVgap(Convert.toInt(Math.round(this.myComponentLayoutVGap * yScale)));
			}
			catch (final Exception e) {}
		}
		else if (this.myComponentLayout instanceof CardLayout) {
		    try {
				((CardLayout)this.myComponentLayout).setHgap(Convert.toInt(Math.round(this.myComponentLayoutHGap * xScale)));
				((CardLayout)this.myComponentLayout).setVgap(Convert.toInt(Math.round(this.myComponentLayoutVGap * yScale)));
		    }
			catch (final Exception e) {}
		}
		else if (this.myComponentLayout instanceof FlowLayout) {
			try {
			    ((FlowLayout)this.myComponentLayout).setHgap(Convert.toInt(Math.round(this.myComponentLayoutHGap * xScale)));
				((FlowLayout)this.myComponentLayout).setVgap(Convert.toInt(Math.round(this.myComponentLayoutVGap * yScale)));
			}
			catch (final Exception e) {}
		}
		else if (this.myComponentLayout instanceof GridLayout) {
			try {
			    ((GridLayout)this.myComponentLayout).setHgap(Convert.toInt(Math.round(this.myComponentLayoutHGap * xScale)));
				((GridLayout)this.myComponentLayout).setVgap(Convert.toInt(Math.round(this.myComponentLayoutVGap * yScale)));
			}
			catch (final Exception e) {}
		}
		else if (this.myComponentLayout instanceof GridBagLayout) {
			try {
				((GridBagLayout)this.myComponentLayout).setConstraints(
						this.myComponent,
						new GridBagConstraints(
								this.myComponentLayoutGridx,
								this.myComponentLayoutGridy,
								this.myComponentLayoutGridwidth,
								this.myComponentLayoutGridheight,
								Math.round(this.myComponentLayoutWeightx * xScale),
								Math.round(this.myComponentLayoutWeighty * yScale),
								this.myComponentLayoutAnchor,
								this.myComponentLayoutFill,
								new Insets(
										Convert.toInt(Math.round(this.myComponentLayoutInsetTop * yScale)),
										Convert.toInt(Math.round(this.myComponentLayoutInsetLeft * xScale)),
										Convert.toInt(Math.round(this.myComponentLayoutInsetBottom * yScale)),
										Convert.toInt(Math.round(this.myComponentLayoutInsetRight * xScale))
										),
								Convert.toInt(Math.round(this.myComponentLayoutIpadx * xScale)),
								Convert.toInt(Math.round(this.myComponentLayoutIpady * yScale))
						)
				);
			}
			catch (final Exception e) {}
		}

    	swingComponentFontSize = this.myComponentFontSize * scalingFactor * (Math.pow(Math.pow(xScale,powerFactor) * Math.pow(yScale,powerFactor) / (Math.pow(xScale,powerFactor) + Math.pow(yScale,powerFactor)), 1.0 / powerFactor));
    	swingComponentBorderFontSize = this.myComponentBorderFontSize * scalingFactor * (Math.pow(Math.pow(xScale,powerFactor) * Math.pow(yScale,powerFactor) / (Math.pow(xScale,powerFactor) + Math.pow(yScale,powerFactor)), 1.0 / powerFactor));
    	acopChartFrameFontSize = this.myAcopChartFrameFontSize * scalingFactor * (Math.pow(Math.pow(xScale,powerFactor) * Math.pow(yScale,powerFactor) / (Math.pow(xScale,powerFactor) + Math.pow(yScale,powerFactor)), 1.0 / powerFactor));
       	acopGaugerValueLabelFontSize = this.myAcopGaugerValueLabelFontSize * scalingFactor * (Math.pow(Math.pow(xScale,powerFactor) * Math.pow(yScale,powerFactor) / (Math.pow(xScale,powerFactor) + Math.pow(yScale,powerFactor)), 1.0 / powerFactor));
       	acopGaugerTickTextFontSize = this.myAcopGaugerTickTextFontSize * scalingFactor * (Math.pow(Math.pow(xScale,powerFactor) * Math.pow(yScale,powerFactor) / (Math.pow(xScale,powerFactor) + Math.pow(yScale,powerFactor)), 1.0 / powerFactor));

    	if (this.myComponent.getClass().getName() == "com.cosylab.gui.components.ResizableTextLabel"  || this.myComponent.getClass().getName() == "com.cosylab.gui.components.wheelswitch.ValueDigit" || this.myComponent.getClass().getName() == "com.cosylab.gui.components.wheelswitch.StaticDigit") {
	    	if (xScale >= 1.0) {
	    		wheelSwitchResizeFactorX = 1.0 / Math.pow(xScale, 1.5);
	    	}
	    	else {
	    		wheelSwitchResizeFactorX = 1.0 / Math.pow(xScale, 1.0);
	    	}
	    	wheelSwitchResizeFactorY = 1.0 / Math.pow(xScale, 1.0);
	    	this.myComponent.setPreferredSize(new Dimension(Convert.toInt(Math.round(this.myComponentPrefferedWidth * xScale * wheelSwitchResizeFactorX)), Convert.toInt(Math.round(this.myComponentPrefferedHeight * yScale * wheelSwitchResizeFactorY))));
    	}
	    else {
	    	this.myComponent.setPreferredSize(new Dimension(Convert.toInt(Math.round(this.myComponentPrefferedWidth * xScale)), Convert.toInt(Math.round(this.myComponentPrefferedHeight * yScale))));
	    }

	    this.myComponent.setLocation(Convert.toInt(Math.round(this.myComponentXLocation * xScale)), Convert.toInt(Math.round(this.myComponentYLocation * yScale)));
    	this.myComponent.setSize(new Dimension(Convert.toInt(Math.round(this.myComponentWidth * xScale)), Convert.toInt(Math.round(this.myComponentHeight * yScale))));
	    this.myComponent.setBounds(Convert.toInt(Math.round(this.myComponentBoundsX * xScale)), Convert.toInt(Math.round(this.myComponentBoundsY * yScale)), Convert.toInt(Math.round(this.myComponentBoundsWidth * xScale)), Convert.toInt(Math.round(this.myComponentBoundsHeight * yScale)));
    	this.myComponent.setMaximumSize(new Dimension(Convert.toInt(Math.round(this.myComponentMaximumWidth * xScale)), Convert.toInt(Math.round(this.myComponentMaximumHeight * yScale))));
    	this.myComponent.setMinimumSize(new Dimension(Convert.toInt(Math.round(this.myComponentMinimumWidth * xScale)), Convert.toInt(Math.round(this.myComponentMinimumHeight * yScale))));

    	try {
			((TitledBorder)((JComponent)this.myComponent).getBorder()).setTitleFont(new Font(this.myComponentBorderFontName, this.myComponentBorderFontStyle, Convert.toInt(Math.round(swingComponentBorderFontSize))));
			//((TitledBorder)((JComponent)myComponent).getBorder()).setTitleFont(myComponentBorderFont.deriveFont(myApplicationResizeManager.getScaleTransformation()));
		}
		catch (final Exception e){}

	    if (this.myComponent instanceof JLabel) {
	    	try {((JLabel)this.myComponent).setIconTextGap(Convert.toInt(Math.round(this.myComponentIconTextGap * xScale)));} catch (final Exception e) {}
	    	try {
	    		((ImageIcon)((JLabel)this.myComponent).getIcon()).getImage();
	    		}
	    	catch (final Exception e) {
		    	this.myComponent.setFont(new Font(this.myComponentFontName, this.myComponentFontStyle, Convert.toInt(Math.round(swingComponentFontSize))));
			    //myComponent.setFont(myComponentFont.deriveFont(myApplicationResizeManager.getScaleTransformation()));
	    	}
	    }
	    else {
	    	this.myComponent.setFont(new Font(this.myComponentFontName, this.myComponentFontStyle, Convert.toInt(Math.round(swingComponentFontSize))));
		    //myComponent.setFont(myComponentFont.deriveFont(myApplicationResizeManager.getScaleTransformation()));
	    }

		try {
			this.myComponent.getClass().getMethod("setFrameFont", Font.class).invoke(this.myComponent, new Font(this.myAcopChartFrameFontName,this.myAcopChartFrameFontStyle, Convert.toInt(Math.round(acopChartFrameFontSize))));
			//myComponent.getClass().getMethod("setFrameFont", Font.class).invoke(myComponent, myAcopChartFrameFont.deriveFont(myApplicationResizeManager.getScaleTransformation()));
			this.myComponent.getClass().getMethod("setFrameWidth", Integer.TYPE).invoke(this.myComponent, (Integer) Convert.toInt(Math.round(this.myAcopChartFrameWidth * xScale)));
			this.myComponent.getClass().getMethod("setFrameBottomOffset", Integer.TYPE).invoke(this.myComponent, (Integer)Convert.toInt(Math.round(this.myAcopChartFrameBottomOffset * yScale)));
			this.myComponent.getClass().getMethod("setFrameTopOffset", Integer.TYPE).invoke(this.myComponent, (Integer)Convert.toInt(Math.round(this.myAcopChartFrameTopOffset * yScale)));
			this.myComponent.getClass().getMethod("setFrameLeftOffset", Integer.TYPE).invoke(this.myComponent, (Integer)Convert.toInt(Math.round(this.myAcopChartFrameLeftOffset * xScale)));
			this.myComponent.getClass().getMethod("setFrameRightOffset", Integer.TYPE).invoke(this.myComponent, (Integer)Convert.toInt(Math.round(this.myAcopChartFrameRightOffset * xScale)));
		}
		catch(final Exception e){}

		try {
			this.myComponent.getClass().getMethod("setValueLabelFont", Font.class).invoke(this.myComponent, new Font(this.myAcopGaugerValueLabelFontName, this.myAcopGaugerValueLabelFontStyle, Convert.toInt(Math.round(acopGaugerValueLabelFontSize))));
			//myComponent.getClass().getMethod("setValueLabelFont", Font.class).invoke(myComponent, myAcopGaugerValueLabelFont.deriveFont(myApplicationResizeManager.getScaleTransformation()));
			this.myComponent.getClass().getMethod("setTickTextFont", Font.class).invoke(this.myComponent, new Font(this.myAcopGaugerTickTextFontName, this.myAcopGaugerTickTextFontStyle, Convert.toInt(Math.round(acopGaugerTickTextFontSize))));
			//myComponent.getClass().getMethod("setTickTextFont", Font.class).invoke(myComponent, myAcopGaugerTickTextFont.deriveFont(myApplicationResizeManager.getScaleTransformation()));
		}
		catch(final Exception e){}

		if ((this.myComponent instanceof JTable) && (this.myComponent.getClass().getName() != "de.desy.acop.displayers.AcopTable")) {
			headerFontSize = this.myTableHeaderFont.getSize() * scalingFactor * (Math.pow(Math.pow(xScale,powerFactor) * Math.pow(yScale,powerFactor) / (Math.pow(xScale,powerFactor) + Math.pow(yScale,powerFactor)), 1.0 / powerFactor));
	    	this.myTableHeader.setFont(new Font(this.myTableHeaderFont.getName(), this.myTableHeaderFont.getStyle(), Convert.toInt(Math.round(headerFontSize))));
			for (i = 0; i < this.myTable.getModel().getColumnCount(); i++) {
	        	this.myTableHeaderColumn[i].setPreferredWidth( Convert.toInt(Math.round((this.myTableHeaderCellPrefferedWidth[i]* xScale))));
	        	this.myTableHeaderColumn[i].setWidth( Convert.toInt(Math.round((this.myTableHeaderCellWidth[i]* xScale))));
				headerCellFontSize = this.myTableHeaderCellFont[i].getSize() * scalingFactor * (Math.pow(Math.pow(xScale,powerFactor) * Math.pow(yScale,powerFactor) / (Math.pow(xScale,powerFactor) + Math.pow(yScale,powerFactor)), 1.0 / powerFactor));
				this.myTableHeaderCellRendererComponent[i].setFont(new Font(this.myTableHeaderCellFont[i].getName(), this.myTableHeaderCellFont[i].getStyle(), Convert.toInt(Math.round(headerCellFontSize))));
			}
	    	//myTable.setRowHeight(Convert.toInt(Math.round(myTableRowHeight * yScale)));
			this.myTable.setRowMargin(Convert.toInt(Math.round(this.myTableRowMargin * yScale)));
			for (i = 0; i < this.myTable.getModel().getColumnCount(); i++) {
	        	this.myTableColumn[i].setPreferredWidth(Convert.toInt(Math.round((this.myTableDataCellPrefferedWidth[i]* xScale))));
	        	this.myTableColumn[i].setWidth(Convert.toInt(Math.round((this.myTableDataCellWidth[i]* xScale))));
	        	for (j = 0; j < this.myTable.getModel().getRowCount(); j++) {
					this.myTable.setRowHeight(j, Convert.toInt(Math.round(this.myTableRowHeight[j] * yScale)));
					dataCellFontSize = this.myTableDataCellFont[j][i].getSize() * scalingFactor * (Math.pow(Math.pow(xScale,powerFactor) * Math.pow(yScale,powerFactor) / (Math.pow(xScale,powerFactor) + Math.pow(yScale,powerFactor)), 1.0 / powerFactor));
			    	try {
			    		((ImageIcon)((JLabel)this.myTableDataCellRendererComponent[j][i]).getIcon()).getImage();
			    		}
			    	catch (final Exception e) {
			    		this.myTableDataCellRendererComponent[j][i].setFont(new Font(this.myTableDataCellFont[j][i].getName(), this.myTableDataCellFont[j][i].getStyle(),Convert.toInt(Math.round(dataCellFontSize))));
			    	}
			    	try {((JLabel)this.myTableDataCellRendererComponent[j][i]).setIconTextGap(Convert.toInt(Math.round(this.myTableDataCellIconTextGap[j][i] * xScale)));} catch (final Exception e) {}
	        	}
	        }
		}
	}

	/**
	 * Resizes  a MstApp popup menu.
	 *
	 */
	public final void resizePopupMenu () {

		double xScaleOld = 1.0;
		double yScaleOld = 1.0;
		double xScaleNew = 1.0;
		double yScaleNew = 1.0;
		double xScale = 1.0;
		double yScale = 1.0;
		double scaleFontNew = 1.0;
		double scaleFontOld = 1.0;
		double scaleFont = 1.0;
		double myPopupMenuWidth = 0;
		double myPopupMenuHeight = 0;
		int myPopupMenuFontSize = 0;
		final double powerFactor = 10.0;
		Component[] myPopupMenuComponents = null;
		Font[] myPopupMenuComponentFont = null;
		int[] myPopupMenuComponentFontSize = null;
		int myPopupMenuComponentCount = 0;
		boolean firstTime = true;

		if (firstTime == true) {
			scaleFontOld = Math.pow(0.5, 1.0 / powerFactor);
			firstTime = false;
		}
		if (this.myPopupMenu.isVisible() == true) {
	      	xScaleNew = this.myReferenceComponent.getWidth() / this.myReferenceComponentWidth;
	    	yScaleNew = this.myReferenceComponent.getHeight() / this.myReferenceComponentHeight;
	    	scaleFontNew = (Math.pow(Math.pow(xScaleNew,powerFactor) * Math.pow(yScaleNew,powerFactor) / (Math.pow(xScaleNew,powerFactor) + Math.pow(yScaleNew,powerFactor)), 1.0 / powerFactor));
	    	if (xScaleNew != xScaleOld) {
	    		xScale = xScaleNew / xScaleOld;
	    			}
	    	else {
	    		xScale = 1.0;
	    	}
	    	if (yScaleNew != yScaleOld) {
	    		yScale = yScaleNew / yScaleOld;
	    	}
	    	else {
	    		yScale = 1.0;
	    	}
	    	if ((xScaleNew == xScaleOld) ^ (yScaleNew == yScaleOld)) {
				scaleFont = 1.0;
			}
			else {
				scaleFont = scaleFontNew / scaleFontOld;
			}
	    	xScaleOld = xScaleNew;
    		yScaleOld = yScaleNew;
    		scaleFontOld = scaleFontNew;
    		myPopupMenuComponentCount = this.myPopupMenu.getComponentCount();
    		myPopupMenuComponentFont = new Font[myPopupMenuComponentCount];
    		myPopupMenuComponents = new Component[myPopupMenuComponentCount];
    		myPopupMenuComponentFontSize = new int[myPopupMenuComponentCount];
    		myPopupMenuWidth = 0;
    		myPopupMenuHeight = 0;
    		for (int i = 0; i < myPopupMenuComponentCount; i++) {
    			myPopupMenuComponents[i] = this.myPopupMenu.getComponent(i);
    			myPopupMenuComponentFont[i] = myPopupMenuComponents[i].getFont();
    			myPopupMenuComponentFontSize[i] = myPopupMenuComponentFont[i].getSize();
    			myPopupMenuWidth = myPopupMenuComponents[i].getPreferredSize().getWidth();
    			myPopupMenuHeight = myPopupMenuHeight + myPopupMenuComponents[i].getPreferredSize().getHeight();
    		}
    		myPopupMenuFontSize = myPopupMenuComponentFontSize[0];
    		for (int i = 0; i < myPopupMenuComponentCount; i++) {
     			if (myPopupMenuComponentFontSize[i] < myPopupMenuFontSize) {myPopupMenuFontSize = myPopupMenuComponentFontSize[i];}
    		}
    		for (int i = 0; i < myPopupMenuComponentCount; i++) {
    			myPopupMenuComponents[i].setFont(new Font(myPopupMenuComponents[i].getFont().getName(), myPopupMenuComponents[i].getFont().getStyle(), Convert.toInt(Math.round(myPopupMenuFontSize * scaleFont))));
    		}
			this.myPopupMenu.setPopupSize(new Dimension(Convert.toInt(Math.round(myPopupMenuWidth * xScale)), Convert.toInt(Math.round(myPopupMenuHeight * yScale) )));
		}
	}
}
