/**
 * 	Aug  6, 2009 - Aug  6, 2009	ws:	Eclipse asked for removing unnessary casts, so I did
 */
package de.desy.mst.libs.framework.mstapp.util.applicationresizemanager.resizers;

import java.awt.*;
import java.awt.geom.AffineTransform;

import javax.swing.*;

import de.desy.mst.libs.framework.mstapp.util.Convert;
import de.desy.mst.libs.framework.mstapp.util.applicationresizemanager.managers.ApplicationResizeManager;

/**
* Draws the icon associated with a label with the correct scale.
*
* @author R.Bacher
* @version 3.0.0
*
*/
public class IconResizer extends ImageIcon{
	private static final long serialVersionUID = 1L;

	private Image myIconImage = null;
	private double myIconReferenceXPos = 0;
	private double myIconReferenceYPos = 0;
	private double myIconReferenceWidth = 0;
	private double myIconReferenceHeight = 0;
	private boolean firstTime = true;
	private Component myIconReferenceComponent = null;


	/**
	 *
	 * Constructor
	 *
	 * @param referenceComponent reference component to be resized
	 */
	public IconResizer (final ApplicationResizeManager applicationResizeManager, final Component referenceComponent) {
		super();
		this.myIconReferenceComponent = referenceComponent;
		this.firstTime = true;
	}

	/**
	 *
	 * Paints the resized icon attached to a JLabel
	 *
	 */
	@Override public synchronized void paintIcon (final Component component, final Graphics graphics, final int x, final int y) {
		double myXScale = 1.0;
		double myYScale = 1.0;
		int myXPos = 0;
		int myYPos = 0;
		Graphics2D myGraphics2D = null;

		myGraphics2D = (Graphics2D)graphics;
		this.myIconImage = this.getImage();

		if (this.firstTime == true) {
			this.myIconReferenceXPos = x;
			this.myIconReferenceYPos = y;
			this.myIconReferenceWidth = this.myIconReferenceComponent.getWidth();
			this.myIconReferenceHeight = this.myIconReferenceComponent.getHeight();
			this.firstTime = false;
		}

	    myXScale = this.myIconReferenceComponent.getWidth() / this.myIconReferenceWidth ;
	 	myYScale = this.myIconReferenceComponent.getHeight() / this.myIconReferenceHeight ;
		myXPos = Convert.toInt(Math.round(this.myIconReferenceXPos * myXScale));
		myYPos = Convert.toInt(Math.round(this.myIconReferenceYPos * myYScale));
		((JLabel)component).setVerticalAlignment(javax.swing.SwingConstants.TOP);
		myGraphics2D.transform(AffineTransform.getScaleInstance(myXScale, myYScale));
		myGraphics2D.drawImage(this.myIconImage, myXPos, myYPos, component);
	} 

}
