/**
 * Oct 25, 2006 - Nov  1, 2006	ws:	created from scratch
 */
package de.desy.mst.libs.framework.mstapp.util.reflection;

import java.util.List;

/**
 * Um Spaltennamen und Werte fuer generische Tools wie den DeviceManager
 * aus Entries <T> extrahieren zu koennen und einfach auch fuer einen einfachen
 * programmatischen Zugang zur JTable.<br>
 * Implementatoren: 
 * <li>PublicFields (fuer das Entry <E> as public fields Konzept).
 * <li>$$$$$$$ (fuer das GEntry Konzept).
 * 
 * @author ws
 */
public interface ISpaltenInfo <E>{
	/**
	 * Liste von unterstuetzten SpaltenNamen
	 * @return never null
	 */
	public List<String> getSpaltenNamen();
	
	/**
	 * Liste von unterstuetzten SpaltenNamen
	 * @param id 			normalerweise tabId (Id fuer Logging)
	 * @param spaltenName 	name der Spalte bzw. eines Feldes ....
	 * @param entryIterator Liste der Objecte aus denen diese Spalte extrahiert
	 * 						werden soll
	 * @return never null, 	Liste der zu den entries korrespondierenden Spalten
	 */
	public List<Object> getSpalte(final String id
								, final String spaltenName
								, final Iterable<E> entryIterator);
	
	/**
	 * @return	true falls nur info ueber das Object null vorhanden
	 */
	public boolean isTrivial();
}
