/**
 * 
 */
package de.desy.mst.libs.pintlk.badgerviewer.config;

import java.net.InetAddress;
import java.net.UnknownHostException;

class PositiveHostAddressDetection extends ConfigDetector {
	private final String regExInclude;
	private final int flags;
	PositiveHostAddressDetection(final String regExInclude, final int flags) {
		this.regExInclude = regExInclude;
		this.flags = flags;
	}
	/* (non-Javadoc)
	 * @see de.desy.mst.libs.pintlk.badgerviewer.network.EClientConfig.DetectProxy#isIncluded()
	 */
	boolean isIncluded(){
		try {
			final java.util.regex.Pattern pattern = java.util.regex.Pattern.compile(this.regExInclude, this.flags);
			return pattern.matcher(InetAddress.getLocalHost().getHostAddress()).matches();
		} catch (UnknownHostException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			return false;
		}
	}
	
}