/*
 * Created on Dec 7, 2006
 *
 */
package de.desy.mst.libs.ser.tclientlib;

/**
 * An interface with common methods for TINE accessors.
 * 
 * @author jwlg
 */
public interface ITineAccessor {

    /**
     * Returns true if TINE access failed.
     */
    public boolean hasError();

    /**
     * Returns the status code of the last TINE access.
     */
    public int getLinkStatus();

    /**
     * Returns the error message of the last TINE access.
     */
    public String getErrorMessage();

    /**
     * Returns the address to which the underlying TINE link connects.
     */
    public TLinkAddress getLinkAddress();

    /**
     * Sets the connection mode.
     */
    public void setConnectionMode(TConnectionMode mode);

    /**
     * Returns the connection mode.
     */
    public TConnectionMode getConnectionMode();

    /**
     * Closes underlying TINE links.
     */
    public void close();
}
