/*
 * Created on Nov 11, 2009
 *
  */
package de.desy.mst.libs.ser.tclientlib.utils;

public class TineStringUtils {
    
    private static TineStringUtils theInstance = new TineStringUtils();
    
    public static TineStringUtils getInstance() { 
        return theInstance; 
    }
    
    /**
     * Removes trailing '0' from a string. TINE sometimes does not strip
     * trailing zeros when it converts a C string into a Java String. This
     * method ensures that this is done properly.
     * 
     * @param inputString
     *            Input string.
     * 
     */
    public String removeTrailingZero(String inputString) {
        String result;
        int endIndex = inputString.indexOf((char) 0);
        if (endIndex > 0) {
            result = inputString.substring(0, endIndex);
        } else {
            result = inputString;
        }
        return result;
    }

    /**
     * Removes trailing '0' from a string. TINE sometimes does not strip
     * trailing zeros when it converts a C string into a Java String. This
     * method ensures that this is done properly.
     * 
     * @param inputChars
     *            Input string as character array.
     */
    public String convertToString(char[] inputChars) {
        String result;
        int zeroIndex = -1;
        for (int i = 0; i < inputChars.length; i++) {
            if (inputChars[i] == 0) {
                zeroIndex = i;
                break;
            }
        }
        if (zeroIndex >= 0) {
            result = new String(inputChars, 0, zeroIndex);
        } else {
            result = new String(inputChars);
        }
        return result;
    }


}
